#include <stdio.h>
#include <string.h>
#include <math.h>
#include "system.h"
#include "altera_avalon_pio_regs.h"
#define CHIP_SELECTING 32768
#define SUB_CHIP_SELECTING 65536
#define SUB_DATA_SELECTING 98304
#define BIT_DATA_SELECTING 131072
#define COMMAND_WORD 163840
#define SRAM_ADDRESS 524288
#define SRAM_WRITE 393216
#define SRAM_PRE_WRITE 262144

#define  SELECTION_D  9 
#define  CLEANUP_D    20
#define  READPIXCLE_D 6
#define  READSRAM_D  7
#define  CONFIGSRAM_D  10

typedef volatile unsigned int bus32 ;
typedef volatile unsigned short bus16 ;
typedef volatile unsigned char bus8 ;
//#define test_write  (*((bus32 *)(TEST_0_BASE+0x4)))
//#define test_read  (*((bus32 *)(TEST_0_BASE+0x8)))

int cmp(char *src,char *exm){
int ls=strlen(src);
int le=strlen(exm);
int i;
int k=0;
if(ls!=le) return 0;
for(i=0;i<ls;i++){
if(src[i]!=exm[i]){
return 0;
}
}
return 1;
}

int getbit(int src,int num){
int res=src/pow(2,num);
if(res%2==1) return 1;
return 0;
}

int setbit(int * src,int num){
if(getbit( src[0], num)) return 1;
src[0]=src[0]+pow(2,num);
return 1;
}
int clrbit(int * src,int num){
if(getbit( src[0], num)==0) return 1;
src[0]=src[0]-pow(2,num);
return 1;
}

volatile int edge_capture;
static void handle_J23_interrupts(void* context, alt_u32 id)
{
  /* Cast context to edge_capture's type. It is important that this be 
   * declared volatile to avoid unwanted compiler optimization.
   */
  volatile int* edge_capture_ptr = (volatile int*) context;
  /* Store the value in the J23 edge capture register in *context. */
  // these system functions like IORD_ALTERA_AVALON_PIO_EDGE_CAP(  )
  // are defined in: altera_avalon_pio_regs.h
  *edge_capture_ptr = IORD_ALTERA_AVALON_PIO_EDGE_CAP(J23_SW_BASE);
  /* Reset the J23 edge capture register. */
  IOWR_ALTERA_AVALON_PIO_EDGE_CAP(J23_SW_BASE, 0);
    printf("interrupted by software!\n");
   printf(">>>>>");
//    altro_comdin();
}
static void init_J23_pio()
{
  /* Recast the edge_capture pointer to match the alt_irq_register() function
   * prototype. */
  void* edge_capture_ptr = (void*) &edge_capture;
  /* Enable all 3 J23 jumper assigned pins. */
  IOWR_ALTERA_AVALON_PIO_IRQ_MASK(J23_SW_BASE, 0xf);
  /* Reset the edge capture register. */
  
  IOWR_ALTERA_AVALON_PIO_EDGE_CAP(J23_SW_BASE, 0x0);
  /* Register the interrupt handler. */
  alt_irq_register( J23_SW_IRQ, edge_capture_ptr, handle_J23_interrupts ); 
}


static bus32 * const test_read = (bus32 * const) TEST_0_BASE+4 ;
static bus32 * const test_trigger = (bus32 * const) TEST_0_BASE+8 ;
static bus32 * const test_command = (bus32 * const) TEST_0_BASE+1 ;
static bus32 * const test_addr = (bus32 * const) TEST_0_BASE+2 ;
static bus32 * const test_reset = (bus32 * const) TEST_0_BASE+8;
static bus32 * const test_write = (bus32 * const) TEST_0_BASE+3;
static bus32 * const test_addr_command = (bus32 * const) TEST_0_BASE;
static bus32 * const test_state = (bus32 * const) TEST_0_BASE+5;
static bus32 * const test_comdin = (bus32 * const) TEST_0_BASE+7;
static bus32 * const test_rorc_data = (bus32 * const) TEST_0_BASE+9;
static bus32 * const test_data_control = (bus32 * const) TEST_0_BASE+10;
static bus32 * const test_data_num = (bus32 * const) TEST_0_BASE+11;

int altro_data_control(int a){
* test_data_control=a;
return a;
}
int altro_data_num(int a){
* test_data_num=a;
return a;
}

int altro_read(){
int b;
b=* test_read;
return b;
}

int altro_comdin(){
int b;
b=* test_comdin;

printf("destination is %d%d%d%d\n",getbit(b,3),getbit(b,2),getbit(b,1),getbit(b,0));
printf("command is     %d%d%d%d\n",getbit(b,7),getbit(b,6),getbit(b,5),getbit(b,4));
printf("others is %d%d%d%d%d%d%d%d%d%d%d%d%d%d%d%d%d%d%d%d%d%d%d%d\n",getbit(b,31),getbit(b,30),getbit(b,29),getbit(b,28),getbit(b,27),getbit(b,26),getbit(b,25),getbit(b,24),getbit(b,23),getbit(b,22),getbit(b,21),getbit(b,20),getbit(b,19),getbit(b,18),getbit(b,17),getbit(b,16),getbit(b,15),getbit(b,14),getbit(b,13),getbit(b,12),getbit(b,11),getbit(b,10),getbit(b,9),getbit(b,8));


return b;
}

int altro_rorc_data(){
int b;
b=* test_rorc_data;

return b;
}

int altro_state(){
int b;
b=* test_state;
printf("wrreq is %d\n",getbit(b,0));
printf("rdempty is %d\n",getbit(b,1));
printf("fifo_read_ENA is %d\n",getbit(b,2));
printf("req_reg is %d\n",getbit(b,3));
printf("readflag is %d\n",getbit(b,4));
printf("command_addr is %d\n",getbit(b,5));
printf("command is %d\n",getbit(b,6));
printf("send_addr is %d%d%d%d%d%d%d\n",getbit(b,13),getbit(b,12),getbit(b,11),getbit(b,10),getbit(b,9),getbit(b,8),getbit(b,7));
printf("re_addr is %d%d%d%d%d%d%d\n",getbit(b,20),getbit(b,19),getbit(b,18),getbit(b,17),getbit(b,16),getbit(b,15),getbit(b,14));
printf("fiLF_N is %d\n",getbit(b,21));
printf("fiBEN_N is %d\n",getbit(b,22));
printf("fiDIR is %d\n",getbit(b,23));
printf("control fifo is %d\n",getbit(b,24));
return b;
}
void altro_write(int a){
* test_read=a;
}
void altro_trigger(){
* test_trigger=2;
}
void altro_addr_command(int a){
* test_addr_command=a;

}
void altro_command(int a){
* test_command=a;

}
void altro_address(int a){
* test_addr=a;

}

void altro_reset(){
* test_reset=1;

}
void altro_getstatus(){
  int j1;
altro_command(1);
altro_addr_command(1); 
altro_address(40);
 j1=altro_read();
 
 printf("SYNC is %d\n",getbit(j1,0));
 printf("CkRdC is %d\n",getbit(j1,1));
 printf("mem_test_fail is %d\n",getbit(j1,2));
 printf("full_frame_done is %d\n",getbit(j1,3));
 printf("full_frame_wr is %d\n",getbit(j1,4));
 printf("mem_test_done is %d\n",getbit(j1,5));
 printf("mem_test_busy is %d\n",getbit(j1,6));
 printf("daq_error is %d\n",getbit(j1,7));
 printf("full_frame_busy is %d\n",getbit(j1,8));
 printf("clr_mem_busy is %d\n",getbit(j1,9));
 printf("got_nios_io is %d\n",getbit(j1,10));
 printf("cds_daq_busy is %d\n",getbit(j1,11));
 printf("daq_busy is %d\n",getbit(j1,12));
 printf("resync_status is %d\n",getbit(j1,13));
 printf("idle is %d\n",getbit(j1,14));
 printf("dcm_adc_locked is %d\n",getbit(j1,15));
}
int altro_setsrammode(){
altro_command(1);
altro_addr_command(1);
altro_address(52);
altro_write(11);
altro_address(51);
altro_write(6);
int i;
int j1;
for(i=0;i<1000;i++){
  altro_address(40);
  j1=altro_read();
  if(getbit(j1,10)==1){

   printf("state is sram mode\n");
  return 0;
  }
 if(getbit(j1,7)==1){
      altro_address(51);
    altro_write(9);
    altro_address(52);
    altro_write(9);
   printf("daq error \n");
  return 1;
  }
  

}

printf("sram mode setting fails\n");
  return 1;
}


void altro_clrsrammode(){
altro_command(1);
altro_addr_command(1);
altro_address(52);
altro_write(6);
altro_write(11);
}

void altro_setdodaq(){
altro_command(1);
altro_addr_command(1);
altro_address(51);
altro_write(4);
}

void altro_adc(int a){
altro_command(1);
altro_addr_command(1);
altro_address(60);
altro_write(a);
}
void altro_ack(){
altro_command(1);
altro_addr_command(1);
altro_address(51);
altro_write(9);
altro_address(52);
altro_write(9);
}

void altro_clrdodaq(){
altro_command(1);
altro_addr_command(1);
altro_address(52);
altro_write(4);
}

int altro_readsram(int addr,int pos){
if(pos>4) return 0;
altro_address(54);
altro_write(addr);

altro_address(41+pos);
altro_read();
altro_read();
altro_read();
altro_read();
altro_read();
return altro_read();
}


void altro_writesram(int addr,int* data){

altro_address(54);
altro_write(addr);
altro_address(55);
altro_write(data[0]);
altro_address(56);
altro_write(data[1]);
altro_address(57);
altro_write(data[2]);
altro_address(58);
altro_write(data[3]);
altro_address(59);
altro_write(data[4]);
altro_address(51);
altro_write(11);
altro_address(52);
altro_write(11);
}
void altro_sync(){
altro_command(1);
altro_addr_command(1);

altro_address(51);
altro_write(3);
altro_address(52);
altro_write(3);
}
int main()
{
  
  init_J23_pio();
  /*
  int i=0;
  int j=0;
  for(;;){
     i++;
     printf("%d ",i);
     
    for( j=0;j<100;j++){
    j=j;
    };
  }
*/
bus32 a;
  printf("Hello from Nios II!\n");
  int j=0;
  int i,j1,j2,jj[20];
  int data[5];
    int rmsbuf[512*300];
  float rms[512];
  float rmsaverage[512];
  char sc[3];
int k;

  for(;;){

//printf(" t :trigger\n w :write \n r :read\n c :command\n d :addr_command\n b : ram address \n e : ram read \n a :address\n ");
    printf(">>>>>");
scanf("%s",&sc);

      if(cmp(sc,"sync"))
    {
      
       //      printf("which trigger \n");
       // scanf("%d",&j1);
     altro_sync(); 
  //   altro_trigger(); 
      //if(j1==1) * test_trigger1;      
      //if(j1==2) * test_trigger2;      
    printf("a sync is sent\n");
    
    
    }
else if(cmp(sc,"clrmem"))
    {
      altro_clrsrammode();
      altro_clrdodaq();
      
altro_command(1);
altro_addr_command(1);
altro_address(51);
altro_write(7); 
for(i=0;i<200000;i++){
i=i;
}
altro_address(52);
altro_write(7); 
    
    printf("sram is cleared\n");
    
    
    }
else if(cmp(sc,"rms"))
      {
scanf("%d",&data[0]);

scanf("%d",&data[1]);
altro_command(1);
altro_addr_command(1);
for(i=0;i<100;i++){
altro_setdodaq();
for(j=0;j<128*1000;j++){
j=j;
}
altro_clrdodaq();
do{;}while(altro_setsrammode()==1);
for(j1=0;j1<512;j1++){
// printf("data is %d\n", altro_readsram(data[0]*512+j1,1));
 rmsbuf[512*i+j1]=altro_readsram(data[0]*512+j1,data[1]);
 }
altro_clrsrammode();
}



for(i=0;i<512;i++){
 for(j=0;j<1000;j++){
j=j;
} 
    printf("real %d data is %d\n",i, rmsbuf[512*0+i]);
rmsaverage[i]=0;
rms[i]=0;
}

for(i=0;i<512;i++){
 
  for(j=0;j<100;j++){
//    if(i==2) printf("real %d data is %d\n",j, rmsbuf[512*j+i]);
  rmsaverage[i]=rmsaverage[i]+rmsbuf[512*j+i];
  }
}

for(i=0;i<512;i++){
rmsaverage[i]=rmsaverage[i]/100;
  for(j=0;j<1000;j++){
  j=j;
  }
printf("data is %f\n", rmsaverage[i]);
}


for(i=0;i<512;i++){
  printf("calculation  is %d\r", i);
  for(j=0;j<100;j++){
  rms[i]=rms[i]+(rmsbuf[512*j+i]-rmsaverage[i])*(rmsbuf[512*j+i]-rmsaverage[i]);
  }

}

for(i=0;i<512;i++){
rms[i]=rms[i]/100;
rms[i]=sqrt(rms[i]);
printf(" Point %d  RMS  is %f\n",512*data[0]+i, rms[i]);
}
     
     

 } else  if(cmp(sc,"adc"))
    {
 printf("input adc channel\n");
scanf("%d",&j1);
 altro_adc(j1);   
 
    }else  if(cmp(sc,"resetsram"))
    {
 printf("sram is resetting...   ");
altro_command(1);
altro_addr_command(1);

for(j=0;j<1;j++){
altro_address(51);
altro_write(0);
for(i=0;i<100;i++){
i=i;
}
altro_address(52);
altro_write(0);

for(i=0;i<100;i++){
i=i;
}
}
printf("sram is reseted\n");
 
    }else  if(cmp(sc,"resetdcm"))
    {
 printf("DCM is reseted\n");
 altro_command(1);
altro_addr_command(1);
altro_address(51);
altro_write(1);
altro_address(52);
altro_write(1);
 
    }else  if(cmp(sc,"resetmm"))
    {
 
 altro_command(1);

altro_addr_command(1);
altro_address(51);
// altro_write(0);
altro_write(10);

for(i=0;i<84480;i++){
i=i;
}
altro_address(52);
//altro_write(0);
altro_write(10);
 printf("mimostar2 is reseted\n");
 
    } else  if(cmp(sc,"rhic"))
    {
 printf("rhic clock is set\n");
 altro_command(3);
altro_addr_command(1);
altro_address(51);
altro_write(1);
altro_address(52);
altro_write(1);
 
    } else  if(cmp(sc,"local"))
    {
 printf("local clock is set\n");
 altro_command(1);
altro_addr_command(1);
altro_address(51);
altro_write(1);
altro_address(52);
altro_write(1);
 
    } else  if(cmp(sc,"t"))
    {
      
       //      printf("which trigger \n");
       // scanf("%d",&j1);
     altro_trigger(); 

  //   altro_trigger(); 
      //if(j1==1) * test_trigger1;      
      //if(j1==2) * test_trigger2;      
    printf("a trigger is sent\n");
    
    
    } else  if(cmp(sc,"ttt"))
    {
      
             printf("how many triggers? \n");
        scanf("%d",&j1);
             printf("how many clocks delay? \n");
        scanf("%d",&j2);        
       for(i=0;i<j1;i++){
     altro_trigger(); 
       for( j=0;j<j2;j++){
    j=j;
    };
       };
  //   altro_trigger(); 
      //if(j1==1) * test_trigger1;      
      //if(j1==2) * test_trigger2;      
    printf("%d triggers are sent\n",j1);
    
    
    }else  if(cmp(sc,"tt"))
    {
      
             printf("how many triggers?  5\n");
       j1=2;
             printf("how many clocks delay?  1\n");
        j2=11111;       
       for(i=0;i<j1;i++){
     altro_trigger(); 
       for( j=0;j<j2;j++){
    j=j;
    };
       };
  //   altro_trigger(); 
      //if(j1==1) * test_trigger1;      
      //if(j1==2) * test_trigger2;      
    printf("%d triggers are sent\n",j1);
    
    
    }
else if(cmp(sc,"jtag"))
    {
      
altro_reset();
altro_command(1);    
    printf("This is jtag mode\n");
    
    
    }
else if(cmp(sc,"ack"))
    {
      

altro_ack();    

    printf("I acknowledge the error\n");
    
    }
else if(cmp(sc,"fullframe"))
    {
      altro_setdodaq();
      altro_address(61);
      altro_write(1);
    altro_reset();
     altro_command(4);
     altro_addr_command(1);
     altro_address(49);
     altro_data_control(1);
     altro_data_num(100000);
     altro_data_control(2);
     altro_data_num(20); 
    printf("This is full frame mode\n");
    
    
    }
else if(cmp(sc,"normal"))
    {
      altro_setdodaq();
      altro_address(61);
      altro_write(0);
    altro_reset();
     altro_command(0);
     altro_addr_command(0);
     altro_data_control(2);
     altro_data_num(20); 
    printf("This is full normal mode\n");
    
    
    }
else      if(cmp(sc,"full"))
    {
      
 printf("input event length\n");
scanf("%d",&j1);
 printf("input event number\n");
scanf("%d",&j2);
altro_reset();
     altro_command(4);
     altro_addr_command(1);
     altro_address(49);
     altro_data_control(1);
     altro_data_num(j1);
     altro_data_control(2);
     altro_data_num(j2);
        
      
      
    printf("full frame mode is entered\n");
    
    
    }
else  if(cmp(sc,"w"))
      {
//altro_command(1);
//altro_addr_command(1);
//altro_address(61);
 printf("input data to be wrote\n");
scanf("%d",&j1);
//j1=6;
altro_write(j1);

     

 }else  if(cmp(sc,"c"))
      {

 printf("input command\n");
scanf("%d",&j1);
altro_command(j1);

     

 }else  if(cmp(sc,"d"))
      {

 printf("input addr command\n");
scanf("%d",&j1);
altro_addr_command(j1);

     

 }else  if(cmp(sc,"getbit"))
      {
        
altro_setdodaq();


 }else  if(cmp(sc,"readbit"))
      {
  printf("input address\n");       
scanf("%d",&jj[0]);
 printf("input channel\n"); 
scanf("%d",&jj[1]);
 printf("input number\n"); 
scanf("%d",&jj[2]);
altro_clrdodaq();
altro_setsrammode();
for(i=0;i<jj[2];i++)
 printf("data in address %d  is %d\n", jj[0]+i, altro_readsram(jj[0]+i,jj[1]));
altro_clrsrammode();


 }else  if(cmp(sc,"writebit"))
      {
  printf("input address\n");       
scanf("%d",&jj[0]);
 printf("input channel 0\n"); 
scanf("%d",&data[0]);
 printf("input channel 1\n"); 
scanf("%d",&data[1]);
 printf("input channel 2\n"); 
scanf("%d",&data[2]);
 printf("input channel 3\n"); 
scanf("%d",&data[3]);
 printf("input channel 4\n"); 
scanf("%d",&data[4]);
altro_clrdodaq();
altro_setsrammode();
 printf("writing  in address %d  \n", jj[0]);
 altro_writesram(jj[0],data);
altro_clrsrammode();


 }else  if(cmp(sc,"q"))
      {


j1=altro_state();
 printf("state is %d\n",j1);
     

 }else  if(cmp(sc,"qq"))
      {


j1=altro_comdin();
 printf("state is %d\n",j1);
     

 }else  if(cmp(sc,"a"))
      {

 printf("input address\n");
scanf("%d",&j1);
altro_address(j1);

     

 } else  if(cmp(sc,"r")){
//altro_command(1);
//altro_addr_command(1);
//altro_address(60);
 printf("input number\n");
scanf("%d",&jj[0]);
//jj[0]=1111;
 printf("input show or not\n");
scanf("%d",&jj[1]);
//jj[1]=0;
j1=0;
do{
  j1++;
j2=altro_read();
j=0;
  for( j=0;j<8000;j++){
    j=j;
    };
    if(jj[1]==0){
if(j2!=43690&&j2!=21845&&j2!=1048575&&j2!=0)  printf("--%d==%d \n ",j2,j1);}
//if(j2==6)  {  if(j1-jj[2]!=16)printf("--%d==%d--------------------%d \n ",j2,j1,j1-jj[2]);
//jj[2]=j1;
//}
//else
//printf("--%d==%d \n ",j2,j1);
//;
//}
else
{
  printf("--%d==%d \n ",j2,j1);
  }
if(j1==jj[0]) break;
//if(j2==786527) break;
}while(1);

//        for( k=0;k<20;k++){
//j2=altro_read();;
//printf("read %d from fifo, number is %d\n",j2,k);
//}

} else  if(cmp(sc,"rr")){
//altro_command(1);
//altro_addr_command(1);
//altro_address(60);
 printf("input number\n");
scanf("%d",&jj[0]);
//jj[0]=1111;
 printf("input show or not\n");
scanf("%d",&jj[1]);
//jj[1]=0;
j1=0;
do{
  j1++;
j2=altro_read();
j=0;
  for( j=0;j<8000;j++){
    j=j;
    };
    if(jj[1]==0){
if(j2==-1431655766) 
{
  printf("--%d==%d \n ",j2,j1);
if(jj[2]<15&&jj[2]>0) printf("------error----------%d==%d \n ",j2,j1);

jj[2]=0;
 
}else{
jj[2]++;

}
 
 }
//if(j2==6)  {  if(j1-jj[2]!=16)printf("--%d==%d--------------------%d \n ",j2,j1,j1-jj[2]);
//jj[2]=j1;
//}
//else
//printf("--%d==%d \n ",j2,j1);
//;
//}
else
{
  printf("--%d==%d \n ",j2,j1);
  }
if(j1==jj[0]) break;
//if(j2==786527) break;
}while(1);

//        for( k=0;k<20;k++){
//j2=altro_read();;
//printf("read %d from fifo, number is %d\n",j2,k);
//}

}

else  if(cmp(sc,"rrr")){
//altro_command(1);
//altro_addr_command(1);
//altro_address(60);
 printf("input number\n");
scanf("%d",&jj[0]);
//jj[0]=1111;
 printf("input show or not\n");
scanf("%d",&jj[1]);
//jj[1]=0;
j1=0;
jj[2]=0;
do{
  j1++;
j2=altro_read();
j=0;
  for( j=0;j<8000;j++){
    j=j;
    };
    if(jj[1]==0){
if(j2==-1431655766) 
{
//  printf("--%d==%d \n ",j2,j1);
//if(jj[2]<15&&jj[2]>0) printf("------error----------%d==%d \n ",j2,j1);

jj[2]=1;
jj[3]=12345; 
}else{
  if(jj[2]==1&&jj[3]==12345) {
  jj[3]=j2;
  }else{
  if(jj[3]==j2)printf("------error----------%d==%d \n ",j2,j1);
  }
  


}
 
 }
//if(j2==6)  {  if(j1-jj[2]!=16)printf("--%d==%d--------------------%d \n ",j2,j1,j1-jj[2]);
//jj[2]=j1;
//}
//else
//printf("--%d==%d \n ",j2,j1);
//;
//}
else
{
  printf("--%d==%d \n ",j2,j1);
  }
if(j1==jj[0]) break;
//if(j2==786527) break;
}while(1);

//        for( k=0;k<20;k++){
//j2=altro_read();;
//printf("read %d from fifo, number is %d\n",j2,k);
//}

}

else  if(cmp(sc,"m")){         printf("system is reseted \n");
altro_reset();
}
else  if(cmp(sc,"rorc")){         printf("get data from fifo \n");
printf("rorc data is %d\n",altro_rorc_data());
}else{
printf(" t :trigger\n w :write \n r :read\n c :command\n d :addr_command\n b : ram address \n e : ram read \n a :address\n ");

}

;

  
  
  }
//  printf("Hello Worl d!\n");


return 1;
}

    
