--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:    09:41:49 04/14/06
-- Design Name:    
-- Module Name:    study - Behavioral
-- Project Name:   
-- Target Device:  
-- Tool versions:  
-- Description:
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
--------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNIstudy;
--use UNIstudy.VComponents.all;

entity study is
generic (
	addrsize 	: integer  :=9 ;
	datasize 	: integer  :=20;
	window_length 	: integer  :=10;
	cycle_clk	:	integer :=20 );
port (
--	reset_n 		: in std_logic;
	pix_clk 		: in std_logic;
	trg_word		: in std_logic;
--	chip_id		: in std_logic_vector(11 downto 0);
	data_in		: in std_logic_vector(17 downto 0);
--do_aborts		: in std_logic;
	start			: in std_logic;
--	got_cluster		: in std_logic;
	idle_flag		: out std_logic;	 
	data_out				: out std_logic_vector(19 downto 0);
--q				: out std_logic;
--	q1				: out STD_LOGIC_vector(31 downto 0);
--	q2				: out STD_LOGIC_vector(31 downto 0);
--	q3				: out STD_LOGIC_vector(31 downto 0);
--	q4				: out STD_LOGIC_vector(31 downto 0);
--	read_ready	: out std_logic;
	rdreq			: in std_logic;

----new 
	read_clk 		: in std_logic


		);
end entity study;

ARCHITECTURE a of study is



component myfifo
	PORT
	(
		data		: IN STD_LOGIC_VECTOR (19 DOWNTO 0);
		wrreq		: IN STD_LOGIC ;
		rdreq		: IN STD_LOGIC ;
		rdclk		: IN STD_LOGIC ;
		wrclk		: IN STD_LOGIC ;
		aclr		: IN STD_LOGIC  := '0';
		q			: OUT STD_LOGIC_VECTOR (19 DOWNTO 0);
		rdempty		: OUT STD_LOGIC ;
		wrfull		: OUT STD_LOGIC 
	);
end component;


type stype is (WAIT_TRG, WAIT_WINDOW,WRITTING,WAIT_READ);
type rtype is (IDLE,READING);
signal state: stype:=WAIT_TRG;




--signal write_distribute : STD_LOGIC_vector(4 downto 0):="00000";
signal write_distribute : STD_LOGIC_vector(0 downto 0):="0";
--signal get_distribute 	: STD_LOGIC_vector(4 downto 0):="00000";
signal get_distribute 	: STD_LOGIC_vector(0 downto 0):="0";



signal write_data 			: STD_LOGIC_vector(datasize-1 downto 0);
signal read_data 			: STD_LOGIC_vector(datasize-1 downto 0);
signal write_req : STD_LOGIC:='0';
signal read_req : STD_LOGIC:='0';
signal write_pre : STD_LOGIC:='0';

signal w_write_over : STD_LOGIC:='0';
signal r_write_over : STD_LOGIC:='0';
signal write_over : STD_LOGIC:='0';


signal window_counter : integer:=0;
signal write_counter : integer:=0;
signal written_counter : integer:=0;
signal read_counter : integer:=0;
signal sum_counter : integer:=0;

signal f3 : STD_LOGIC:='0';
signal f4 : STD_LOGIC:='0';





begin
read_req<=rdreq and write_over;

write_over<= w_write_over xor r_write_over;
--f1<=f2 xor f3;
 sum_counter<=	written_counter-read_counter;

--  get_distribute<= write_distribute+1 when write_distribute(0)='0' else
--						 write_distribute+2 when write_distribute(1)='0' else
--						 write_distribute+4 when write_distribute(2)='0' else
--						 write_distribute+8 when write_distribute(3)='0' else
--						 write_distribute+16 when write_distribute(4)='0' else
--						 write_distribute;

get_distribute<= write_distribute+1 when write_distribute(0)='0' else
					 write_distribute;
write_data<="00000000000000011111"  when	window_counter=1 else
				"00" & data_in;
data_out<=read_data  when 	write_over='1' and rdreq='1' else
				"ZZZZZZZZZZZZZZZZZZZZ";
write_pre<='1' when 	window_counter>0 and window_counter<=1 else
             write_req and start;

idle_flag<= '1' when state=WAIT_TRG else
			'0';





process(pix_clk)
begin


if pix_clk='1' and pix_clk'event  then

if  trg_word='1' then
  write_distribute<=get_distribute;

end if;

if state=WAIT_READ and sum_counter=0 and trg_word='0' then
write_distribute(0)<='0';
end if;


case state is
    when WAIT_TRG	 =>
--		reset <='1';
		if write_distribute(0)='1' then
--		reset <='0';
		 window_counter<=0;
		 write_req<='0';
		 state<= WAIT_WINDOW;
		 end if;
    when WAIT_WINDOW	 =>


 		if window_counter=window_length-2 then
		write_counter<=0;
		 write_req<='1' ;
		written_counter<=written_counter+1;
		 state<= WRITTING;
		 else
		 window_counter<=window_counter+1; 
		 end if;	
	 when WRITTING	 =>


		 	if write_counter=cycle_clk then
			write_req<='0';
		 w_write_over<=not w_write_over;
		 state<= WAIT_READ;
		 else 
		 if start='1' then
	 	 written_counter<=written_counter+1;
	 	 write_counter<=write_counter+1;	
		end if;
--	 	 write_counter<=write_counter+1;	
		
			end if;
    when WAIT_READ =>
	 if sum_counter=0 and write_distribute(0)='0'  then
		 state<= WAIT_TRG;
		 end if;
end case;

end if;


end process;


process(read_clk)
begin 

if  read_clk='1'and read_clk'event then

		 	if sum_counter=0 and write_over='1' then
		r_write_over<=not r_write_over;

		 	elsif  write_over='1'and rdreq='1' then
	 	 read_counter<=read_counter+1;
		end if;



end if;



end process;



myfifo_i: myfifo
	PORT map
	(
		data		=>write_data,
		wrreq		=>write_pre,
		rdreq		=>read_req,
		rdclk		=>read_clk,
		wrclk		=>pix_clk,
		aclr		=>'0',
		q			=>read_data,
		rdempty		=>f3,
		wrfull		=>f4
	);




--q<=write_over;
--q1<=CONV_STD_LOGIC_VECTOR(write_counter,32);
--q2<=CONV_STD_LOGIC_VECTOR(sum_counter,32);
--q3<=CONV_STD_LOGIC_VECTOR(written_counter,32);
--q4<=CONV_STD_LOGIC_VECTOR(sum_counter,32);
end architecture;
