--megafunction wizard: %Altera SOPC Builder%
--GENERATION: STANDARD
--VERSION: WM1.0


--Legal Notice: (C)2005 Altera Corporation. All rights reserved.  Your
--use of Altera Corporation's design tools, logic functions and other
--software and tools, and its AMPP partner logic functions, and any
--output files any of the foregoing (including device programming or
--simulation files), and any associated documentation or information are
--expressly subject to the terms and conditions of the Altera Program
--License Subscription Agreement or other applicable license agreement,
--including, without limitation, that your use is for the sole purpose
--of programming logic devices manufactured by Altera and sold by Altera
--or its authorized distributors.  Please refer to the applicable
--agreement for further details.

library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity J23_SW_s1_arbitrator is 
        port (
              -- inputs:
                 signal J23_SW_s1_irq : IN STD_LOGIC;
                 signal J23_SW_s1_readdata : IN STD_LOGIC;
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_waitrequest : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal J23_SW_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal J23_SW_s1_chipselect : OUT STD_LOGIC;
                 signal J23_SW_s1_irq_from_sa : OUT STD_LOGIC;
                 signal J23_SW_s1_readdata_from_sa : OUT STD_LOGIC;
                 signal J23_SW_s1_reset_n : OUT STD_LOGIC;
                 signal J23_SW_s1_write_n : OUT STD_LOGIC;
                 signal J23_SW_s1_writedata : OUT STD_LOGIC;
                 signal cpu_data_master_granted_J23_SW_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_J23_SW_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_J23_SW_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_J23_SW_s1 : OUT STD_LOGIC;
                 signal d1_J23_SW_s1_end_xfer : OUT STD_LOGIC
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of J23_SW_s1_arbitrator : entity is FALSE;
end entity J23_SW_s1_arbitrator;


architecture europa of J23_SW_s1_arbitrator is
                signal J23_SW_s1_allgrants :  STD_LOGIC;
                signal J23_SW_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal J23_SW_s1_any_continuerequest :  STD_LOGIC;
                signal J23_SW_s1_arb_counter_enable :  STD_LOGIC;
                signal J23_SW_s1_arb_share_counter :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal J23_SW_s1_arb_share_counter_next_value :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal J23_SW_s1_arb_share_set_values :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal J23_SW_s1_arbitration_holdoff_internal :  STD_LOGIC;
                signal J23_SW_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal J23_SW_s1_begins_xfer :  STD_LOGIC;
                signal J23_SW_s1_end_xfer :  STD_LOGIC;
                signal J23_SW_s1_firsttransfer :  STD_LOGIC;
                signal J23_SW_s1_grant_vector :  STD_LOGIC;
                signal J23_SW_s1_in_a_read_cycle :  STD_LOGIC;
                signal J23_SW_s1_in_a_write_cycle :  STD_LOGIC;
                signal J23_SW_s1_master_qreq_vector :  STD_LOGIC;
                signal J23_SW_s1_slavearbiterlockenable :  STD_LOGIC;
                signal J23_SW_s1_waits_for_read :  STD_LOGIC;
                signal J23_SW_s1_waits_for_write :  STD_LOGIC;
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_J23_SW_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_J23_SW_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_J23_SW_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_J23_SW_s1 :  STD_LOGIC;
                signal wait_for_J23_SW_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT J23_SW_s1_end_xfer;
      end if;
    end if;

  end process;

  J23_SW_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_J23_SW_s1);
  internal_cpu_data_master_requests_J23_SW_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(23 DOWNTO 4) & std_logic_vector'("0000")) = std_logic_vector'("000000100000000100000000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --assign J23_SW_s1_readdata_from_sa = J23_SW_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  J23_SW_s1_readdata_from_sa <= J23_SW_s1_readdata;
  --J23_SW_s1_arb_share_counter set values, which is an e_mux
  J23_SW_s1_arb_share_set_values <= std_logic_vector'("01");
  --J23_SW_s1_arb_share_counter_next_value assignment, which is an e_assign
  J23_SW_s1_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(J23_SW_s1_firsttransfer) = '1'), (((std_logic_vector'("0000000000000000000000000000000") & (J23_SW_s1_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(J23_SW_s1_arb_share_counter)) = '1'), (((std_logic_vector'("0000000000000000000000000000000") & (J23_SW_s1_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 2);
  --J23_SW_s1_allgrants all slave grants, which is an e_mux
  J23_SW_s1_allgrants <= J23_SW_s1_grant_vector;
  --J23_SW_s1_end_xfer assignment, which is an e_assign
  J23_SW_s1_end_xfer <= NOT ((J23_SW_s1_waits_for_read OR J23_SW_s1_waits_for_write));
  --J23_SW_s1_arb_share_counter arbitration counter enable, which is an e_assign
  J23_SW_s1_arb_counter_enable <= J23_SW_s1_end_xfer AND J23_SW_s1_allgrants;
  --J23_SW_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      J23_SW_s1_arb_share_counter <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if std_logic'(J23_SW_s1_arb_counter_enable) = '1' then 
        J23_SW_s1_arb_share_counter <= J23_SW_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --J23_SW_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      J23_SW_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((J23_SW_s1_master_qreq_vector AND J23_SW_s1_end_xfer)) = '1' then 
        J23_SW_s1_slavearbiterlockenable <= or_reduce(J23_SW_s1_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master J23_SW/s1 arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= J23_SW_s1_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --J23_SW_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  J23_SW_s1_any_continuerequest <= std_logic'('0');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('0');
  internal_cpu_data_master_qualified_request_J23_SW_s1 <= internal_cpu_data_master_requests_J23_SW_s1 AND NOT (((NOT cpu_data_master_waitrequest) AND cpu_data_master_write));
  --J23_SW_s1_writedata mux, which is an e_mux
  J23_SW_s1_writedata <= cpu_data_master_writedata(0);
  --master is always granted when requested
  internal_cpu_data_master_granted_J23_SW_s1 <= internal_cpu_data_master_qualified_request_J23_SW_s1;
  --cpu/data_master saved-grant J23_SW/s1, which is an e_assign
  cpu_data_master_saved_grant_J23_SW_s1 <= internal_cpu_data_master_requests_J23_SW_s1;
  --allow new arb cycle for J23_SW/s1, which is an e_assign
  J23_SW_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  J23_SW_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  J23_SW_s1_master_qreq_vector <= std_logic'('1');
  --J23_SW_s1_reset_n assignment, which is an e_assign
  J23_SW_s1_reset_n <= reset_n;
  J23_SW_s1_chipselect <= internal_cpu_data_master_granted_J23_SW_s1;
  --J23_SW_s1_firsttransfer first transaction, which is an e_assign
  J23_SW_s1_firsttransfer <= NOT ((J23_SW_s1_slavearbiterlockenable AND J23_SW_s1_any_continuerequest));
  --J23_SW_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  J23_SW_s1_beginbursttransfer_internal <= J23_SW_s1_begins_xfer AND J23_SW_s1_firsttransfer;
  --J23_SW_s1_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  J23_SW_s1_arbitration_holdoff_internal <= J23_SW_s1_begins_xfer AND J23_SW_s1_firsttransfer;
  --~J23_SW_s1_write_n assignment, which is an e_mux
  J23_SW_s1_write_n <= NOT ((internal_cpu_data_master_granted_J23_SW_s1 AND cpu_data_master_write));
  --J23_SW_s1_address mux, which is an e_mux
  J23_SW_s1_address <= A_EXT (A_SRL(cpu_data_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010")), 2);
  --d1_J23_SW_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_J23_SW_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_J23_SW_s1_end_xfer <= J23_SW_s1_end_xfer;
      end if;
    end if;

  end process;

  --J23_SW_s1_waits_for_read in a cycle, which is an e_mux
  J23_SW_s1_waits_for_read <= J23_SW_s1_in_a_read_cycle AND J23_SW_s1_begins_xfer;
  --J23_SW_s1_in_a_read_cycle assignment, which is an e_assign
  J23_SW_s1_in_a_read_cycle <= internal_cpu_data_master_granted_J23_SW_s1 AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= J23_SW_s1_in_a_read_cycle;
  --J23_SW_s1_waits_for_write in a cycle, which is an e_mux
  J23_SW_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(J23_SW_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --J23_SW_s1_in_a_write_cycle assignment, which is an e_assign
  J23_SW_s1_in_a_write_cycle <= internal_cpu_data_master_granted_J23_SW_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= J23_SW_s1_in_a_write_cycle;
  wait_for_J23_SW_s1_counter <= std_logic'('0');
  --assign J23_SW_s1_irq_from_sa = J23_SW_s1_irq so that symbol knows where to group signals which may go to master only, which is an e_assign
  J23_SW_s1_irq_from_sa <= J23_SW_s1_irq;
  --vhdl renameroo for output signals
  cpu_data_master_granted_J23_SW_s1 <= internal_cpu_data_master_granted_J23_SW_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_J23_SW_s1 <= internal_cpu_data_master_qualified_request_J23_SW_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_J23_SW_s1 <= internal_cpu_data_master_requests_J23_SW_s1;

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library std;
use std.textio.all;

entity cpu_jtag_debug_module_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_data_master_debugaccess : IN STD_LOGIC;
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_instruction_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_instruction_master_read : IN STD_LOGIC;
                 signal cpu_jtag_debug_module_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_jtag_debug_module_resetrequest : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal cpu_data_master_granted_cpu_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_cpu_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_cpu_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_data_master_requests_cpu_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_instruction_master_granted_cpu_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_cpu_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_cpu_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_instruction_master_requests_cpu_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_jtag_debug_module_address : OUT STD_LOGIC_VECTOR (8 DOWNTO 0);
                 signal cpu_jtag_debug_module_begintransfer : OUT STD_LOGIC;
                 signal cpu_jtag_debug_module_byteenable : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_jtag_debug_module_chipselect : OUT STD_LOGIC;
                 signal cpu_jtag_debug_module_debugaccess : OUT STD_LOGIC;
                 signal cpu_jtag_debug_module_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_jtag_debug_module_reset : OUT STD_LOGIC;
                 signal cpu_jtag_debug_module_reset_n : OUT STD_LOGIC;
                 signal cpu_jtag_debug_module_resetrequest_from_sa : OUT STD_LOGIC;
                 signal cpu_jtag_debug_module_write : OUT STD_LOGIC;
                 signal cpu_jtag_debug_module_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal d1_cpu_jtag_debug_module_end_xfer : OUT STD_LOGIC
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of cpu_jtag_debug_module_arbitrator : entity is FALSE;
end entity cpu_jtag_debug_module_arbitrator;


architecture europa of cpu_jtag_debug_module_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_instruction_master_arbiterlock :  STD_LOGIC;
                signal cpu_instruction_master_continuerequest :  STD_LOGIC;
                signal cpu_instruction_master_saved_grant_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_jtag_debug_module_allgrants :  STD_LOGIC;
                signal cpu_jtag_debug_module_allow_new_arb_cycle :  STD_LOGIC;
                signal cpu_jtag_debug_module_any_continuerequest :  STD_LOGIC;
                signal cpu_jtag_debug_module_arb_addend :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_jtag_debug_module_arb_counter_enable :  STD_LOGIC;
                signal cpu_jtag_debug_module_arb_share_counter :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_jtag_debug_module_arb_share_counter_next_value :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_jtag_debug_module_arb_share_set_values :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_jtag_debug_module_arb_winner :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_jtag_debug_module_arbitration_holdoff_internal :  STD_LOGIC;
                signal cpu_jtag_debug_module_beginbursttransfer_internal :  STD_LOGIC;
                signal cpu_jtag_debug_module_begins_xfer :  STD_LOGIC;
                signal cpu_jtag_debug_module_chosen_master_double_vector :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal cpu_jtag_debug_module_chosen_master_rot_left :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_jtag_debug_module_end_xfer :  STD_LOGIC;
                signal cpu_jtag_debug_module_firsttransfer :  STD_LOGIC;
                signal cpu_jtag_debug_module_grant_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_jtag_debug_module_in_a_read_cycle :  STD_LOGIC;
                signal cpu_jtag_debug_module_in_a_write_cycle :  STD_LOGIC;
                signal cpu_jtag_debug_module_master_qreq_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_jtag_debug_module_saved_chosen_master_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_jtag_debug_module_slavearbiterlockenable :  STD_LOGIC;
                signal cpu_jtag_debug_module_waits_for_read :  STD_LOGIC;
                signal cpu_jtag_debug_module_waits_for_write :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_cpu_jtag_debug_module :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_cpu_jtag_debug_module :  STD_LOGIC;
                signal internal_cpu_data_master_requests_cpu_jtag_debug_module :  STD_LOGIC;
                signal internal_cpu_instruction_master_granted_cpu_jtag_debug_module :  STD_LOGIC;
                signal internal_cpu_instruction_master_qualified_request_cpu_jtag_debug_module :  STD_LOGIC;
                signal internal_cpu_instruction_master_requests_cpu_jtag_debug_module :  STD_LOGIC;
                signal internal_cpu_jtag_debug_module_reset_n :  STD_LOGIC;
                signal last_cycle_cpu_data_master_granted_slave_cpu_jtag_debug_module :  STD_LOGIC;
                signal last_cycle_cpu_instruction_master_granted_slave_cpu_jtag_debug_module :  STD_LOGIC;
                signal wait_for_cpu_jtag_debug_module_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT cpu_jtag_debug_module_end_xfer;
      end if;
    end if;

  end process;

  cpu_jtag_debug_module_begins_xfer <= NOT d1_reasons_to_wait AND ((internal_cpu_data_master_qualified_request_cpu_jtag_debug_module OR internal_cpu_instruction_master_qualified_request_cpu_jtag_debug_module));
  internal_cpu_data_master_requests_cpu_jtag_debug_module <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(23 DOWNTO 11) & std_logic_vector'("00000000000")) = std_logic_vector'("000010010000000000000000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --assign cpu_jtag_debug_module_readdata_from_sa = cpu_jtag_debug_module_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  cpu_jtag_debug_module_readdata_from_sa <= cpu_jtag_debug_module_readdata;
  --cpu_jtag_debug_module_arb_share_counter set values, which is an e_mux
  cpu_jtag_debug_module_arb_share_set_values <= std_logic_vector'("01");
  --cpu_jtag_debug_module_arb_share_counter_next_value assignment, which is an e_assign
  cpu_jtag_debug_module_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(cpu_jtag_debug_module_firsttransfer) = '1'), (((std_logic_vector'("0000000000000000000000000000000") & (cpu_jtag_debug_module_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(cpu_jtag_debug_module_arb_share_counter)) = '1'), (((std_logic_vector'("0000000000000000000000000000000") & (cpu_jtag_debug_module_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 2);
  --cpu_jtag_debug_module_allgrants all slave grants, which is an e_mux
  cpu_jtag_debug_module_allgrants <= ((or_reduce(cpu_jtag_debug_module_grant_vector) OR or_reduce(cpu_jtag_debug_module_grant_vector)) OR or_reduce(cpu_jtag_debug_module_grant_vector)) OR or_reduce(cpu_jtag_debug_module_grant_vector);
  --cpu_jtag_debug_module_end_xfer assignment, which is an e_assign
  cpu_jtag_debug_module_end_xfer <= NOT ((cpu_jtag_debug_module_waits_for_read OR cpu_jtag_debug_module_waits_for_write));
  --cpu_jtag_debug_module_arb_share_counter arbitration counter enable, which is an e_assign
  cpu_jtag_debug_module_arb_counter_enable <= cpu_jtag_debug_module_end_xfer AND cpu_jtag_debug_module_allgrants;
  --cpu_jtag_debug_module_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_jtag_debug_module_arb_share_counter <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if std_logic'(cpu_jtag_debug_module_arb_counter_enable) = '1' then 
        cpu_jtag_debug_module_arb_share_counter <= cpu_jtag_debug_module_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --cpu_jtag_debug_module_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_jtag_debug_module_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((or_reduce(cpu_jtag_debug_module_master_qreq_vector) AND cpu_jtag_debug_module_end_xfer)) = '1' then 
        cpu_jtag_debug_module_slavearbiterlockenable <= or_reduce(cpu_jtag_debug_module_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master cpu/jtag_debug_module arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= cpu_jtag_debug_module_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --cpu/instruction_master cpu/jtag_debug_module arbiterlock, which is an e_assign
  cpu_instruction_master_arbiterlock <= cpu_jtag_debug_module_slavearbiterlockenable AND cpu_instruction_master_continuerequest;
  --cpu/instruction_master granted cpu/jtag_debug_module last time, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      last_cycle_cpu_instruction_master_granted_slave_cpu_jtag_debug_module <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        last_cycle_cpu_instruction_master_granted_slave_cpu_jtag_debug_module <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(cpu_instruction_master_saved_grant_cpu_jtag_debug_module) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'(((cpu_jtag_debug_module_arbitration_holdoff_internal OR NOT internal_cpu_instruction_master_requests_cpu_jtag_debug_module))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(last_cycle_cpu_instruction_master_granted_slave_cpu_jtag_debug_module))))));
      end if;
    end if;

  end process;

  --cpu_instruction_master_continuerequest continued request, which is an e_mux
  cpu_instruction_master_continuerequest <= last_cycle_cpu_instruction_master_granted_slave_cpu_jtag_debug_module AND internal_cpu_instruction_master_requests_cpu_jtag_debug_module;
  --cpu_jtag_debug_module_any_continuerequest at least one master continues requesting, which is an e_mux
  cpu_jtag_debug_module_any_continuerequest <= cpu_instruction_master_continuerequest OR cpu_data_master_continuerequest;
  internal_cpu_data_master_qualified_request_cpu_jtag_debug_module <= internal_cpu_data_master_requests_cpu_jtag_debug_module AND NOT (cpu_instruction_master_arbiterlock);
  --cpu_jtag_debug_module_writedata mux, which is an e_mux
  cpu_jtag_debug_module_writedata <= cpu_data_master_writedata;
  --mux cpu_jtag_debug_module_debugaccess, which is an e_mux
  cpu_jtag_debug_module_debugaccess <= cpu_data_master_debugaccess;
  internal_cpu_instruction_master_requests_cpu_jtag_debug_module <= to_std_logic(((Std_Logic_Vector'(cpu_instruction_master_address_to_slave(23 DOWNTO 11) & std_logic_vector'("00000000000")) = std_logic_vector'("000010010000000000000000")))) AND (cpu_instruction_master_read);
  --cpu/data_master granted cpu/jtag_debug_module last time, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      last_cycle_cpu_data_master_granted_slave_cpu_jtag_debug_module <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        last_cycle_cpu_data_master_granted_slave_cpu_jtag_debug_module <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(cpu_data_master_saved_grant_cpu_jtag_debug_module) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'(((cpu_jtag_debug_module_arbitration_holdoff_internal OR NOT internal_cpu_data_master_requests_cpu_jtag_debug_module))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(last_cycle_cpu_data_master_granted_slave_cpu_jtag_debug_module))))));
      end if;
    end if;

  end process;

  --cpu_data_master_continuerequest continued request, which is an e_mux
  cpu_data_master_continuerequest <= last_cycle_cpu_data_master_granted_slave_cpu_jtag_debug_module AND internal_cpu_data_master_requests_cpu_jtag_debug_module;
  internal_cpu_instruction_master_qualified_request_cpu_jtag_debug_module <= internal_cpu_instruction_master_requests_cpu_jtag_debug_module AND NOT (cpu_data_master_arbiterlock);
  --allow new arb cycle for cpu/jtag_debug_module, which is an e_assign
  cpu_jtag_debug_module_allow_new_arb_cycle <= NOT cpu_data_master_arbiterlock AND NOT cpu_instruction_master_arbiterlock;
  --cpu/instruction_master assignment into master qualified-requests vector for cpu/jtag_debug_module, which is an e_assign
  cpu_jtag_debug_module_master_qreq_vector(0) <= internal_cpu_instruction_master_qualified_request_cpu_jtag_debug_module;
  --cpu/instruction_master grant cpu/jtag_debug_module, which is an e_assign
  internal_cpu_instruction_master_granted_cpu_jtag_debug_module <= cpu_jtag_debug_module_grant_vector(0);
  --cpu/instruction_master saved-grant cpu/jtag_debug_module, which is an e_assign
  cpu_instruction_master_saved_grant_cpu_jtag_debug_module <= cpu_jtag_debug_module_arb_winner(0) AND internal_cpu_instruction_master_requests_cpu_jtag_debug_module;
  --cpu/data_master assignment into master qualified-requests vector for cpu/jtag_debug_module, which is an e_assign
  cpu_jtag_debug_module_master_qreq_vector(1) <= internal_cpu_data_master_qualified_request_cpu_jtag_debug_module;
  --cpu/data_master grant cpu/jtag_debug_module, which is an e_assign
  internal_cpu_data_master_granted_cpu_jtag_debug_module <= cpu_jtag_debug_module_grant_vector(1);
  --cpu/data_master saved-grant cpu/jtag_debug_module, which is an e_assign
  cpu_data_master_saved_grant_cpu_jtag_debug_module <= cpu_jtag_debug_module_arb_winner(1) AND internal_cpu_data_master_requests_cpu_jtag_debug_module;
  --cpu/jtag_debug_module chosen-master double-vector, which is an e_assign
  cpu_jtag_debug_module_chosen_master_double_vector <= A_EXT (((std_logic_vector'("0") & ((cpu_jtag_debug_module_master_qreq_vector & cpu_jtag_debug_module_master_qreq_vector))) AND (((std_logic_vector'("0") & (Std_Logic_Vector'(NOT cpu_jtag_debug_module_master_qreq_vector & NOT cpu_jtag_debug_module_master_qreq_vector))) + (std_logic_vector'("000") & (cpu_jtag_debug_module_arb_addend))))), 4);
  --stable onehot encoding of arb winner
  cpu_jtag_debug_module_arb_winner <= A_WE_StdLogicVector((std_logic'(((cpu_jtag_debug_module_allow_new_arb_cycle AND or_reduce(cpu_jtag_debug_module_grant_vector)))) = '1'), cpu_jtag_debug_module_grant_vector, cpu_jtag_debug_module_saved_chosen_master_vector);
  --saved cpu_jtag_debug_module_grant_vector, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_jtag_debug_module_saved_chosen_master_vector <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if std_logic'(cpu_jtag_debug_module_allow_new_arb_cycle) = '1' then 
        cpu_jtag_debug_module_saved_chosen_master_vector <= A_WE_StdLogicVector((std_logic'(or_reduce(cpu_jtag_debug_module_grant_vector)) = '1'), cpu_jtag_debug_module_grant_vector, cpu_jtag_debug_module_saved_chosen_master_vector);
      end if;
    end if;

  end process;

  --onehot encoding of chosen master
  cpu_jtag_debug_module_grant_vector <= Std_Logic_Vector'(A_ToStdLogicVector(((cpu_jtag_debug_module_chosen_master_double_vector(1) OR cpu_jtag_debug_module_chosen_master_double_vector(3)))) & A_ToStdLogicVector(((cpu_jtag_debug_module_chosen_master_double_vector(0) OR cpu_jtag_debug_module_chosen_master_double_vector(2)))));
  --cpu/jtag_debug_module chosen master rotated left, which is an e_assign
  cpu_jtag_debug_module_chosen_master_rot_left <= A_EXT (A_WE_StdLogicVector((((A_SLL(cpu_jtag_debug_module_arb_winner,std_logic_vector'("00000000000000000000000000000001")))) /= std_logic_vector'("00")), (std_logic_vector'("000000000000000000000000000000") & ((A_SLL(cpu_jtag_debug_module_arb_winner,std_logic_vector'("00000000000000000000000000000001"))))), std_logic_vector'("00000000000000000000000000000001")), 2);
  --cpu/jtag_debug_module's addend for next-master-grant
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_jtag_debug_module_arb_addend <= std_logic_vector'("01");
    elsif clk'event and clk = '1' then
      if std_logic'(or_reduce(cpu_jtag_debug_module_grant_vector)) = '1' then 
        cpu_jtag_debug_module_arb_addend <= A_WE_StdLogicVector((std_logic'(cpu_jtag_debug_module_end_xfer) = '1'), cpu_jtag_debug_module_chosen_master_rot_left, cpu_jtag_debug_module_grant_vector);
      end if;
    end if;

  end process;

  cpu_jtag_debug_module_begintransfer <= cpu_jtag_debug_module_begins_xfer;
  --assign lhs ~cpu_jtag_debug_module_reset of type reset_n to cpu_jtag_debug_module_reset_n, which is an e_assign
  cpu_jtag_debug_module_reset <= NOT internal_cpu_jtag_debug_module_reset_n;
  --cpu_jtag_debug_module_reset_n assignment, which is an e_assign
  internal_cpu_jtag_debug_module_reset_n <= reset_n;
  --assign cpu_jtag_debug_module_resetrequest_from_sa = cpu_jtag_debug_module_resetrequest so that symbol knows where to group signals which may go to master only, which is an e_assign
  cpu_jtag_debug_module_resetrequest_from_sa <= cpu_jtag_debug_module_resetrequest;
  cpu_jtag_debug_module_chipselect <= internal_cpu_data_master_granted_cpu_jtag_debug_module OR internal_cpu_instruction_master_granted_cpu_jtag_debug_module;
  --cpu_jtag_debug_module_firsttransfer first transaction, which is an e_assign
  cpu_jtag_debug_module_firsttransfer <= NOT ((cpu_jtag_debug_module_slavearbiterlockenable AND cpu_jtag_debug_module_any_continuerequest));
  --cpu_jtag_debug_module_beginbursttransfer_internal begin burst transfer, which is an e_assign
  cpu_jtag_debug_module_beginbursttransfer_internal <= cpu_jtag_debug_module_begins_xfer AND cpu_jtag_debug_module_firsttransfer;
  --cpu_jtag_debug_module_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  cpu_jtag_debug_module_arbitration_holdoff_internal <= cpu_jtag_debug_module_begins_xfer AND cpu_jtag_debug_module_firsttransfer;
  --cpu_jtag_debug_module_write assignment, which is an e_mux
  cpu_jtag_debug_module_write <= internal_cpu_data_master_granted_cpu_jtag_debug_module AND cpu_data_master_write;
  --cpu_jtag_debug_module_address mux, which is an e_mux
  cpu_jtag_debug_module_address <= A_EXT (A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_cpu_jtag_debug_module)) = '1'), (A_SRL(cpu_data_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010"))), (A_SRL(cpu_instruction_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010")))), 9);
  --d1_cpu_jtag_debug_module_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_cpu_jtag_debug_module_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_cpu_jtag_debug_module_end_xfer <= cpu_jtag_debug_module_end_xfer;
      end if;
    end if;

  end process;

  --cpu_jtag_debug_module_waits_for_read in a cycle, which is an e_mux
  cpu_jtag_debug_module_waits_for_read <= cpu_jtag_debug_module_in_a_read_cycle AND cpu_jtag_debug_module_begins_xfer;
  --cpu_jtag_debug_module_in_a_read_cycle assignment, which is an e_assign
  cpu_jtag_debug_module_in_a_read_cycle <= ((internal_cpu_data_master_granted_cpu_jtag_debug_module AND cpu_data_master_read)) OR ((internal_cpu_instruction_master_granted_cpu_jtag_debug_module AND cpu_instruction_master_read));
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= cpu_jtag_debug_module_in_a_read_cycle;
  --cpu_jtag_debug_module_waits_for_write in a cycle, which is an e_mux
  cpu_jtag_debug_module_waits_for_write <= cpu_jtag_debug_module_in_a_write_cycle AND cpu_jtag_debug_module_begins_xfer;
  --cpu_jtag_debug_module_in_a_write_cycle assignment, which is an e_assign
  cpu_jtag_debug_module_in_a_write_cycle <= internal_cpu_data_master_granted_cpu_jtag_debug_module AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= cpu_jtag_debug_module_in_a_write_cycle;
  wait_for_cpu_jtag_debug_module_counter <= std_logic'('0');
  --cpu_jtag_debug_module_byteenable byte enable port mux, which is an e_mux
  cpu_jtag_debug_module_byteenable <= A_EXT (A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_cpu_jtag_debug_module)) = '1'), (std_logic_vector'("0000000000000000000000000000") & (cpu_data_master_byteenable)), -SIGNED(std_logic_vector'("00000000000000000000000000000001"))), 4);
  --vhdl renameroo for output signals
  cpu_data_master_granted_cpu_jtag_debug_module <= internal_cpu_data_master_granted_cpu_jtag_debug_module;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_cpu_jtag_debug_module <= internal_cpu_data_master_qualified_request_cpu_jtag_debug_module;
  --vhdl renameroo for output signals
  cpu_data_master_requests_cpu_jtag_debug_module <= internal_cpu_data_master_requests_cpu_jtag_debug_module;
  --vhdl renameroo for output signals
  cpu_instruction_master_granted_cpu_jtag_debug_module <= internal_cpu_instruction_master_granted_cpu_jtag_debug_module;
  --vhdl renameroo for output signals
  cpu_instruction_master_qualified_request_cpu_jtag_debug_module <= internal_cpu_instruction_master_qualified_request_cpu_jtag_debug_module;
  --vhdl renameroo for output signals
  cpu_instruction_master_requests_cpu_jtag_debug_module <= internal_cpu_instruction_master_requests_cpu_jtag_debug_module;
  --vhdl renameroo for output signals
  cpu_jtag_debug_module_reset_n <= internal_cpu_jtag_debug_module_reset_n;
--synthesis translate_off
    --grant signals are active simultaneously, which is an e_process
    process (clk)
    VARIABLE write_line : line;
    begin
      if clk'event and clk = '1' then
        if (std_logic_vector'("000000000000000000000000000000") & (((std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(internal_cpu_data_master_granted_cpu_jtag_debug_module))) + (std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(internal_cpu_instruction_master_granted_cpu_jtag_debug_module))))))>std_logic_vector'("00000000000000000000000000000001") then 
          write(write_line, now);
          write(write_line, string'(": "));
          write(write_line, string'("> 1 of grant signals are active simultaneously"));
          write(output, write_line.all);
          deallocate (write_line);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

    --saved_grant signals are active simultaneously, which is an e_process
    process (clk)
    VARIABLE write_line1 : line;
    begin
      if clk'event and clk = '1' then
        if (std_logic_vector'("000000000000000000000000000000") & (((std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(cpu_data_master_saved_grant_cpu_jtag_debug_module))) + (std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(cpu_instruction_master_saved_grant_cpu_jtag_debug_module))))))>std_logic_vector'("00000000000000000000000000000001") then 
          write(write_line1, now);
          write(write_line1, string'(": "));
          write(write_line1, string'("> 1 of saved_grant signals are active simultaneously"));
          write(output, write_line1.all);
          deallocate (write_line1);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

--synthesis translate_on

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity cpu_data_master_arbitrator is 
        port (
              -- inputs:
                 signal J23_SW_s1_irq_from_sa : IN STD_LOGIC;
                 signal J23_SW_s1_readdata_from_sa : IN STD_LOGIC;
                 signal SRAM_s1_wait_counter_eq_0 : IN STD_LOGIC;
                 signal SRAM_s1_wait_counter_eq_1 : IN STD_LOGIC;
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_data_master_byteenable_epc_s1 : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_data_master_debugaccess : IN STD_LOGIC;
                 signal cpu_data_master_granted_J23_SW_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_SRAM_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_cpu_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_data_master_granted_dev_uart_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_epc_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_onchip_RAM_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_onchip_ROM_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_sysid_control_slave : IN STD_LOGIC;
                 signal cpu_data_master_granted_test_0_test : IN STD_LOGIC;
                 signal cpu_data_master_granted_timer_0_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_J23_SW_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_SRAM_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_cpu_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_dev_uart_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_epc_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_onchip_RAM_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_onchip_ROM_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_sysid_control_slave : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_test_0_test : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_timer_0_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_J23_SW_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_SRAM_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_cpu_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_dev_uart_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_epc_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_onchip_RAM_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_onchip_ROM_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_sysid_control_slave : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_test_0_test : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_timer_0_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_J23_SW_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_SRAM_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_cpu_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_data_master_requests_dev_uart_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_epc_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_onchip_RAM_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_onchip_ROM_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_sysid_control_slave : IN STD_LOGIC;
                 signal cpu_data_master_requests_test_0_test : IN STD_LOGIC;
                 signal cpu_data_master_requests_timer_0_s1 : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_jtag_debug_module_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal d1_J23_SW_s1_end_xfer : IN STD_LOGIC;
                 signal d1_cpu_jtag_debug_module_end_xfer : IN STD_LOGIC;
                 signal d1_dev_uart_s1_end_xfer : IN STD_LOGIC;
                 signal d1_onchip_RAM_s1_end_xfer : IN STD_LOGIC;
                 signal d1_onchip_ROM_s1_end_xfer : IN STD_LOGIC;
                 signal d1_sysid_control_slave_end_xfer : IN STD_LOGIC;
                 signal d1_test_0_test_end_xfer : IN STD_LOGIC;
                 signal d1_timer_0_s1_end_xfer : IN STD_LOGIC;
                 signal d1_tri_state_bridge_avalon_slave_end_xfer : IN STD_LOGIC;
                 signal dev_uart_s1_irq_from_sa : IN STD_LOGIC;
                 signal dev_uart_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal epc_s1_wait_counter_eq_0 : IN STD_LOGIC;
                 signal epc_s1_wait_counter_eq_1 : IN STD_LOGIC;
                 signal incoming_tri_state_bridge_data : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal incoming_tri_state_bridge_data_with_Xs_converted_to_0 : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal onchip_RAM_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal onchip_ROM_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal readdata_from_the_test_0_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal registered_cpu_data_master_read_data_valid_SRAM_s1 : IN STD_LOGIC;
                 signal registered_cpu_data_master_read_data_valid_epc_s1 : IN STD_LOGIC;
                 signal registered_cpu_data_master_read_data_valid_onchip_RAM_s1 : IN STD_LOGIC;
                 signal registered_cpu_data_master_read_data_valid_onchip_ROM_s1 : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;
                 signal sysid_control_slave_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal timer_0_s1_irq_from_sa : IN STD_LOGIC;
                 signal timer_0_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal wreq_from_the_test_0_from_sa : IN STD_LOGIC;

              -- outputs:
                 signal cpu_data_master_address_to_slave : OUT STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_data_master_dbs_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_data_master_dbs_write_16 : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal cpu_data_master_irq : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_data_master_no_byte_enables_and_last_term : OUT STD_LOGIC;
                 signal cpu_data_master_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_data_master_waitrequest : OUT STD_LOGIC
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of cpu_data_master_arbitrator : entity is FALSE;
end entity cpu_data_master_arbitrator;


architecture europa of cpu_data_master_arbitrator is
                signal cpu_data_master_dbs_increment :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_data_master_run :  STD_LOGIC;
                signal dbs_16_reg_segment_0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dbs_count_enable :  STD_LOGIC;
                signal dbs_counter_overflow :  STD_LOGIC;
                signal dummy_sink :  STD_LOGIC;
                signal internal_cpu_data_master_address_to_slave :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal internal_cpu_data_master_dbs_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal internal_cpu_data_master_no_byte_enables_and_last_term :  STD_LOGIC;
                signal internal_cpu_data_master_waitrequest :  STD_LOGIC;
                signal last_dbs_term_and_run :  STD_LOGIC;
                signal next_dbs_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal p1_dbs_16_reg_segment_0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal p1_registered_cpu_data_master_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal pre_dbs_count_enable :  STD_LOGIC;
                signal r_0 :  STD_LOGIC;
                signal r_1 :  STD_LOGIC;
                signal r_2 :  STD_LOGIC;
                signal registered_cpu_data_master_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);

begin

  --r_0 master_run cascaded wait assignment, which is an e_assign
  r_0 <= Vector_To_Std_Logic((((((((((((((((((((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_qualified_request_J23_SW_s1 OR NOT cpu_data_master_requests_J23_SW_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_J23_SW_s1 OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_J23_SW_s1 OR NOT cpu_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_qualified_request_cpu_jtag_debug_module OR NOT cpu_data_master_requests_cpu_jtag_debug_module)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_granted_cpu_jtag_debug_module OR NOT cpu_data_master_qualified_request_cpu_jtag_debug_module)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_cpu_jtag_debug_module OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_cpu_jtag_debug_module OR NOT cpu_data_master_write)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_dev_uart_s1 OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_dev_uart_s1 OR NOT cpu_data_master_write)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((((cpu_data_master_qualified_request_onchip_RAM_s1 OR registered_cpu_data_master_read_data_valid_onchip_RAM_s1) OR NOT cpu_data_master_requests_onchip_RAM_s1)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((((NOT cpu_data_master_qualified_request_onchip_RAM_s1 OR NOT cpu_data_master_read) OR ((registered_cpu_data_master_read_data_valid_onchip_RAM_s1 AND cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_onchip_RAM_s1 OR NOT cpu_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((((cpu_data_master_qualified_request_onchip_ROM_s1 OR registered_cpu_data_master_read_data_valid_onchip_ROM_s1) OR NOT cpu_data_master_requests_onchip_ROM_s1)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_granted_onchip_ROM_s1 OR NOT cpu_data_master_qualified_request_onchip_ROM_s1)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((((NOT cpu_data_master_qualified_request_onchip_ROM_s1 OR NOT cpu_data_master_read) OR ((registered_cpu_data_master_read_data_valid_onchip_ROM_s1 AND cpu_data_master_read)))))))));
  --cascaded wait assignment, which is an e_assign
  cpu_data_master_run <= (r_0 AND r_1) AND r_2;
  --r_1 master_run cascaded wait assignment, which is an e_assign
  r_1 <= Vector_To_Std_Logic(((((((((((((((((((((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_onchip_ROM_s1 OR NOT cpu_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_sysid_control_slave OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_sysid_control_slave OR NOT cpu_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_qualified_request_test_0_test OR NOT cpu_data_master_requests_test_0_test)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_test_0_test OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT wreq_from_the_test_0_from_sa)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_test_0_test OR NOT cpu_data_master_write)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT wreq_from_the_test_0_from_sa)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_qualified_request_timer_0_s1 OR NOT cpu_data_master_requests_timer_0_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_timer_0_s1 OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_timer_0_s1 OR NOT cpu_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((((cpu_data_master_qualified_request_SRAM_s1 OR registered_cpu_data_master_read_data_valid_SRAM_s1) OR NOT cpu_data_master_requests_SRAM_s1)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((((cpu_data_master_qualified_request_epc_s1 OR ((registered_cpu_data_master_read_data_valid_epc_s1 AND internal_cpu_data_master_dbs_address(1)))) OR (((cpu_data_master_write AND NOT(or_reduce(cpu_data_master_byteenable_epc_s1))) AND internal_cpu_data_master_dbs_address(1)))) OR NOT cpu_data_master_requests_epc_s1)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_granted_SRAM_s1 OR NOT cpu_data_master_qualified_request_SRAM_s1)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_granted_epc_s1 OR NOT cpu_data_master_qualified_request_epc_s1)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((((NOT cpu_data_master_qualified_request_SRAM_s1 OR NOT cpu_data_master_read) OR ((registered_cpu_data_master_read_data_valid_SRAM_s1 AND cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_SRAM_s1 OR NOT cpu_data_master_write)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(SRAM_s1_wait_counter_eq_1)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((((NOT cpu_data_master_qualified_request_epc_s1 OR NOT cpu_data_master_read) OR (((registered_cpu_data_master_read_data_valid_epc_s1 AND (internal_cpu_data_master_dbs_address(1))) AND cpu_data_master_read)))))))));
  --r_2 master_run cascaded wait assignment, which is an e_assign
  r_2 <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_epc_s1 OR NOT cpu_data_master_write)))) OR ((((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(epc_s1_wait_counter_eq_1)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((internal_cpu_data_master_dbs_address(1)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))));
  --optimize select-logic by passing only those address bits which matter.
  internal_cpu_data_master_address_to_slave <= Std_Logic_Vector'(A_ToStdLogicVector(cpu_data_master_address(23)) & A_ToStdLogicVector(std_logic'('0')) & cpu_data_master_address(21 DOWNTO 0));
  --dummy sink, which is an e_mux
  dummy_sink <= Vector_To_Std_Logic(((((((((((((((((((((((((((((((((((((((((((((((internal_cpu_data_master_address_to_slave OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_requests_J23_SW_s1)))) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_qualified_request_J23_SW_s1)))) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(d1_J23_SW_s1_end_xfer)))) OR internal_cpu_data_master_address_to_slave) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_requests_cpu_jtag_debug_module)))) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_qualified_request_cpu_jtag_debug_module)))) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_debugaccess)))) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(d1_cpu_jtag_debug_module_end_xfer)))) OR internal_cpu_data_master_address_to_slave) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_requests_dev_uart_s1)))) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_qualified_request_dev_uart_s1)))) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(d1_dev_uart_s1_end_xfer)))) OR internal_cpu_data_master_address_to_slave) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read_data_valid_onchip_RAM_s1)))) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_requests_onchip_RAM_s1)))) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_qualified_request_onchip_RAM_s1)))) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(d1_onchip_RAM_s1_end_xfer)))) OR internal_cpu_data_master_address_to_slave) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read_data_valid_onchip_ROM_s1)))) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_requests_onchip_ROM_s1)))) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_qualified_request_onchip_ROM_s1)))) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_debugaccess)))) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(d1_onchip_ROM_s1_end_xfer)))) OR internal_cpu_data_master_address_to_slave) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_requests_sysid_control_slave)))) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_qualified_request_sysid_control_slave)))) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(d1_sysid_control_slave_end_xfer)))) OR internal_cpu_data_master_address_to_slave) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_requests_test_0_test)))) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_qualified_request_test_0_test)))) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(d1_test_0_test_end_xfer)))) OR internal_cpu_data_master_address_to_slave) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_requests_timer_0_s1)))) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_qualified_request_timer_0_s1)))) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(d1_timer_0_s1_end_xfer)))) OR internal_cpu_data_master_address_to_slave) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read_data_valid_SRAM_s1)))) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_requests_SRAM_s1)))) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_qualified_request_SRAM_s1)))) OR internal_cpu_data_master_address_to_slave) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read_data_valid_epc_s1)))) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_requests_epc_s1)))) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_qualified_request_epc_s1)))) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(d1_tri_state_bridge_avalon_slave_end_xfer)))) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(SRAM_s1_wait_counter_eq_0)))) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(epc_s1_wait_counter_eq_0)))));
  --cpu/data_master readdata mux, which is an e_mux
  cpu_data_master_readdata <= ((((((((((A_REP(NOT cpu_data_master_requests_J23_SW_s1, 32) OR (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(J23_SW_s1_readdata_from_sa))))) AND ((A_REP(NOT cpu_data_master_requests_cpu_jtag_debug_module, 32) OR cpu_jtag_debug_module_readdata_from_sa))) AND ((A_REP(NOT cpu_data_master_requests_dev_uart_s1, 32) OR (std_logic_vector'("0000000000000000") & (dev_uart_s1_readdata_from_sa))))) AND ((A_REP(NOT cpu_data_master_requests_onchip_RAM_s1, 32) OR onchip_RAM_s1_readdata_from_sa))) AND ((A_REP(NOT cpu_data_master_requests_onchip_ROM_s1, 32) OR onchip_ROM_s1_readdata_from_sa))) AND ((A_REP(NOT cpu_data_master_requests_sysid_control_slave, 32) OR sysid_control_slave_readdata_from_sa))) AND ((A_REP(NOT cpu_data_master_requests_test_0_test, 32) OR registered_cpu_data_master_readdata))) AND ((A_REP(NOT cpu_data_master_requests_timer_0_s1, 32) OR (std_logic_vector'("0000000000000000") & (timer_0_s1_readdata_from_sa))))) AND ((A_REP(NOT cpu_data_master_requests_SRAM_s1, 32) OR incoming_tri_state_bridge_data))) AND ((A_REP(NOT cpu_data_master_requests_epc_s1, 32) OR (incoming_tri_state_bridge_data_with_Xs_converted_to_0 & dbs_16_reg_segment_0)));
  --actual waitrequest port, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_data_master_waitrequest <= Vector_To_Std_Logic(NOT std_logic_vector'("00000000000000000000000000000000"));
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        internal_cpu_data_master_waitrequest <= Vector_To_Std_Logic(NOT (A_WE_StdLogicVector((std_logic'((NOT ((cpu_data_master_read OR cpu_data_master_write)))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_run AND internal_cpu_data_master_waitrequest))))))));
      end if;
    end if;

  end process;

  --irq assign, which is an e_assign
  cpu_data_master_irq <= Std_Logic_Vector'(A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(J23_SW_s1_irq_from_sa) & A_ToStdLogicVector(timer_0_s1_irq_from_sa) & A_ToStdLogicVector(dev_uart_s1_irq_from_sa) & A_ToStdLogicVector(std_logic'('0')));
  --unpredictable registered wait state incoming data, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      registered_cpu_data_master_readdata <= std_logic_vector'("00000000000000000000000000000000");
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        registered_cpu_data_master_readdata <= p1_registered_cpu_data_master_readdata;
      end if;
    end if;

  end process;

  --registered readdata mux, which is an e_mux
  p1_registered_cpu_data_master_readdata <= A_REP(NOT cpu_data_master_requests_test_0_test, 32) OR readdata_from_the_test_0_from_sa;
  --no_byte_enables_and_last_term, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_data_master_no_byte_enables_and_last_term <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        internal_cpu_data_master_no_byte_enables_and_last_term <= last_dbs_term_and_run;
      end if;
    end if;

  end process;

  --compute the last dbs term, which is an e_mux
  last_dbs_term_and_run <= (to_std_logic(((internal_cpu_data_master_dbs_address = std_logic_vector'("10")))) AND cpu_data_master_write) AND NOT(or_reduce(cpu_data_master_byteenable_epc_s1));
  --pre dbs count enable, which is an e_mux
  pre_dbs_count_enable <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((((((NOT internal_cpu_data_master_no_byte_enables_and_last_term) AND cpu_data_master_requests_epc_s1) AND cpu_data_master_write) AND NOT(or_reduce(cpu_data_master_byteenable_epc_s1)))) OR cpu_data_master_read_data_valid_epc_s1)))) OR (((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((cpu_data_master_granted_epc_s1 AND cpu_data_master_write)))) AND std_logic_vector'("00000000000000000000000000000001")) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((epc_s1_wait_counter_eq_0 AND NOT d1_tri_state_bridge_avalon_slave_end_xfer)))))))));
  --input to dbs-16 stored 0, which is an e_mux
  p1_dbs_16_reg_segment_0 <= incoming_tri_state_bridge_data_with_Xs_converted_to_0;
  --dbs register for dbs-16 segment 0, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      dbs_16_reg_segment_0 <= std_logic_vector'("0000000000000000");
    elsif clk'event and clk = '1' then
      if std_logic'((dbs_count_enable AND to_std_logic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((internal_cpu_data_master_dbs_address(1))))) = std_logic_vector'("00000000000000000000000000000000")))))) = '1' then 
        dbs_16_reg_segment_0 <= p1_dbs_16_reg_segment_0;
      end if;
    end if;

  end process;

  --mux write dbs 1, which is an e_mux
  cpu_data_master_dbs_write_16 <= A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_dbs_address(1))) = '1'), cpu_data_master_writedata(31 DOWNTO 16), cpu_data_master_writedata(15 DOWNTO 0));
  --dbs count increment, which is an e_mux
  cpu_data_master_dbs_increment <= A_EXT (A_WE_StdLogicVector((std_logic'((cpu_data_master_requests_epc_s1)) = '1'), std_logic_vector'("00000000000000000000000000000010"), std_logic_vector'("00000000000000000000000000000000")), 2);
  --dbs counter overflow, which is an e_assign
  dbs_counter_overflow <= internal_cpu_data_master_dbs_address(1) AND NOT((next_dbs_address(1)));
  --next master address, which is an e_assign
  next_dbs_address <= A_EXT (((std_logic_vector'("0") & (internal_cpu_data_master_dbs_address)) + (std_logic_vector'("0") & (cpu_data_master_dbs_increment))), 2);
  --dbs count enable, which is an e_mux
  dbs_count_enable <= pre_dbs_count_enable;
  --dbs counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_data_master_dbs_address <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if std_logic'(dbs_count_enable) = '1' then 
        internal_cpu_data_master_dbs_address <= next_dbs_address;
      end if;
    end if;

  end process;

  --vhdl renameroo for output signals
  cpu_data_master_address_to_slave <= internal_cpu_data_master_address_to_slave;
  --vhdl renameroo for output signals
  cpu_data_master_dbs_address <= internal_cpu_data_master_dbs_address;
  --vhdl renameroo for output signals
  cpu_data_master_no_byte_enables_and_last_term <= internal_cpu_data_master_no_byte_enables_and_last_term;
  --vhdl renameroo for output signals
  cpu_data_master_waitrequest <= internal_cpu_data_master_waitrequest;

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library std;
use std.textio.all;

entity cpu_instruction_master_arbitrator is 
        port (
              -- inputs:
                 signal SRAM_s1_wait_counter_eq_0 : IN STD_LOGIC;
                 signal SRAM_s1_wait_counter_eq_1 : IN STD_LOGIC;
                 signal clk : IN STD_LOGIC;
                 signal cpu_instruction_master_address : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_instruction_master_granted_SRAM_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_granted_cpu_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_instruction_master_granted_epc_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_granted_onchip_ROM_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_SRAM_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_cpu_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_epc_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_onchip_ROM_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_read : IN STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_SRAM_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_cpu_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_epc_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_onchip_ROM_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_requests_SRAM_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_requests_cpu_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_instruction_master_requests_epc_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_requests_onchip_ROM_s1 : IN STD_LOGIC;
                 signal cpu_jtag_debug_module_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal d1_cpu_jtag_debug_module_end_xfer : IN STD_LOGIC;
                 signal d1_onchip_ROM_s1_end_xfer : IN STD_LOGIC;
                 signal d1_tri_state_bridge_avalon_slave_end_xfer : IN STD_LOGIC;
                 signal epc_s1_wait_counter_eq_0 : IN STD_LOGIC;
                 signal epc_s1_wait_counter_eq_1 : IN STD_LOGIC;
                 signal incoming_tri_state_bridge_data : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal onchip_ROM_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal cpu_instruction_master_address_to_slave : OUT STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_instruction_master_dbs_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_instruction_master_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_instruction_master_waitrequest : OUT STD_LOGIC
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of cpu_instruction_master_arbitrator : entity is FALSE;
end entity cpu_instruction_master_arbitrator;


architecture europa of cpu_instruction_master_arbitrator is
                signal active_and_waiting_last_time :  STD_LOGIC;
                signal cpu_instruction_master_address_last_time :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal cpu_instruction_master_dbs_increment :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_instruction_master_read_last_time :  STD_LOGIC;
                signal cpu_instruction_master_run :  STD_LOGIC;
                signal dbs_16_reg_segment_0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dbs_count_enable :  STD_LOGIC;
                signal dbs_counter_overflow :  STD_LOGIC;
                signal dummy_sink :  STD_LOGIC;
                signal internal_cpu_instruction_master_address_to_slave :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal internal_cpu_instruction_master_dbs_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal internal_cpu_instruction_master_waitrequest :  STD_LOGIC;
                signal next_dbs_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal p1_dbs_16_reg_segment_0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal pre_dbs_count_enable :  STD_LOGIC;
                signal r_0 :  STD_LOGIC;
                signal r_1 :  STD_LOGIC;
                signal r_2 :  STD_LOGIC;

begin

  --r_0 master_run cascaded wait assignment, which is an e_assign
  r_0 <= Vector_To_Std_Logic(((((((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_instruction_master_qualified_request_cpu_jtag_debug_module OR NOT cpu_instruction_master_requests_cpu_jtag_debug_module)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_instruction_master_granted_cpu_jtag_debug_module OR NOT cpu_instruction_master_qualified_request_cpu_jtag_debug_module)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_instruction_master_qualified_request_cpu_jtag_debug_module OR NOT cpu_instruction_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT d1_cpu_jtag_debug_module_end_xfer)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_instruction_master_read)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((((cpu_instruction_master_qualified_request_onchip_ROM_s1 OR cpu_instruction_master_read_data_valid_onchip_ROM_s1) OR NOT cpu_instruction_master_requests_onchip_ROM_s1)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_instruction_master_granted_onchip_ROM_s1 OR NOT cpu_instruction_master_qualified_request_onchip_ROM_s1)))))));
  --cascaded wait assignment, which is an e_assign
  cpu_instruction_master_run <= (r_0 AND r_1) AND r_2;
  --r_1 master_run cascaded wait assignment, which is an e_assign
  r_1 <= Vector_To_Std_Logic((((((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((((NOT cpu_instruction_master_qualified_request_onchip_ROM_s1 OR NOT cpu_instruction_master_read) OR ((cpu_instruction_master_read_data_valid_onchip_ROM_s1 AND cpu_instruction_master_read))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((((cpu_instruction_master_qualified_request_SRAM_s1 OR cpu_instruction_master_read_data_valid_SRAM_s1) OR NOT cpu_instruction_master_requests_SRAM_s1)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((((cpu_instruction_master_qualified_request_epc_s1 OR ((cpu_instruction_master_read_data_valid_epc_s1 AND internal_cpu_instruction_master_dbs_address(1)))) OR NOT cpu_instruction_master_requests_epc_s1)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_instruction_master_granted_SRAM_s1 OR NOT cpu_instruction_master_qualified_request_SRAM_s1)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_instruction_master_granted_epc_s1 OR NOT cpu_instruction_master_qualified_request_epc_s1)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((((NOT cpu_instruction_master_qualified_request_SRAM_s1 OR NOT cpu_instruction_master_read) OR ((cpu_instruction_master_read_data_valid_SRAM_s1 AND cpu_instruction_master_read)))))))));
  --r_2 master_run cascaded wait assignment, which is an e_assign
  r_2 <= (NOT cpu_instruction_master_qualified_request_epc_s1 OR NOT cpu_instruction_master_read) OR (((cpu_instruction_master_read_data_valid_epc_s1 AND (internal_cpu_instruction_master_dbs_address(1))) AND cpu_instruction_master_read));
  --optimize select-logic by passing only those address bits which matter.
  internal_cpu_instruction_master_address_to_slave <= Std_Logic_Vector'(A_ToStdLogicVector(cpu_instruction_master_address(23)) & A_ToStdLogicVector(std_logic'('0')) & cpu_instruction_master_address(21 DOWNTO 0));
  --dummy sink, which is an e_mux
  dummy_sink <= Vector_To_Std_Logic(((((((((((((((((internal_cpu_instruction_master_address_to_slave OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_instruction_master_requests_cpu_jtag_debug_module)))) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_instruction_master_qualified_request_cpu_jtag_debug_module)))) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(d1_cpu_jtag_debug_module_end_xfer)))) OR internal_cpu_instruction_master_address_to_slave) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_instruction_master_requests_onchip_ROM_s1)))) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_instruction_master_qualified_request_onchip_ROM_s1)))) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(d1_onchip_ROM_s1_end_xfer)))) OR internal_cpu_instruction_master_address_to_slave) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_instruction_master_requests_SRAM_s1)))) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_instruction_master_qualified_request_SRAM_s1)))) OR internal_cpu_instruction_master_address_to_slave) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_instruction_master_requests_epc_s1)))) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_instruction_master_qualified_request_epc_s1)))) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(d1_tri_state_bridge_avalon_slave_end_xfer)))) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(SRAM_s1_wait_counter_eq_0)))) OR (std_logic_vector'("00000000000000000000000") & (A_TOSTDLOGICVECTOR(epc_s1_wait_counter_eq_0)))));
  --cpu/instruction_master readdata mux, which is an e_mux
  cpu_instruction_master_readdata <= A_EXT (((std_logic_vector'("0000000000000000") & (((((A_REP(NOT cpu_instruction_master_requests_cpu_jtag_debug_module, 32) OR cpu_jtag_debug_module_readdata_from_sa)) AND ((A_REP(NOT cpu_instruction_master_requests_onchip_ROM_s1, 32) OR onchip_ROM_s1_readdata_from_sa))) AND ((A_REP(NOT cpu_instruction_master_requests_SRAM_s1, 32) OR incoming_tri_state_bridge_data))))) AND (((std_logic_vector'("0000000000000000") & (A_REP(NOT cpu_instruction_master_requests_epc_s1, 32))) OR (incoming_tri_state_bridge_data & dbs_16_reg_segment_0)))), 32);
  --actual waitrequest port, which is an e_assign
  internal_cpu_instruction_master_waitrequest <= NOT cpu_instruction_master_run;
  --input to dbs-16 stored 0, which is an e_mux
  p1_dbs_16_reg_segment_0 <= incoming_tri_state_bridge_data (15 DOWNTO 0);
  --dbs register for dbs-16 segment 0, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      dbs_16_reg_segment_0 <= std_logic_vector'("0000000000000000");
    elsif clk'event and clk = '1' then
      if std_logic'((dbs_count_enable AND to_std_logic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((internal_cpu_instruction_master_dbs_address(1))))) = std_logic_vector'("00000000000000000000000000000000")))))) = '1' then 
        dbs_16_reg_segment_0 <= p1_dbs_16_reg_segment_0;
      end if;
    end if;

  end process;

  --dbs count increment, which is an e_mux
  cpu_instruction_master_dbs_increment <= A_EXT (A_WE_StdLogicVector((std_logic'((cpu_instruction_master_requests_epc_s1)) = '1'), std_logic_vector'("00000000000000000000000000000010"), std_logic_vector'("00000000000000000000000000000000")), 2);
  --dbs counter overflow, which is an e_assign
  dbs_counter_overflow <= internal_cpu_instruction_master_dbs_address(1) AND NOT((next_dbs_address(1)));
  --next master address, which is an e_assign
  next_dbs_address <= A_EXT (((std_logic_vector'("0") & (internal_cpu_instruction_master_dbs_address)) + (std_logic_vector'("0") & (cpu_instruction_master_dbs_increment))), 2);
  --dbs count enable, which is an e_mux
  dbs_count_enable <= pre_dbs_count_enable;
  --dbs counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_instruction_master_dbs_address <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if std_logic'(dbs_count_enable) = '1' then 
        internal_cpu_instruction_master_dbs_address <= next_dbs_address;
      end if;
    end if;

  end process;

  --pre dbs count enable, which is an e_mux
  pre_dbs_count_enable <= cpu_instruction_master_read_data_valid_epc_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_address_to_slave <= internal_cpu_instruction_master_address_to_slave;
  --vhdl renameroo for output signals
  cpu_instruction_master_dbs_address <= internal_cpu_instruction_master_dbs_address;
  --vhdl renameroo for output signals
  cpu_instruction_master_waitrequest <= internal_cpu_instruction_master_waitrequest;
--synthesis translate_off
    --cpu_instruction_master_address check against wait, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        cpu_instruction_master_address_last_time <= std_logic_vector'("000000000000000000000000");
      elsif clk'event and clk = '1' then
        if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
          cpu_instruction_master_address_last_time <= cpu_instruction_master_address;
        end if;
      end if;

    end process;

    --cpu/instruction_master waited last time, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        active_and_waiting_last_time <= std_logic'('0');
      elsif clk'event and clk = '1' then
        if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
          active_and_waiting_last_time <= internal_cpu_instruction_master_waitrequest AND (cpu_instruction_master_read);
        end if;
      end if;

    end process;

    --cpu_instruction_master_address matches last port_name, which is an e_process
    process (active_and_waiting_last_time, cpu_instruction_master_address, cpu_instruction_master_address_last_time)
    VARIABLE write_line2 : line;
    begin
        if std_logic'((active_and_waiting_last_time AND to_std_logic(((cpu_instruction_master_address /= cpu_instruction_master_address_last_time))))) = '1' then 
          write(write_line2, now);
          write(write_line2, string'(": "));
          write(write_line2, string'("cpu_instruction_master_address did not heed wait!!!"));
          write(output, write_line2.all);
          deallocate (write_line2);
          assert false report "VHDL STOP" severity failure;
        end if;

    end process;

    --cpu_instruction_master_read check against wait, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        cpu_instruction_master_read_last_time <= std_logic'('0');
      elsif clk'event and clk = '1' then
        if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
          cpu_instruction_master_read_last_time <= cpu_instruction_master_read;
        end if;
      end if;

    end process;

    --cpu_instruction_master_read matches last port_name, which is an e_process
    process (active_and_waiting_last_time, cpu_instruction_master_read, cpu_instruction_master_read_last_time)
    VARIABLE write_line3 : line;
    begin
        if std_logic'((active_and_waiting_last_time AND to_std_logic(((std_logic'(cpu_instruction_master_read) /= std_logic'(cpu_instruction_master_read_last_time)))))) = '1' then 
          write(write_line3, now);
          write(write_line3, string'(": "));
          write(write_line3, string'("cpu_instruction_master_read did not heed wait!!!"));
          write(output, write_line3.all);
          deallocate (write_line3);
          assert false report "VHDL STOP" severity failure;
        end if;

    end process;

--synthesis translate_on

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity dev_uart_s1_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal dev_uart_s1_dataavailable : IN STD_LOGIC;
                 signal dev_uart_s1_irq : IN STD_LOGIC;
                 signal dev_uart_s1_readdata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal dev_uart_s1_readyfordata : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal cpu_data_master_granted_dev_uart_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_dev_uart_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_dev_uart_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_dev_uart_s1 : OUT STD_LOGIC;
                 signal d1_dev_uart_s1_end_xfer : OUT STD_LOGIC;
                 signal dev_uart_s1_address : OUT STD_LOGIC_VECTOR (2 DOWNTO 0);
                 signal dev_uart_s1_begintransfer : OUT STD_LOGIC;
                 signal dev_uart_s1_chipselect : OUT STD_LOGIC;
                 signal dev_uart_s1_dataavailable_from_sa : OUT STD_LOGIC;
                 signal dev_uart_s1_irq_from_sa : OUT STD_LOGIC;
                 signal dev_uart_s1_read_n : OUT STD_LOGIC;
                 signal dev_uart_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal dev_uart_s1_readyfordata_from_sa : OUT STD_LOGIC;
                 signal dev_uart_s1_reset_n : OUT STD_LOGIC;
                 signal dev_uart_s1_write_n : OUT STD_LOGIC;
                 signal dev_uart_s1_writedata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of dev_uart_s1_arbitrator : entity is FALSE;
end entity dev_uart_s1_arbitrator;


architecture europa of dev_uart_s1_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_dev_uart_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal dev_uart_s1_allgrants :  STD_LOGIC;
                signal dev_uart_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal dev_uart_s1_any_continuerequest :  STD_LOGIC;
                signal dev_uart_s1_arb_counter_enable :  STD_LOGIC;
                signal dev_uart_s1_arb_share_counter :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal dev_uart_s1_arb_share_counter_next_value :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal dev_uart_s1_arb_share_set_values :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal dev_uart_s1_arbitration_holdoff_internal :  STD_LOGIC;
                signal dev_uart_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal dev_uart_s1_begins_xfer :  STD_LOGIC;
                signal dev_uart_s1_end_xfer :  STD_LOGIC;
                signal dev_uart_s1_firsttransfer :  STD_LOGIC;
                signal dev_uart_s1_grant_vector :  STD_LOGIC;
                signal dev_uart_s1_in_a_read_cycle :  STD_LOGIC;
                signal dev_uart_s1_in_a_write_cycle :  STD_LOGIC;
                signal dev_uart_s1_master_qreq_vector :  STD_LOGIC;
                signal dev_uart_s1_slavearbiterlockenable :  STD_LOGIC;
                signal dev_uart_s1_waits_for_read :  STD_LOGIC;
                signal dev_uart_s1_waits_for_write :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_dev_uart_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_dev_uart_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_dev_uart_s1 :  STD_LOGIC;
                signal wait_for_dev_uart_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT dev_uart_s1_end_xfer;
      end if;
    end if;

  end process;

  dev_uart_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_dev_uart_s1);
  internal_cpu_data_master_requests_dev_uart_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(23 DOWNTO 5) & std_logic_vector'("00000")) = std_logic_vector'("000010000000000100000000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --assign dev_uart_s1_dataavailable_from_sa = dev_uart_s1_dataavailable so that symbol knows where to group signals which may go to master only, which is an e_assign
  dev_uart_s1_dataavailable_from_sa <= dev_uart_s1_dataavailable;
  --assign dev_uart_s1_readyfordata_from_sa = dev_uart_s1_readyfordata so that symbol knows where to group signals which may go to master only, which is an e_assign
  dev_uart_s1_readyfordata_from_sa <= dev_uart_s1_readyfordata;
  --assign dev_uart_s1_readdata_from_sa = dev_uart_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  dev_uart_s1_readdata_from_sa <= dev_uart_s1_readdata;
  --dev_uart_s1_arb_share_counter set values, which is an e_mux
  dev_uart_s1_arb_share_set_values <= std_logic_vector'("01");
  --dev_uart_s1_arb_share_counter_next_value assignment, which is an e_assign
  dev_uart_s1_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(dev_uart_s1_firsttransfer) = '1'), (((std_logic_vector'("0000000000000000000000000000000") & (dev_uart_s1_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(dev_uart_s1_arb_share_counter)) = '1'), (((std_logic_vector'("0000000000000000000000000000000") & (dev_uart_s1_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 2);
  --dev_uart_s1_allgrants all slave grants, which is an e_mux
  dev_uart_s1_allgrants <= dev_uart_s1_grant_vector;
  --dev_uart_s1_end_xfer assignment, which is an e_assign
  dev_uart_s1_end_xfer <= NOT ((dev_uart_s1_waits_for_read OR dev_uart_s1_waits_for_write));
  --dev_uart_s1_arb_share_counter arbitration counter enable, which is an e_assign
  dev_uart_s1_arb_counter_enable <= dev_uart_s1_end_xfer AND dev_uart_s1_allgrants;
  --dev_uart_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      dev_uart_s1_arb_share_counter <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if std_logic'(dev_uart_s1_arb_counter_enable) = '1' then 
        dev_uart_s1_arb_share_counter <= dev_uart_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --dev_uart_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      dev_uart_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((dev_uart_s1_master_qreq_vector AND dev_uart_s1_end_xfer)) = '1' then 
        dev_uart_s1_slavearbiterlockenable <= or_reduce(dev_uart_s1_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master dev_uart/s1 arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= dev_uart_s1_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --dev_uart_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  dev_uart_s1_any_continuerequest <= std_logic'('0');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('0');
  internal_cpu_data_master_qualified_request_dev_uart_s1 <= internal_cpu_data_master_requests_dev_uart_s1;
  --dev_uart_s1_writedata mux, which is an e_mux
  dev_uart_s1_writedata <= cpu_data_master_writedata (15 DOWNTO 0);
  --master is always granted when requested
  internal_cpu_data_master_granted_dev_uart_s1 <= internal_cpu_data_master_qualified_request_dev_uart_s1;
  --cpu/data_master saved-grant dev_uart/s1, which is an e_assign
  cpu_data_master_saved_grant_dev_uart_s1 <= internal_cpu_data_master_requests_dev_uart_s1;
  --allow new arb cycle for dev_uart/s1, which is an e_assign
  dev_uart_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  dev_uart_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  dev_uart_s1_master_qreq_vector <= std_logic'('1');
  dev_uart_s1_begintransfer <= dev_uart_s1_begins_xfer;
  --dev_uart_s1_reset_n assignment, which is an e_assign
  dev_uart_s1_reset_n <= reset_n;
  dev_uart_s1_chipselect <= internal_cpu_data_master_granted_dev_uart_s1;
  --dev_uart_s1_firsttransfer first transaction, which is an e_assign
  dev_uart_s1_firsttransfer <= NOT ((dev_uart_s1_slavearbiterlockenable AND dev_uart_s1_any_continuerequest));
  --dev_uart_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  dev_uart_s1_beginbursttransfer_internal <= dev_uart_s1_begins_xfer AND dev_uart_s1_firsttransfer;
  --dev_uart_s1_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  dev_uart_s1_arbitration_holdoff_internal <= dev_uart_s1_begins_xfer AND dev_uart_s1_firsttransfer;
  --~dev_uart_s1_read_n assignment, which is an e_mux
  dev_uart_s1_read_n <= NOT ((internal_cpu_data_master_granted_dev_uart_s1 AND cpu_data_master_read));
  --~dev_uart_s1_write_n assignment, which is an e_mux
  dev_uart_s1_write_n <= NOT ((internal_cpu_data_master_granted_dev_uart_s1 AND cpu_data_master_write));
  --dev_uart_s1_address mux, which is an e_mux
  dev_uart_s1_address <= A_EXT (A_SRL(cpu_data_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010")), 3);
  --d1_dev_uart_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_dev_uart_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_dev_uart_s1_end_xfer <= dev_uart_s1_end_xfer;
      end if;
    end if;

  end process;

  --dev_uart_s1_waits_for_read in a cycle, which is an e_mux
  dev_uart_s1_waits_for_read <= dev_uart_s1_in_a_read_cycle AND dev_uart_s1_begins_xfer;
  --dev_uart_s1_in_a_read_cycle assignment, which is an e_assign
  dev_uart_s1_in_a_read_cycle <= internal_cpu_data_master_granted_dev_uart_s1 AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= dev_uart_s1_in_a_read_cycle;
  --dev_uart_s1_waits_for_write in a cycle, which is an e_mux
  dev_uart_s1_waits_for_write <= dev_uart_s1_in_a_write_cycle AND dev_uart_s1_begins_xfer;
  --dev_uart_s1_in_a_write_cycle assignment, which is an e_assign
  dev_uart_s1_in_a_write_cycle <= internal_cpu_data_master_granted_dev_uart_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= dev_uart_s1_in_a_write_cycle;
  wait_for_dev_uart_s1_counter <= std_logic'('0');
  --assign dev_uart_s1_irq_from_sa = dev_uart_s1_irq so that symbol knows where to group signals which may go to master only, which is an e_assign
  dev_uart_s1_irq_from_sa <= dev_uart_s1_irq;
  --vhdl renameroo for output signals
  cpu_data_master_granted_dev_uart_s1 <= internal_cpu_data_master_granted_dev_uart_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_dev_uart_s1 <= internal_cpu_data_master_qualified_request_dev_uart_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_dev_uart_s1 <= internal_cpu_data_master_requests_dev_uart_s1;

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity onchip_RAM_s1_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_waitrequest : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal onchip_RAM_s1_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal cpu_data_master_granted_onchip_RAM_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_onchip_RAM_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_onchip_RAM_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_onchip_RAM_s1 : OUT STD_LOGIC;
                 signal d1_onchip_RAM_s1_end_xfer : OUT STD_LOGIC;
                 signal onchip_RAM_s1_address : OUT STD_LOGIC_VECTOR (13 DOWNTO 0);
                 signal onchip_RAM_s1_byteenable : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal onchip_RAM_s1_chipselect : OUT STD_LOGIC;
                 signal onchip_RAM_s1_clken : OUT STD_LOGIC;
                 signal onchip_RAM_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal onchip_RAM_s1_write : OUT STD_LOGIC;
                 signal onchip_RAM_s1_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal registered_cpu_data_master_read_data_valid_onchip_RAM_s1 : OUT STD_LOGIC
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of onchip_RAM_s1_arbitrator : entity is FALSE;
end entity onchip_RAM_s1_arbitrator;


architecture europa of onchip_RAM_s1_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_onchip_RAM_s1_shift_register :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_onchip_RAM_s1_shift_register_in :  STD_LOGIC;
                signal cpu_data_master_saved_grant_onchip_RAM_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_onchip_RAM_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_onchip_RAM_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_onchip_RAM_s1 :  STD_LOGIC;
                signal onchip_RAM_s1_allgrants :  STD_LOGIC;
                signal onchip_RAM_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal onchip_RAM_s1_any_continuerequest :  STD_LOGIC;
                signal onchip_RAM_s1_arb_counter_enable :  STD_LOGIC;
                signal onchip_RAM_s1_arb_share_counter :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal onchip_RAM_s1_arb_share_counter_next_value :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal onchip_RAM_s1_arb_share_set_values :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal onchip_RAM_s1_arbitration_holdoff_internal :  STD_LOGIC;
                signal onchip_RAM_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal onchip_RAM_s1_begins_xfer :  STD_LOGIC;
                signal onchip_RAM_s1_end_xfer :  STD_LOGIC;
                signal onchip_RAM_s1_firsttransfer :  STD_LOGIC;
                signal onchip_RAM_s1_grant_vector :  STD_LOGIC;
                signal onchip_RAM_s1_in_a_read_cycle :  STD_LOGIC;
                signal onchip_RAM_s1_in_a_write_cycle :  STD_LOGIC;
                signal onchip_RAM_s1_master_qreq_vector :  STD_LOGIC;
                signal onchip_RAM_s1_slavearbiterlockenable :  STD_LOGIC;
                signal onchip_RAM_s1_waits_for_read :  STD_LOGIC;
                signal onchip_RAM_s1_waits_for_write :  STD_LOGIC;
                signal p1_cpu_data_master_read_data_valid_onchip_RAM_s1_shift_register :  STD_LOGIC;
                signal wait_for_onchip_RAM_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT onchip_RAM_s1_end_xfer;
      end if;
    end if;

  end process;

  onchip_RAM_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_onchip_RAM_s1);
  internal_cpu_data_master_requests_onchip_RAM_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(23 DOWNTO 16) & std_logic_vector'("0000000000000000")) = std_logic_vector'("000000010000000000000000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --assign onchip_RAM_s1_readdata_from_sa = onchip_RAM_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  onchip_RAM_s1_readdata_from_sa <= onchip_RAM_s1_readdata;
  --registered rdv signal_name registered_cpu_data_master_read_data_valid_onchip_RAM_s1 assignment, which is an e_assign
  registered_cpu_data_master_read_data_valid_onchip_RAM_s1 <= cpu_data_master_read_data_valid_onchip_RAM_s1_shift_register_in;
  --onchip_RAM_s1_arb_share_counter set values, which is an e_mux
  onchip_RAM_s1_arb_share_set_values <= std_logic_vector'("01");
  --onchip_RAM_s1_arb_share_counter_next_value assignment, which is an e_assign
  onchip_RAM_s1_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(onchip_RAM_s1_firsttransfer) = '1'), (((std_logic_vector'("0000000000000000000000000000000") & (onchip_RAM_s1_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(onchip_RAM_s1_arb_share_counter)) = '1'), (((std_logic_vector'("0000000000000000000000000000000") & (onchip_RAM_s1_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 2);
  --onchip_RAM_s1_allgrants all slave grants, which is an e_mux
  onchip_RAM_s1_allgrants <= onchip_RAM_s1_grant_vector;
  --onchip_RAM_s1_end_xfer assignment, which is an e_assign
  onchip_RAM_s1_end_xfer <= NOT ((onchip_RAM_s1_waits_for_read OR onchip_RAM_s1_waits_for_write));
  --onchip_RAM_s1_arb_share_counter arbitration counter enable, which is an e_assign
  onchip_RAM_s1_arb_counter_enable <= onchip_RAM_s1_end_xfer AND onchip_RAM_s1_allgrants;
  --onchip_RAM_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      onchip_RAM_s1_arb_share_counter <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if std_logic'(onchip_RAM_s1_arb_counter_enable) = '1' then 
        onchip_RAM_s1_arb_share_counter <= onchip_RAM_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --onchip_RAM_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      onchip_RAM_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((onchip_RAM_s1_master_qreq_vector AND onchip_RAM_s1_end_xfer)) = '1' then 
        onchip_RAM_s1_slavearbiterlockenable <= or_reduce(onchip_RAM_s1_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master onchip_RAM/s1 arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= onchip_RAM_s1_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --onchip_RAM_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  onchip_RAM_s1_any_continuerequest <= std_logic'('0');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('0');
  internal_cpu_data_master_qualified_request_onchip_RAM_s1 <= internal_cpu_data_master_requests_onchip_RAM_s1 AND NOT ((((cpu_data_master_read AND (cpu_data_master_read_data_valid_onchip_RAM_s1_shift_register))) OR (((NOT cpu_data_master_waitrequest) AND cpu_data_master_write))));
  --cpu_data_master_read_data_valid_onchip_RAM_s1_shift_register_in mux for readlatency shift register, which is an e_mux
  cpu_data_master_read_data_valid_onchip_RAM_s1_shift_register_in <= ((internal_cpu_data_master_granted_onchip_RAM_s1 AND cpu_data_master_read) AND NOT onchip_RAM_s1_waits_for_read) AND NOT (cpu_data_master_read_data_valid_onchip_RAM_s1_shift_register);
  --shift register p1 cpu_data_master_read_data_valid_onchip_RAM_s1_shift_register in if flush, otherwise shift left, which is an e_mux
  p1_cpu_data_master_read_data_valid_onchip_RAM_s1_shift_register <= Vector_To_Std_Logic(Std_Logic_Vector'(A_ToStdLogicVector(cpu_data_master_read_data_valid_onchip_RAM_s1_shift_register) & A_ToStdLogicVector(cpu_data_master_read_data_valid_onchip_RAM_s1_shift_register_in)));
  --cpu_data_master_read_data_valid_onchip_RAM_s1_shift_register for remembering which master asked for a fixed latency read, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_data_master_read_data_valid_onchip_RAM_s1_shift_register <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        cpu_data_master_read_data_valid_onchip_RAM_s1_shift_register <= p1_cpu_data_master_read_data_valid_onchip_RAM_s1_shift_register;
      end if;
    end if;

  end process;

  --local readdatavalid cpu_data_master_read_data_valid_onchip_RAM_s1, which is an e_mux
  cpu_data_master_read_data_valid_onchip_RAM_s1 <= cpu_data_master_read_data_valid_onchip_RAM_s1_shift_register;
  --onchip_RAM_s1_writedata mux, which is an e_mux
  onchip_RAM_s1_writedata <= cpu_data_master_writedata;
  --mux onchip_RAM_s1_clken, which is an e_mux
  onchip_RAM_s1_clken <= std_logic'('1');
  --master is always granted when requested
  internal_cpu_data_master_granted_onchip_RAM_s1 <= internal_cpu_data_master_qualified_request_onchip_RAM_s1;
  --cpu/data_master saved-grant onchip_RAM/s1, which is an e_assign
  cpu_data_master_saved_grant_onchip_RAM_s1 <= internal_cpu_data_master_requests_onchip_RAM_s1;
  --allow new arb cycle for onchip_RAM/s1, which is an e_assign
  onchip_RAM_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  onchip_RAM_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  onchip_RAM_s1_master_qreq_vector <= std_logic'('1');
  onchip_RAM_s1_chipselect <= internal_cpu_data_master_granted_onchip_RAM_s1;
  --onchip_RAM_s1_firsttransfer first transaction, which is an e_assign
  onchip_RAM_s1_firsttransfer <= NOT ((onchip_RAM_s1_slavearbiterlockenable AND onchip_RAM_s1_any_continuerequest));
  --onchip_RAM_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  onchip_RAM_s1_beginbursttransfer_internal <= onchip_RAM_s1_begins_xfer AND onchip_RAM_s1_firsttransfer;
  --onchip_RAM_s1_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  onchip_RAM_s1_arbitration_holdoff_internal <= onchip_RAM_s1_begins_xfer AND onchip_RAM_s1_firsttransfer;
  --onchip_RAM_s1_write assignment, which is an e_mux
  onchip_RAM_s1_write <= internal_cpu_data_master_granted_onchip_RAM_s1 AND cpu_data_master_write;
  --onchip_RAM_s1_address mux, which is an e_mux
  onchip_RAM_s1_address <= A_EXT (A_SRL(cpu_data_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010")), 14);
  --d1_onchip_RAM_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_onchip_RAM_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_onchip_RAM_s1_end_xfer <= onchip_RAM_s1_end_xfer;
      end if;
    end if;

  end process;

  --onchip_RAM_s1_waits_for_read in a cycle, which is an e_mux
  onchip_RAM_s1_waits_for_read <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(onchip_RAM_s1_in_a_read_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --onchip_RAM_s1_in_a_read_cycle assignment, which is an e_assign
  onchip_RAM_s1_in_a_read_cycle <= internal_cpu_data_master_granted_onchip_RAM_s1 AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= onchip_RAM_s1_in_a_read_cycle;
  --onchip_RAM_s1_waits_for_write in a cycle, which is an e_mux
  onchip_RAM_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(onchip_RAM_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --onchip_RAM_s1_in_a_write_cycle assignment, which is an e_assign
  onchip_RAM_s1_in_a_write_cycle <= internal_cpu_data_master_granted_onchip_RAM_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= onchip_RAM_s1_in_a_write_cycle;
  wait_for_onchip_RAM_s1_counter <= std_logic'('0');
  --onchip_RAM_s1_byteenable byte enable port mux, which is an e_mux
  onchip_RAM_s1_byteenable <= A_EXT (A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_onchip_RAM_s1)) = '1'), (std_logic_vector'("0000000000000000000000000000") & (cpu_data_master_byteenable)), -SIGNED(std_logic_vector'("00000000000000000000000000000001"))), 4);
  --vhdl renameroo for output signals
  cpu_data_master_granted_onchip_RAM_s1 <= internal_cpu_data_master_granted_onchip_RAM_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_onchip_RAM_s1 <= internal_cpu_data_master_qualified_request_onchip_RAM_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_onchip_RAM_s1 <= internal_cpu_data_master_requests_onchip_RAM_s1;

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library std;
use std.textio.all;

entity onchip_ROM_s1_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_data_master_debugaccess : IN STD_LOGIC;
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_waitrequest : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_instruction_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_instruction_master_read : IN STD_LOGIC;
                 signal onchip_ROM_s1_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal cpu_data_master_granted_onchip_ROM_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_onchip_ROM_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_onchip_ROM_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_onchip_ROM_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_granted_onchip_ROM_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_onchip_ROM_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_onchip_ROM_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_requests_onchip_ROM_s1 : OUT STD_LOGIC;
                 signal d1_onchip_ROM_s1_end_xfer : OUT STD_LOGIC;
                 signal onchip_ROM_s1_address : OUT STD_LOGIC_VECTOR (13 DOWNTO 0);
                 signal onchip_ROM_s1_byteenable : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal onchip_ROM_s1_chipselect : OUT STD_LOGIC;
                 signal onchip_ROM_s1_clken : OUT STD_LOGIC;
                 signal onchip_ROM_s1_debugaccess : OUT STD_LOGIC;
                 signal onchip_ROM_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal onchip_ROM_s1_write : OUT STD_LOGIC;
                 signal onchip_ROM_s1_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal registered_cpu_data_master_read_data_valid_onchip_ROM_s1 : OUT STD_LOGIC
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of onchip_ROM_s1_arbitrator : entity is FALSE;
end entity onchip_ROM_s1_arbitrator;


architecture europa of onchip_ROM_s1_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_onchip_ROM_s1_shift_register :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_onchip_ROM_s1_shift_register_in :  STD_LOGIC;
                signal cpu_data_master_saved_grant_onchip_ROM_s1 :  STD_LOGIC;
                signal cpu_instruction_master_arbiterlock :  STD_LOGIC;
                signal cpu_instruction_master_continuerequest :  STD_LOGIC;
                signal cpu_instruction_master_read_data_valid_onchip_ROM_s1_shift_register :  STD_LOGIC;
                signal cpu_instruction_master_read_data_valid_onchip_ROM_s1_shift_register_in :  STD_LOGIC;
                signal cpu_instruction_master_saved_grant_onchip_ROM_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_onchip_ROM_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_onchip_ROM_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_onchip_ROM_s1 :  STD_LOGIC;
                signal internal_cpu_instruction_master_granted_onchip_ROM_s1 :  STD_LOGIC;
                signal internal_cpu_instruction_master_qualified_request_onchip_ROM_s1 :  STD_LOGIC;
                signal internal_cpu_instruction_master_requests_onchip_ROM_s1 :  STD_LOGIC;
                signal last_cycle_cpu_data_master_granted_slave_onchip_ROM_s1 :  STD_LOGIC;
                signal last_cycle_cpu_instruction_master_granted_slave_onchip_ROM_s1 :  STD_LOGIC;
                signal onchip_ROM_s1_allgrants :  STD_LOGIC;
                signal onchip_ROM_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal onchip_ROM_s1_any_continuerequest :  STD_LOGIC;
                signal onchip_ROM_s1_arb_addend :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal onchip_ROM_s1_arb_counter_enable :  STD_LOGIC;
                signal onchip_ROM_s1_arb_share_counter :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal onchip_ROM_s1_arb_share_counter_next_value :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal onchip_ROM_s1_arb_share_set_values :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal onchip_ROM_s1_arb_winner :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal onchip_ROM_s1_arbitration_holdoff_internal :  STD_LOGIC;
                signal onchip_ROM_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal onchip_ROM_s1_begins_xfer :  STD_LOGIC;
                signal onchip_ROM_s1_chosen_master_double_vector :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal onchip_ROM_s1_chosen_master_rot_left :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal onchip_ROM_s1_end_xfer :  STD_LOGIC;
                signal onchip_ROM_s1_firsttransfer :  STD_LOGIC;
                signal onchip_ROM_s1_grant_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal onchip_ROM_s1_in_a_read_cycle :  STD_LOGIC;
                signal onchip_ROM_s1_in_a_write_cycle :  STD_LOGIC;
                signal onchip_ROM_s1_master_qreq_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal onchip_ROM_s1_saved_chosen_master_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal onchip_ROM_s1_slavearbiterlockenable :  STD_LOGIC;
                signal onchip_ROM_s1_waits_for_read :  STD_LOGIC;
                signal onchip_ROM_s1_waits_for_write :  STD_LOGIC;
                signal p1_cpu_data_master_read_data_valid_onchip_ROM_s1_shift_register :  STD_LOGIC;
                signal p1_cpu_instruction_master_read_data_valid_onchip_ROM_s1_shift_register :  STD_LOGIC;
                signal wait_for_onchip_ROM_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT onchip_ROM_s1_end_xfer;
      end if;
    end if;

  end process;

  onchip_ROM_s1_begins_xfer <= NOT d1_reasons_to_wait AND ((internal_cpu_data_master_qualified_request_onchip_ROM_s1 OR internal_cpu_instruction_master_qualified_request_onchip_ROM_s1));
  internal_cpu_data_master_requests_onchip_ROM_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(23 DOWNTO 16) & std_logic_vector'("0000000000000000")) = std_logic_vector'("000000000000000000000000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --assign onchip_ROM_s1_readdata_from_sa = onchip_ROM_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  onchip_ROM_s1_readdata_from_sa <= onchip_ROM_s1_readdata;
  --registered rdv signal_name registered_cpu_data_master_read_data_valid_onchip_ROM_s1 assignment, which is an e_assign
  registered_cpu_data_master_read_data_valid_onchip_ROM_s1 <= cpu_data_master_read_data_valid_onchip_ROM_s1_shift_register_in;
  --onchip_ROM_s1_arb_share_counter set values, which is an e_mux
  onchip_ROM_s1_arb_share_set_values <= std_logic_vector'("01");
  --onchip_ROM_s1_arb_share_counter_next_value assignment, which is an e_assign
  onchip_ROM_s1_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(onchip_ROM_s1_firsttransfer) = '1'), (((std_logic_vector'("0000000000000000000000000000000") & (onchip_ROM_s1_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(onchip_ROM_s1_arb_share_counter)) = '1'), (((std_logic_vector'("0000000000000000000000000000000") & (onchip_ROM_s1_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 2);
  --onchip_ROM_s1_allgrants all slave grants, which is an e_mux
  onchip_ROM_s1_allgrants <= ((or_reduce(onchip_ROM_s1_grant_vector) OR or_reduce(onchip_ROM_s1_grant_vector)) OR or_reduce(onchip_ROM_s1_grant_vector)) OR or_reduce(onchip_ROM_s1_grant_vector);
  --onchip_ROM_s1_end_xfer assignment, which is an e_assign
  onchip_ROM_s1_end_xfer <= NOT ((onchip_ROM_s1_waits_for_read OR onchip_ROM_s1_waits_for_write));
  --onchip_ROM_s1_arb_share_counter arbitration counter enable, which is an e_assign
  onchip_ROM_s1_arb_counter_enable <= onchip_ROM_s1_end_xfer AND onchip_ROM_s1_allgrants;
  --onchip_ROM_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      onchip_ROM_s1_arb_share_counter <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if std_logic'(onchip_ROM_s1_arb_counter_enable) = '1' then 
        onchip_ROM_s1_arb_share_counter <= onchip_ROM_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --onchip_ROM_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      onchip_ROM_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((or_reduce(onchip_ROM_s1_master_qreq_vector) AND onchip_ROM_s1_end_xfer)) = '1' then 
        onchip_ROM_s1_slavearbiterlockenable <= or_reduce(onchip_ROM_s1_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master onchip_ROM/s1 arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= onchip_ROM_s1_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --cpu/instruction_master onchip_ROM/s1 arbiterlock, which is an e_assign
  cpu_instruction_master_arbiterlock <= onchip_ROM_s1_slavearbiterlockenable AND cpu_instruction_master_continuerequest;
  --cpu/instruction_master granted onchip_ROM/s1 last time, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      last_cycle_cpu_instruction_master_granted_slave_onchip_ROM_s1 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        last_cycle_cpu_instruction_master_granted_slave_onchip_ROM_s1 <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(cpu_instruction_master_saved_grant_onchip_ROM_s1) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'(((onchip_ROM_s1_arbitration_holdoff_internal OR NOT internal_cpu_instruction_master_requests_onchip_ROM_s1))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(last_cycle_cpu_instruction_master_granted_slave_onchip_ROM_s1))))));
      end if;
    end if;

  end process;

  --cpu_instruction_master_continuerequest continued request, which is an e_mux
  cpu_instruction_master_continuerequest <= last_cycle_cpu_instruction_master_granted_slave_onchip_ROM_s1 AND internal_cpu_instruction_master_requests_onchip_ROM_s1;
  --onchip_ROM_s1_any_continuerequest at least one master continues requesting, which is an e_mux
  onchip_ROM_s1_any_continuerequest <= cpu_instruction_master_continuerequest OR cpu_data_master_continuerequest;
  internal_cpu_data_master_qualified_request_onchip_ROM_s1 <= internal_cpu_data_master_requests_onchip_ROM_s1 AND NOT (((((cpu_data_master_read AND (cpu_data_master_read_data_valid_onchip_ROM_s1_shift_register))) OR (((NOT cpu_data_master_waitrequest) AND cpu_data_master_write))) OR cpu_instruction_master_arbiterlock));
  --cpu_data_master_read_data_valid_onchip_ROM_s1_shift_register_in mux for readlatency shift register, which is an e_mux
  cpu_data_master_read_data_valid_onchip_ROM_s1_shift_register_in <= ((internal_cpu_data_master_granted_onchip_ROM_s1 AND cpu_data_master_read) AND NOT onchip_ROM_s1_waits_for_read) AND NOT (cpu_data_master_read_data_valid_onchip_ROM_s1_shift_register);
  --shift register p1 cpu_data_master_read_data_valid_onchip_ROM_s1_shift_register in if flush, otherwise shift left, which is an e_mux
  p1_cpu_data_master_read_data_valid_onchip_ROM_s1_shift_register <= Vector_To_Std_Logic(Std_Logic_Vector'(A_ToStdLogicVector(cpu_data_master_read_data_valid_onchip_ROM_s1_shift_register) & A_ToStdLogicVector(cpu_data_master_read_data_valid_onchip_ROM_s1_shift_register_in)));
  --cpu_data_master_read_data_valid_onchip_ROM_s1_shift_register for remembering which master asked for a fixed latency read, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_data_master_read_data_valid_onchip_ROM_s1_shift_register <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        cpu_data_master_read_data_valid_onchip_ROM_s1_shift_register <= p1_cpu_data_master_read_data_valid_onchip_ROM_s1_shift_register;
      end if;
    end if;

  end process;

  --local readdatavalid cpu_data_master_read_data_valid_onchip_ROM_s1, which is an e_mux
  cpu_data_master_read_data_valid_onchip_ROM_s1 <= cpu_data_master_read_data_valid_onchip_ROM_s1_shift_register;
  --onchip_ROM_s1_writedata mux, which is an e_mux
  onchip_ROM_s1_writedata <= cpu_data_master_writedata;
  --mux onchip_ROM_s1_clken, which is an e_mux
  onchip_ROM_s1_clken <= std_logic'('1');
  --mux onchip_ROM_s1_debugaccess, which is an e_mux
  onchip_ROM_s1_debugaccess <= cpu_data_master_debugaccess;
  internal_cpu_instruction_master_requests_onchip_ROM_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_instruction_master_address_to_slave(23 DOWNTO 16) & std_logic_vector'("0000000000000000")) = std_logic_vector'("000000000000000000000000")))) AND (cpu_instruction_master_read);
  --cpu/data_master granted onchip_ROM/s1 last time, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      last_cycle_cpu_data_master_granted_slave_onchip_ROM_s1 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        last_cycle_cpu_data_master_granted_slave_onchip_ROM_s1 <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(cpu_data_master_saved_grant_onchip_ROM_s1) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'(((onchip_ROM_s1_arbitration_holdoff_internal OR NOT internal_cpu_data_master_requests_onchip_ROM_s1))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(last_cycle_cpu_data_master_granted_slave_onchip_ROM_s1))))));
      end if;
    end if;

  end process;

  --cpu_data_master_continuerequest continued request, which is an e_mux
  cpu_data_master_continuerequest <= last_cycle_cpu_data_master_granted_slave_onchip_ROM_s1 AND internal_cpu_data_master_requests_onchip_ROM_s1;
  internal_cpu_instruction_master_qualified_request_onchip_ROM_s1 <= internal_cpu_instruction_master_requests_onchip_ROM_s1 AND NOT ((((cpu_instruction_master_read AND (cpu_instruction_master_read_data_valid_onchip_ROM_s1_shift_register))) OR cpu_data_master_arbiterlock));
  --cpu_instruction_master_read_data_valid_onchip_ROM_s1_shift_register_in mux for readlatency shift register, which is an e_mux
  cpu_instruction_master_read_data_valid_onchip_ROM_s1_shift_register_in <= ((internal_cpu_instruction_master_granted_onchip_ROM_s1 AND cpu_instruction_master_read) AND NOT onchip_ROM_s1_waits_for_read) AND NOT (cpu_instruction_master_read_data_valid_onchip_ROM_s1_shift_register);
  --shift register p1 cpu_instruction_master_read_data_valid_onchip_ROM_s1_shift_register in if flush, otherwise shift left, which is an e_mux
  p1_cpu_instruction_master_read_data_valid_onchip_ROM_s1_shift_register <= Vector_To_Std_Logic(Std_Logic_Vector'(A_ToStdLogicVector(cpu_instruction_master_read_data_valid_onchip_ROM_s1_shift_register) & A_ToStdLogicVector(cpu_instruction_master_read_data_valid_onchip_ROM_s1_shift_register_in)));
  --cpu_instruction_master_read_data_valid_onchip_ROM_s1_shift_register for remembering which master asked for a fixed latency read, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_instruction_master_read_data_valid_onchip_ROM_s1_shift_register <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        cpu_instruction_master_read_data_valid_onchip_ROM_s1_shift_register <= p1_cpu_instruction_master_read_data_valid_onchip_ROM_s1_shift_register;
      end if;
    end if;

  end process;

  --local readdatavalid cpu_instruction_master_read_data_valid_onchip_ROM_s1, which is an e_mux
  cpu_instruction_master_read_data_valid_onchip_ROM_s1 <= cpu_instruction_master_read_data_valid_onchip_ROM_s1_shift_register;
  --allow new arb cycle for onchip_ROM/s1, which is an e_assign
  onchip_ROM_s1_allow_new_arb_cycle <= NOT cpu_data_master_arbiterlock AND NOT cpu_instruction_master_arbiterlock;
  --cpu/instruction_master assignment into master qualified-requests vector for onchip_ROM/s1, which is an e_assign
  onchip_ROM_s1_master_qreq_vector(0) <= internal_cpu_instruction_master_qualified_request_onchip_ROM_s1;
  --cpu/instruction_master grant onchip_ROM/s1, which is an e_assign
  internal_cpu_instruction_master_granted_onchip_ROM_s1 <= onchip_ROM_s1_grant_vector(0);
  --cpu/instruction_master saved-grant onchip_ROM/s1, which is an e_assign
  cpu_instruction_master_saved_grant_onchip_ROM_s1 <= onchip_ROM_s1_arb_winner(0) AND internal_cpu_instruction_master_requests_onchip_ROM_s1;
  --cpu/data_master assignment into master qualified-requests vector for onchip_ROM/s1, which is an e_assign
  onchip_ROM_s1_master_qreq_vector(1) <= internal_cpu_data_master_qualified_request_onchip_ROM_s1;
  --cpu/data_master grant onchip_ROM/s1, which is an e_assign
  internal_cpu_data_master_granted_onchip_ROM_s1 <= onchip_ROM_s1_grant_vector(1);
  --cpu/data_master saved-grant onchip_ROM/s1, which is an e_assign
  cpu_data_master_saved_grant_onchip_ROM_s1 <= onchip_ROM_s1_arb_winner(1) AND internal_cpu_data_master_requests_onchip_ROM_s1;
  --onchip_ROM/s1 chosen-master double-vector, which is an e_assign
  onchip_ROM_s1_chosen_master_double_vector <= A_EXT (((std_logic_vector'("0") & ((onchip_ROM_s1_master_qreq_vector & onchip_ROM_s1_master_qreq_vector))) AND (((std_logic_vector'("0") & (Std_Logic_Vector'(NOT onchip_ROM_s1_master_qreq_vector & NOT onchip_ROM_s1_master_qreq_vector))) + (std_logic_vector'("000") & (onchip_ROM_s1_arb_addend))))), 4);
  --stable onehot encoding of arb winner
  onchip_ROM_s1_arb_winner <= A_WE_StdLogicVector((std_logic'(((onchip_ROM_s1_allow_new_arb_cycle AND or_reduce(onchip_ROM_s1_grant_vector)))) = '1'), onchip_ROM_s1_grant_vector, onchip_ROM_s1_saved_chosen_master_vector);
  --saved onchip_ROM_s1_grant_vector, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      onchip_ROM_s1_saved_chosen_master_vector <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if std_logic'(onchip_ROM_s1_allow_new_arb_cycle) = '1' then 
        onchip_ROM_s1_saved_chosen_master_vector <= A_WE_StdLogicVector((std_logic'(or_reduce(onchip_ROM_s1_grant_vector)) = '1'), onchip_ROM_s1_grant_vector, onchip_ROM_s1_saved_chosen_master_vector);
      end if;
    end if;

  end process;

  --onehot encoding of chosen master
  onchip_ROM_s1_grant_vector <= Std_Logic_Vector'(A_ToStdLogicVector(((onchip_ROM_s1_chosen_master_double_vector(1) OR onchip_ROM_s1_chosen_master_double_vector(3)))) & A_ToStdLogicVector(((onchip_ROM_s1_chosen_master_double_vector(0) OR onchip_ROM_s1_chosen_master_double_vector(2)))));
  --onchip_ROM/s1 chosen master rotated left, which is an e_assign
  onchip_ROM_s1_chosen_master_rot_left <= A_EXT (A_WE_StdLogicVector((((A_SLL(onchip_ROM_s1_arb_winner,std_logic_vector'("00000000000000000000000000000001")))) /= std_logic_vector'("00")), (std_logic_vector'("000000000000000000000000000000") & ((A_SLL(onchip_ROM_s1_arb_winner,std_logic_vector'("00000000000000000000000000000001"))))), std_logic_vector'("00000000000000000000000000000001")), 2);
  --onchip_ROM/s1's addend for next-master-grant
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      onchip_ROM_s1_arb_addend <= std_logic_vector'("01");
    elsif clk'event and clk = '1' then
      if std_logic'(or_reduce(onchip_ROM_s1_grant_vector)) = '1' then 
        onchip_ROM_s1_arb_addend <= A_WE_StdLogicVector((std_logic'(onchip_ROM_s1_end_xfer) = '1'), onchip_ROM_s1_chosen_master_rot_left, onchip_ROM_s1_grant_vector);
      end if;
    end if;

  end process;

  onchip_ROM_s1_chipselect <= internal_cpu_data_master_granted_onchip_ROM_s1 OR internal_cpu_instruction_master_granted_onchip_ROM_s1;
  --onchip_ROM_s1_firsttransfer first transaction, which is an e_assign
  onchip_ROM_s1_firsttransfer <= NOT ((onchip_ROM_s1_slavearbiterlockenable AND onchip_ROM_s1_any_continuerequest));
  --onchip_ROM_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  onchip_ROM_s1_beginbursttransfer_internal <= onchip_ROM_s1_begins_xfer AND onchip_ROM_s1_firsttransfer;
  --onchip_ROM_s1_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  onchip_ROM_s1_arbitration_holdoff_internal <= onchip_ROM_s1_begins_xfer AND onchip_ROM_s1_firsttransfer;
  --onchip_ROM_s1_write assignment, which is an e_mux
  onchip_ROM_s1_write <= internal_cpu_data_master_granted_onchip_ROM_s1 AND cpu_data_master_write;
  --onchip_ROM_s1_address mux, which is an e_mux
  onchip_ROM_s1_address <= A_EXT (A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_onchip_ROM_s1)) = '1'), (A_SRL(cpu_data_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010"))), (A_SRL(cpu_instruction_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010")))), 14);
  --d1_onchip_ROM_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_onchip_ROM_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_onchip_ROM_s1_end_xfer <= onchip_ROM_s1_end_xfer;
      end if;
    end if;

  end process;

  --onchip_ROM_s1_waits_for_read in a cycle, which is an e_mux
  onchip_ROM_s1_waits_for_read <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(onchip_ROM_s1_in_a_read_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --onchip_ROM_s1_in_a_read_cycle assignment, which is an e_assign
  onchip_ROM_s1_in_a_read_cycle <= ((internal_cpu_data_master_granted_onchip_ROM_s1 AND cpu_data_master_read)) OR ((internal_cpu_instruction_master_granted_onchip_ROM_s1 AND cpu_instruction_master_read));
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= onchip_ROM_s1_in_a_read_cycle;
  --onchip_ROM_s1_waits_for_write in a cycle, which is an e_mux
  onchip_ROM_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(onchip_ROM_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --onchip_ROM_s1_in_a_write_cycle assignment, which is an e_assign
  onchip_ROM_s1_in_a_write_cycle <= internal_cpu_data_master_granted_onchip_ROM_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= onchip_ROM_s1_in_a_write_cycle;
  wait_for_onchip_ROM_s1_counter <= std_logic'('0');
  --onchip_ROM_s1_byteenable byte enable port mux, which is an e_mux
  onchip_ROM_s1_byteenable <= A_EXT (A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_onchip_ROM_s1)) = '1'), (std_logic_vector'("0000000000000000000000000000") & (cpu_data_master_byteenable)), -SIGNED(std_logic_vector'("00000000000000000000000000000001"))), 4);
  --vhdl renameroo for output signals
  cpu_data_master_granted_onchip_ROM_s1 <= internal_cpu_data_master_granted_onchip_ROM_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_onchip_ROM_s1 <= internal_cpu_data_master_qualified_request_onchip_ROM_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_onchip_ROM_s1 <= internal_cpu_data_master_requests_onchip_ROM_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_granted_onchip_ROM_s1 <= internal_cpu_instruction_master_granted_onchip_ROM_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_qualified_request_onchip_ROM_s1 <= internal_cpu_instruction_master_qualified_request_onchip_ROM_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_requests_onchip_ROM_s1 <= internal_cpu_instruction_master_requests_onchip_ROM_s1;
--synthesis translate_off
    --grant signals are active simultaneously, which is an e_process
    process (clk)
    VARIABLE write_line4 : line;
    begin
      if clk'event and clk = '1' then
        if (std_logic_vector'("000000000000000000000000000000") & (((std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(internal_cpu_data_master_granted_onchip_ROM_s1))) + (std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(internal_cpu_instruction_master_granted_onchip_ROM_s1))))))>std_logic_vector'("00000000000000000000000000000001") then 
          write(write_line4, now);
          write(write_line4, string'(": "));
          write(write_line4, string'("> 1 of grant signals are active simultaneously"));
          write(output, write_line4.all);
          deallocate (write_line4);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

    --saved_grant signals are active simultaneously, which is an e_process
    process (clk)
    VARIABLE write_line5 : line;
    begin
      if clk'event and clk = '1' then
        if (std_logic_vector'("000000000000000000000000000000") & (((std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(cpu_data_master_saved_grant_onchip_ROM_s1))) + (std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(cpu_instruction_master_saved_grant_onchip_ROM_s1))))))>std_logic_vector'("00000000000000000000000000000001") then 
          write(write_line5, now);
          write(write_line5, string'(": "));
          write(write_line5, string'("> 1 of saved_grant signals are active simultaneously"));
          write(output, write_line5.all);
          deallocate (write_line5);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

--synthesis translate_on

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity sysid_control_slave_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;
                 signal sysid_control_slave_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

              -- outputs:
                 signal cpu_data_master_granted_sysid_control_slave : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_sysid_control_slave : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_sysid_control_slave : OUT STD_LOGIC;
                 signal cpu_data_master_requests_sysid_control_slave : OUT STD_LOGIC;
                 signal d1_sysid_control_slave_end_xfer : OUT STD_LOGIC;
                 signal sysid_control_slave_address : OUT STD_LOGIC;
                 signal sysid_control_slave_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of sysid_control_slave_arbitrator : entity is FALSE;
end entity sysid_control_slave_arbitrator;


architecture europa of sysid_control_slave_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_sysid_control_slave :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_sysid_control_slave :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_sysid_control_slave :  STD_LOGIC;
                signal internal_cpu_data_master_requests_sysid_control_slave :  STD_LOGIC;
                signal sysid_control_slave_allgrants :  STD_LOGIC;
                signal sysid_control_slave_allow_new_arb_cycle :  STD_LOGIC;
                signal sysid_control_slave_any_continuerequest :  STD_LOGIC;
                signal sysid_control_slave_arb_counter_enable :  STD_LOGIC;
                signal sysid_control_slave_arb_share_counter :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal sysid_control_slave_arb_share_counter_next_value :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal sysid_control_slave_arb_share_set_values :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal sysid_control_slave_arbitration_holdoff_internal :  STD_LOGIC;
                signal sysid_control_slave_beginbursttransfer_internal :  STD_LOGIC;
                signal sysid_control_slave_begins_xfer :  STD_LOGIC;
                signal sysid_control_slave_end_xfer :  STD_LOGIC;
                signal sysid_control_slave_firsttransfer :  STD_LOGIC;
                signal sysid_control_slave_grant_vector :  STD_LOGIC;
                signal sysid_control_slave_in_a_read_cycle :  STD_LOGIC;
                signal sysid_control_slave_in_a_write_cycle :  STD_LOGIC;
                signal sysid_control_slave_master_qreq_vector :  STD_LOGIC;
                signal sysid_control_slave_slavearbiterlockenable :  STD_LOGIC;
                signal sysid_control_slave_waits_for_read :  STD_LOGIC;
                signal sysid_control_slave_waits_for_write :  STD_LOGIC;
                signal wait_for_sysid_control_slave_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT sysid_control_slave_end_xfer;
      end if;
    end if;

  end process;

  sysid_control_slave_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_sysid_control_slave);
  internal_cpu_data_master_requests_sysid_control_slave <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(23 DOWNTO 3) & std_logic_vector'("000")) = std_logic_vector'("000010000000000000000000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --assign sysid_control_slave_readdata_from_sa = sysid_control_slave_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  sysid_control_slave_readdata_from_sa <= sysid_control_slave_readdata;
  --sysid_control_slave_arb_share_counter set values, which is an e_mux
  sysid_control_slave_arb_share_set_values <= std_logic_vector'("01");
  --sysid_control_slave_arb_share_counter_next_value assignment, which is an e_assign
  sysid_control_slave_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(sysid_control_slave_firsttransfer) = '1'), (((std_logic_vector'("0000000000000000000000000000000") & (sysid_control_slave_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(sysid_control_slave_arb_share_counter)) = '1'), (((std_logic_vector'("0000000000000000000000000000000") & (sysid_control_slave_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 2);
  --sysid_control_slave_allgrants all slave grants, which is an e_mux
  sysid_control_slave_allgrants <= sysid_control_slave_grant_vector;
  --sysid_control_slave_end_xfer assignment, which is an e_assign
  sysid_control_slave_end_xfer <= NOT ((sysid_control_slave_waits_for_read OR sysid_control_slave_waits_for_write));
  --sysid_control_slave_arb_share_counter arbitration counter enable, which is an e_assign
  sysid_control_slave_arb_counter_enable <= sysid_control_slave_end_xfer AND sysid_control_slave_allgrants;
  --sysid_control_slave_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      sysid_control_slave_arb_share_counter <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if std_logic'(sysid_control_slave_arb_counter_enable) = '1' then 
        sysid_control_slave_arb_share_counter <= sysid_control_slave_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --sysid_control_slave_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      sysid_control_slave_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((sysid_control_slave_master_qreq_vector AND sysid_control_slave_end_xfer)) = '1' then 
        sysid_control_slave_slavearbiterlockenable <= or_reduce(sysid_control_slave_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master sysid/control_slave arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= sysid_control_slave_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --sysid_control_slave_any_continuerequest at least one master continues requesting, which is an e_assign
  sysid_control_slave_any_continuerequest <= std_logic'('0');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('0');
  internal_cpu_data_master_qualified_request_sysid_control_slave <= internal_cpu_data_master_requests_sysid_control_slave;
  --master is always granted when requested
  internal_cpu_data_master_granted_sysid_control_slave <= internal_cpu_data_master_qualified_request_sysid_control_slave;
  --cpu/data_master saved-grant sysid/control_slave, which is an e_assign
  cpu_data_master_saved_grant_sysid_control_slave <= internal_cpu_data_master_requests_sysid_control_slave;
  --allow new arb cycle for sysid/control_slave, which is an e_assign
  sysid_control_slave_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  sysid_control_slave_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  sysid_control_slave_master_qreq_vector <= std_logic'('1');
  --sysid_control_slave_firsttransfer first transaction, which is an e_assign
  sysid_control_slave_firsttransfer <= NOT ((sysid_control_slave_slavearbiterlockenable AND sysid_control_slave_any_continuerequest));
  --sysid_control_slave_beginbursttransfer_internal begin burst transfer, which is an e_assign
  sysid_control_slave_beginbursttransfer_internal <= sysid_control_slave_begins_xfer AND sysid_control_slave_firsttransfer;
  --sysid_control_slave_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  sysid_control_slave_arbitration_holdoff_internal <= sysid_control_slave_begins_xfer AND sysid_control_slave_firsttransfer;
  --sysid_control_slave_address mux, which is an e_mux
  sysid_control_slave_address <= Vector_To_Std_Logic(A_SRL(cpu_data_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010")));
  --d1_sysid_control_slave_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_sysid_control_slave_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_sysid_control_slave_end_xfer <= sysid_control_slave_end_xfer;
      end if;
    end if;

  end process;

  --sysid_control_slave_waits_for_read in a cycle, which is an e_mux
  sysid_control_slave_waits_for_read <= sysid_control_slave_in_a_read_cycle AND sysid_control_slave_begins_xfer;
  --sysid_control_slave_in_a_read_cycle assignment, which is an e_assign
  sysid_control_slave_in_a_read_cycle <= internal_cpu_data_master_granted_sysid_control_slave AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= sysid_control_slave_in_a_read_cycle;
  --sysid_control_slave_waits_for_write in a cycle, which is an e_mux
  sysid_control_slave_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(sysid_control_slave_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --sysid_control_slave_in_a_write_cycle assignment, which is an e_assign
  sysid_control_slave_in_a_write_cycle <= internal_cpu_data_master_granted_sysid_control_slave AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= sysid_control_slave_in_a_write_cycle;
  wait_for_sysid_control_slave_counter <= std_logic'('0');
  --vhdl renameroo for output signals
  cpu_data_master_granted_sysid_control_slave <= internal_cpu_data_master_granted_sysid_control_slave;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_sysid_control_slave <= internal_cpu_data_master_qualified_request_sysid_control_slave;
  --vhdl renameroo for output signals
  cpu_data_master_requests_sysid_control_slave <= internal_cpu_data_master_requests_sysid_control_slave;

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity test_0_test_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_waitrequest : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal readdata_from_the_test_0 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;
                 signal wreq_from_the_test_0 : IN STD_LOGIC;

              -- outputs:
                 signal addr_to_the_test_0 : OUT STD_LOGIC_VECTOR (5 DOWNTO 0);
                 signal cpu_data_master_granted_test_0_test : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_test_0_test : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_test_0_test : OUT STD_LOGIC;
                 signal cpu_data_master_requests_test_0_test : OUT STD_LOGIC;
                 signal cs_to_the_test_0 : OUT STD_LOGIC;
                 signal d1_test_0_test_end_xfer : OUT STD_LOGIC;
                 signal readdata_from_the_test_0_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal wreq_from_the_test_0_from_sa : OUT STD_LOGIC;
                 signal write_n_to_the_test_0 : OUT STD_LOGIC;
                 signal writedata_to_the_test_0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of test_0_test_arbitrator : entity is FALSE;
end entity test_0_test_arbitrator;


architecture europa of test_0_test_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_test_0_test :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_test_0_test :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_test_0_test :  STD_LOGIC;
                signal internal_cpu_data_master_requests_test_0_test :  STD_LOGIC;
                signal internal_wreq_from_the_test_0_from_sa :  STD_LOGIC;
                signal test_0_test_allgrants :  STD_LOGIC;
                signal test_0_test_allow_new_arb_cycle :  STD_LOGIC;
                signal test_0_test_any_continuerequest :  STD_LOGIC;
                signal test_0_test_arb_counter_enable :  STD_LOGIC;
                signal test_0_test_arb_share_counter :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal test_0_test_arb_share_counter_next_value :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal test_0_test_arb_share_set_values :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal test_0_test_arbitration_holdoff_internal :  STD_LOGIC;
                signal test_0_test_beginbursttransfer_internal :  STD_LOGIC;
                signal test_0_test_begins_xfer :  STD_LOGIC;
                signal test_0_test_end_xfer :  STD_LOGIC;
                signal test_0_test_firsttransfer :  STD_LOGIC;
                signal test_0_test_grant_vector :  STD_LOGIC;
                signal test_0_test_in_a_read_cycle :  STD_LOGIC;
                signal test_0_test_in_a_write_cycle :  STD_LOGIC;
                signal test_0_test_master_qreq_vector :  STD_LOGIC;
                signal test_0_test_slavearbiterlockenable :  STD_LOGIC;
                signal test_0_test_waits_for_read :  STD_LOGIC;
                signal test_0_test_waits_for_write :  STD_LOGIC;
                signal wait_for_test_0_test_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT test_0_test_end_xfer;
      end if;
    end if;

  end process;

  test_0_test_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_test_0_test);
  internal_cpu_data_master_requests_test_0_test <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(23 DOWNTO 8) & std_logic_vector'("00000000")) = std_logic_vector'("000000100000000000000000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --assign readdata_from_the_test_0_from_sa = readdata_from_the_test_0 so that symbol knows where to group signals which may go to master only, which is an e_assign
  readdata_from_the_test_0_from_sa <= readdata_from_the_test_0;
  --assign wreq_from_the_test_0_from_sa = wreq_from_the_test_0 so that symbol knows where to group signals which may go to master only, which is an e_assign
  internal_wreq_from_the_test_0_from_sa <= wreq_from_the_test_0;
  --test_0_test_arb_share_counter set values, which is an e_mux
  test_0_test_arb_share_set_values <= std_logic_vector'("01");
  --test_0_test_arb_share_counter_next_value assignment, which is an e_assign
  test_0_test_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(test_0_test_firsttransfer) = '1'), (((std_logic_vector'("0000000000000000000000000000000") & (test_0_test_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(test_0_test_arb_share_counter)) = '1'), (((std_logic_vector'("0000000000000000000000000000000") & (test_0_test_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 2);
  --test_0_test_allgrants all slave grants, which is an e_mux
  test_0_test_allgrants <= test_0_test_grant_vector;
  --test_0_test_end_xfer assignment, which is an e_assign
  test_0_test_end_xfer <= NOT ((test_0_test_waits_for_read OR test_0_test_waits_for_write));
  --test_0_test_arb_share_counter arbitration counter enable, which is an e_assign
  test_0_test_arb_counter_enable <= test_0_test_end_xfer AND test_0_test_allgrants;
  --test_0_test_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      test_0_test_arb_share_counter <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if std_logic'(test_0_test_arb_counter_enable) = '1' then 
        test_0_test_arb_share_counter <= test_0_test_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --test_0_test_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      test_0_test_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((test_0_test_master_qreq_vector AND test_0_test_end_xfer)) = '1' then 
        test_0_test_slavearbiterlockenable <= or_reduce(test_0_test_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master test_0/test arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= test_0_test_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --test_0_test_any_continuerequest at least one master continues requesting, which is an e_assign
  test_0_test_any_continuerequest <= std_logic'('0');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('0');
  internal_cpu_data_master_qualified_request_test_0_test <= internal_cpu_data_master_requests_test_0_test AND NOT ((((cpu_data_master_read AND (NOT cpu_data_master_waitrequest))) OR (((NOT cpu_data_master_waitrequest) AND cpu_data_master_write))));
  --writedata_to_the_test_0 mux, which is an e_mux
  writedata_to_the_test_0 <= cpu_data_master_writedata;
  --master is always granted when requested
  internal_cpu_data_master_granted_test_0_test <= internal_cpu_data_master_qualified_request_test_0_test;
  --cpu/data_master saved-grant test_0/test, which is an e_assign
  cpu_data_master_saved_grant_test_0_test <= internal_cpu_data_master_requests_test_0_test;
  --allow new arb cycle for test_0/test, which is an e_assign
  test_0_test_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  test_0_test_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  test_0_test_master_qreq_vector <= std_logic'('1');
  cs_to_the_test_0 <= internal_cpu_data_master_granted_test_0_test;
  --test_0_test_firsttransfer first transaction, which is an e_assign
  test_0_test_firsttransfer <= NOT ((test_0_test_slavearbiterlockenable AND test_0_test_any_continuerequest));
  --test_0_test_beginbursttransfer_internal begin burst transfer, which is an e_assign
  test_0_test_beginbursttransfer_internal <= test_0_test_begins_xfer AND test_0_test_firsttransfer;
  --test_0_test_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  test_0_test_arbitration_holdoff_internal <= test_0_test_begins_xfer AND test_0_test_firsttransfer;
  --~write_n_to_the_test_0 assignment, which is an e_mux
  write_n_to_the_test_0 <= NOT ((internal_cpu_data_master_granted_test_0_test AND cpu_data_master_write));
  --addr_to_the_test_0 mux, which is an e_mux
  addr_to_the_test_0 <= A_EXT (A_SRL(cpu_data_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010")), 6);
  --d1_test_0_test_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_test_0_test_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_test_0_test_end_xfer <= test_0_test_end_xfer;
      end if;
    end if;

  end process;

  --test_0_test_waits_for_read in a cycle, which is an e_mux
  test_0_test_waits_for_read <= test_0_test_in_a_read_cycle AND internal_wreq_from_the_test_0_from_sa;
  --test_0_test_in_a_read_cycle assignment, which is an e_assign
  test_0_test_in_a_read_cycle <= internal_cpu_data_master_granted_test_0_test AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= test_0_test_in_a_read_cycle;
  --test_0_test_waits_for_write in a cycle, which is an e_mux
  test_0_test_waits_for_write <= test_0_test_in_a_write_cycle AND internal_wreq_from_the_test_0_from_sa;
  --test_0_test_in_a_write_cycle assignment, which is an e_assign
  test_0_test_in_a_write_cycle <= internal_cpu_data_master_granted_test_0_test AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= test_0_test_in_a_write_cycle;
  wait_for_test_0_test_counter <= std_logic'('0');
  --vhdl renameroo for output signals
  cpu_data_master_granted_test_0_test <= internal_cpu_data_master_granted_test_0_test;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_test_0_test <= internal_cpu_data_master_qualified_request_test_0_test;
  --vhdl renameroo for output signals
  cpu_data_master_requests_test_0_test <= internal_cpu_data_master_requests_test_0_test;
  --vhdl renameroo for output signals
  wreq_from_the_test_0_from_sa <= internal_wreq_from_the_test_0_from_sa;

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity timer_0_s1_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_waitrequest : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;
                 signal timer_0_s1_irq : IN STD_LOGIC;
                 signal timer_0_s1_readdata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);

              -- outputs:
                 signal cpu_data_master_granted_timer_0_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_timer_0_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_timer_0_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_timer_0_s1 : OUT STD_LOGIC;
                 signal d1_timer_0_s1_end_xfer : OUT STD_LOGIC;
                 signal timer_0_s1_address : OUT STD_LOGIC_VECTOR (2 DOWNTO 0);
                 signal timer_0_s1_chipselect : OUT STD_LOGIC;
                 signal timer_0_s1_irq_from_sa : OUT STD_LOGIC;
                 signal timer_0_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal timer_0_s1_reset_n : OUT STD_LOGIC;
                 signal timer_0_s1_write_n : OUT STD_LOGIC;
                 signal timer_0_s1_writedata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of timer_0_s1_arbitrator : entity is FALSE;
end entity timer_0_s1_arbitrator;


architecture europa of timer_0_s1_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_timer_0_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_timer_0_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_timer_0_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_timer_0_s1 :  STD_LOGIC;
                signal timer_0_s1_allgrants :  STD_LOGIC;
                signal timer_0_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal timer_0_s1_any_continuerequest :  STD_LOGIC;
                signal timer_0_s1_arb_counter_enable :  STD_LOGIC;
                signal timer_0_s1_arb_share_counter :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal timer_0_s1_arb_share_counter_next_value :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal timer_0_s1_arb_share_set_values :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal timer_0_s1_arbitration_holdoff_internal :  STD_LOGIC;
                signal timer_0_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal timer_0_s1_begins_xfer :  STD_LOGIC;
                signal timer_0_s1_end_xfer :  STD_LOGIC;
                signal timer_0_s1_firsttransfer :  STD_LOGIC;
                signal timer_0_s1_grant_vector :  STD_LOGIC;
                signal timer_0_s1_in_a_read_cycle :  STD_LOGIC;
                signal timer_0_s1_in_a_write_cycle :  STD_LOGIC;
                signal timer_0_s1_master_qreq_vector :  STD_LOGIC;
                signal timer_0_s1_slavearbiterlockenable :  STD_LOGIC;
                signal timer_0_s1_waits_for_read :  STD_LOGIC;
                signal timer_0_s1_waits_for_write :  STD_LOGIC;
                signal wait_for_timer_0_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT timer_0_s1_end_xfer;
      end if;
    end if;

  end process;

  timer_0_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_timer_0_s1);
  internal_cpu_data_master_requests_timer_0_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(23 DOWNTO 5) & std_logic_vector'("00000")) = std_logic_vector'("000010000000010000000000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --assign timer_0_s1_readdata_from_sa = timer_0_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  timer_0_s1_readdata_from_sa <= timer_0_s1_readdata;
  --timer_0_s1_arb_share_counter set values, which is an e_mux
  timer_0_s1_arb_share_set_values <= std_logic_vector'("01");
  --timer_0_s1_arb_share_counter_next_value assignment, which is an e_assign
  timer_0_s1_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(timer_0_s1_firsttransfer) = '1'), (((std_logic_vector'("0000000000000000000000000000000") & (timer_0_s1_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(timer_0_s1_arb_share_counter)) = '1'), (((std_logic_vector'("0000000000000000000000000000000") & (timer_0_s1_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 2);
  --timer_0_s1_allgrants all slave grants, which is an e_mux
  timer_0_s1_allgrants <= timer_0_s1_grant_vector;
  --timer_0_s1_end_xfer assignment, which is an e_assign
  timer_0_s1_end_xfer <= NOT ((timer_0_s1_waits_for_read OR timer_0_s1_waits_for_write));
  --timer_0_s1_arb_share_counter arbitration counter enable, which is an e_assign
  timer_0_s1_arb_counter_enable <= timer_0_s1_end_xfer AND timer_0_s1_allgrants;
  --timer_0_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      timer_0_s1_arb_share_counter <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if std_logic'(timer_0_s1_arb_counter_enable) = '1' then 
        timer_0_s1_arb_share_counter <= timer_0_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --timer_0_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      timer_0_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((timer_0_s1_master_qreq_vector AND timer_0_s1_end_xfer)) = '1' then 
        timer_0_s1_slavearbiterlockenable <= or_reduce(timer_0_s1_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master timer_0/s1 arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= timer_0_s1_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --timer_0_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  timer_0_s1_any_continuerequest <= std_logic'('0');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('0');
  internal_cpu_data_master_qualified_request_timer_0_s1 <= internal_cpu_data_master_requests_timer_0_s1 AND NOT (((NOT cpu_data_master_waitrequest) AND cpu_data_master_write));
  --timer_0_s1_writedata mux, which is an e_mux
  timer_0_s1_writedata <= cpu_data_master_writedata (15 DOWNTO 0);
  --master is always granted when requested
  internal_cpu_data_master_granted_timer_0_s1 <= internal_cpu_data_master_qualified_request_timer_0_s1;
  --cpu/data_master saved-grant timer_0/s1, which is an e_assign
  cpu_data_master_saved_grant_timer_0_s1 <= internal_cpu_data_master_requests_timer_0_s1;
  --allow new arb cycle for timer_0/s1, which is an e_assign
  timer_0_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  timer_0_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  timer_0_s1_master_qreq_vector <= std_logic'('1');
  --timer_0_s1_reset_n assignment, which is an e_assign
  timer_0_s1_reset_n <= reset_n;
  timer_0_s1_chipselect <= internal_cpu_data_master_granted_timer_0_s1;
  --timer_0_s1_firsttransfer first transaction, which is an e_assign
  timer_0_s1_firsttransfer <= NOT ((timer_0_s1_slavearbiterlockenable AND timer_0_s1_any_continuerequest));
  --timer_0_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  timer_0_s1_beginbursttransfer_internal <= timer_0_s1_begins_xfer AND timer_0_s1_firsttransfer;
  --timer_0_s1_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  timer_0_s1_arbitration_holdoff_internal <= timer_0_s1_begins_xfer AND timer_0_s1_firsttransfer;
  --~timer_0_s1_write_n assignment, which is an e_mux
  timer_0_s1_write_n <= NOT ((internal_cpu_data_master_granted_timer_0_s1 AND cpu_data_master_write));
  --timer_0_s1_address mux, which is an e_mux
  timer_0_s1_address <= A_EXT (A_SRL(cpu_data_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010")), 3);
  --d1_timer_0_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_timer_0_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_timer_0_s1_end_xfer <= timer_0_s1_end_xfer;
      end if;
    end if;

  end process;

  --timer_0_s1_waits_for_read in a cycle, which is an e_mux
  timer_0_s1_waits_for_read <= timer_0_s1_in_a_read_cycle AND timer_0_s1_begins_xfer;
  --timer_0_s1_in_a_read_cycle assignment, which is an e_assign
  timer_0_s1_in_a_read_cycle <= internal_cpu_data_master_granted_timer_0_s1 AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= timer_0_s1_in_a_read_cycle;
  --timer_0_s1_waits_for_write in a cycle, which is an e_mux
  timer_0_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(timer_0_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --timer_0_s1_in_a_write_cycle assignment, which is an e_assign
  timer_0_s1_in_a_write_cycle <= internal_cpu_data_master_granted_timer_0_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= timer_0_s1_in_a_write_cycle;
  wait_for_timer_0_s1_counter <= std_logic'('0');
  --assign timer_0_s1_irq_from_sa = timer_0_s1_irq so that symbol knows where to group signals which may go to master only, which is an e_assign
  timer_0_s1_irq_from_sa <= timer_0_s1_irq;
  --vhdl renameroo for output signals
  cpu_data_master_granted_timer_0_s1 <= internal_cpu_data_master_granted_timer_0_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_timer_0_s1 <= internal_cpu_data_master_qualified_request_timer_0_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_timer_0_s1 <= internal_cpu_data_master_requests_timer_0_s1;

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library std;
use std.textio.all;

entity tri_state_bridge_avalon_slave_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_data_master_dbs_address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_data_master_dbs_write_16 : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal cpu_data_master_no_byte_enables_and_last_term : IN STD_LOGIC;
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_instruction_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_instruction_master_dbs_address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_instruction_master_read : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal SRAM_s1_wait_counter_eq_0 : OUT STD_LOGIC;
                 signal SRAM_s1_wait_counter_eq_1 : OUT STD_LOGIC;
                 signal be_n_to_the_SRAM : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_data_master_byteenable_epc_s1 : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_data_master_granted_SRAM_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_granted_epc_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_SRAM_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_epc_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_SRAM_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_epc_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_SRAM_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_epc_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_granted_SRAM_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_granted_epc_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_SRAM_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_epc_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_SRAM_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_epc_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_requests_SRAM_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_requests_epc_s1 : OUT STD_LOGIC;
                 signal d1_tri_state_bridge_avalon_slave_end_xfer : OUT STD_LOGIC;
                 signal epc_s1_wait_counter_eq_0 : OUT STD_LOGIC;
                 signal epc_s1_wait_counter_eq_1 : OUT STD_LOGIC;
                 signal incoming_tri_state_bridge_data : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal incoming_tri_state_bridge_data_with_Xs_converted_to_0 : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal read_n_to_the_SRAM : OUT STD_LOGIC;
                 signal registered_cpu_data_master_read_data_valid_SRAM_s1 : OUT STD_LOGIC;
                 signal registered_cpu_data_master_read_data_valid_epc_s1 : OUT STD_LOGIC;
                 signal select0_n_to_the_SRAM : OUT STD_LOGIC;
                 signal select1_n_to_the_SRAM : OUT STD_LOGIC;
                 signal select_n_to_the_epc : OUT STD_LOGIC;
                 signal tri_state_bridge_address : OUT STD_LOGIC_VECTOR (20 DOWNTO 0);
                 signal tri_state_bridge_data : INOUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal tri_state_bridge_readn : OUT STD_LOGIC;
                 signal write_n_to_the_SRAM : OUT STD_LOGIC;
                 signal write_n_to_the_epc : OUT STD_LOGIC
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of tri_state_bridge_avalon_slave_arbitrator : entity is FALSE;
end entity tri_state_bridge_avalon_slave_arbitrator;


architecture europa of tri_state_bridge_avalon_slave_arbitrator is
                signal SRAM_s1_counter_load_value :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal SRAM_s1_in_a_read_cycle :  STD_LOGIC;
                signal SRAM_s1_in_a_write_cycle :  STD_LOGIC;
                signal SRAM_s1_wait_counter :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal SRAM_s1_waits_for_read :  STD_LOGIC;
                signal SRAM_s1_waits_for_write :  STD_LOGIC;
                signal SRAM_s1_with_write_latency :  STD_LOGIC;
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_byteenable_epc_s1_segment_0 :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_data_master_byteenable_epc_s1_segment_1 :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_SRAM_s1_shift_register :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_data_master_read_data_valid_SRAM_s1_shift_register_in :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_epc_s1_shift_register :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_data_master_read_data_valid_epc_s1_shift_register_in :  STD_LOGIC;
                signal cpu_data_master_saved_grant_SRAM_s1 :  STD_LOGIC;
                signal cpu_data_master_saved_grant_epc_s1 :  STD_LOGIC;
                signal cpu_instruction_master_arbiterlock :  STD_LOGIC;
                signal cpu_instruction_master_continuerequest :  STD_LOGIC;
                signal cpu_instruction_master_read_data_valid_SRAM_s1_shift_register :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_instruction_master_read_data_valid_SRAM_s1_shift_register_in :  STD_LOGIC;
                signal cpu_instruction_master_read_data_valid_epc_s1_shift_register :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_instruction_master_read_data_valid_epc_s1_shift_register_in :  STD_LOGIC;
                signal cpu_instruction_master_saved_grant_SRAM_s1 :  STD_LOGIC;
                signal cpu_instruction_master_saved_grant_epc_s1 :  STD_LOGIC;
                signal d1_in_a_write_cycle :  STD_LOGIC;
                signal d1_outgoing_tri_state_bridge_data :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal epc_s1_counter_load_value :  STD_LOGIC_VECTOR (4 DOWNTO 0);
                signal epc_s1_in_a_read_cycle :  STD_LOGIC;
                signal epc_s1_in_a_write_cycle :  STD_LOGIC;
                signal epc_s1_wait_counter :  STD_LOGIC_VECTOR (4 DOWNTO 0);
                signal epc_s1_waits_for_read :  STD_LOGIC;
                signal epc_s1_waits_for_write :  STD_LOGIC;
                signal epc_s1_with_write_latency :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal incoming_tri_state_bridge_data_bit_0_is_x :  STD_LOGIC;
                signal incoming_tri_state_bridge_data_bit_10_is_x :  STD_LOGIC;
                signal incoming_tri_state_bridge_data_bit_11_is_x :  STD_LOGIC;
                signal incoming_tri_state_bridge_data_bit_12_is_x :  STD_LOGIC;
                signal incoming_tri_state_bridge_data_bit_13_is_x :  STD_LOGIC;
                signal incoming_tri_state_bridge_data_bit_14_is_x :  STD_LOGIC;
                signal incoming_tri_state_bridge_data_bit_15_is_x :  STD_LOGIC;
                signal incoming_tri_state_bridge_data_bit_1_is_x :  STD_LOGIC;
                signal incoming_tri_state_bridge_data_bit_2_is_x :  STD_LOGIC;
                signal incoming_tri_state_bridge_data_bit_3_is_x :  STD_LOGIC;
                signal incoming_tri_state_bridge_data_bit_4_is_x :  STD_LOGIC;
                signal incoming_tri_state_bridge_data_bit_5_is_x :  STD_LOGIC;
                signal incoming_tri_state_bridge_data_bit_6_is_x :  STD_LOGIC;
                signal incoming_tri_state_bridge_data_bit_7_is_x :  STD_LOGIC;
                signal incoming_tri_state_bridge_data_bit_8_is_x :  STD_LOGIC;
                signal incoming_tri_state_bridge_data_bit_9_is_x :  STD_LOGIC;
                signal internal_SRAM_s1_wait_counter_eq_0 :  STD_LOGIC;
                signal internal_cpu_data_master_byteenable_epc_s1 :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal internal_cpu_data_master_granted_SRAM_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_granted_epc_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_SRAM_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_epc_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_SRAM_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_epc_s1 :  STD_LOGIC;
                signal internal_cpu_instruction_master_granted_SRAM_s1 :  STD_LOGIC;
                signal internal_cpu_instruction_master_granted_epc_s1 :  STD_LOGIC;
                signal internal_cpu_instruction_master_qualified_request_SRAM_s1 :  STD_LOGIC;
                signal internal_cpu_instruction_master_qualified_request_epc_s1 :  STD_LOGIC;
                signal internal_cpu_instruction_master_requests_SRAM_s1 :  STD_LOGIC;
                signal internal_cpu_instruction_master_requests_epc_s1 :  STD_LOGIC;
                signal internal_epc_s1_wait_counter_eq_0 :  STD_LOGIC;
                signal internal_incoming_tri_state_bridge_data :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal last_cycle_cpu_data_master_granted_slave_SRAM_s1 :  STD_LOGIC;
                signal last_cycle_cpu_data_master_granted_slave_epc_s1 :  STD_LOGIC;
                signal last_cycle_cpu_instruction_master_granted_slave_SRAM_s1 :  STD_LOGIC;
                signal last_cycle_cpu_instruction_master_granted_slave_epc_s1 :  STD_LOGIC;
                signal outgoing_tri_state_bridge_data :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal p1_be_n_to_the_SRAM :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal p1_cpu_data_master_read_data_valid_SRAM_s1_shift_register :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal p1_cpu_data_master_read_data_valid_epc_s1_shift_register :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal p1_cpu_instruction_master_read_data_valid_SRAM_s1_shift_register :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal p1_cpu_instruction_master_read_data_valid_epc_s1_shift_register :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal p1_read_n_to_the_SRAM :  STD_LOGIC;
                signal p1_select1_n_to_the_SRAM :  STD_LOGIC;
                signal p1_select_n_to_the_epc :  STD_LOGIC;
                signal p1_tri_state_bridge_address :  STD_LOGIC_VECTOR (20 DOWNTO 0);
                signal p1_tri_state_bridge_readn :  STD_LOGIC;
                signal p1_write_n_to_the_SRAM :  STD_LOGIC;
                signal p1_write_n_to_the_epc :  STD_LOGIC;
                signal time_to_write :  STD_LOGIC;
                signal tri_state_bridge_avalon_slave_allgrants :  STD_LOGIC;
                signal tri_state_bridge_avalon_slave_allow_new_arb_cycle :  STD_LOGIC;
                signal tri_state_bridge_avalon_slave_any_continuerequest :  STD_LOGIC;
                signal tri_state_bridge_avalon_slave_arb_addend :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal tri_state_bridge_avalon_slave_arb_counter_enable :  STD_LOGIC;
                signal tri_state_bridge_avalon_slave_arb_share_counter :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal tri_state_bridge_avalon_slave_arb_share_counter_next_value :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal tri_state_bridge_avalon_slave_arb_share_set_values :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal tri_state_bridge_avalon_slave_arb_winner :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal tri_state_bridge_avalon_slave_arbitration_holdoff_internal :  STD_LOGIC;
                signal tri_state_bridge_avalon_slave_beginbursttransfer_internal :  STD_LOGIC;
                signal tri_state_bridge_avalon_slave_begins_xfer :  STD_LOGIC;
                signal tri_state_bridge_avalon_slave_chosen_master_double_vector :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal tri_state_bridge_avalon_slave_chosen_master_rot_left :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal tri_state_bridge_avalon_slave_end_xfer :  STD_LOGIC;
                signal tri_state_bridge_avalon_slave_firsttransfer :  STD_LOGIC;
                signal tri_state_bridge_avalon_slave_grant_vector :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal tri_state_bridge_avalon_slave_master_qreq_vector :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal tri_state_bridge_avalon_slave_read_pending :  STD_LOGIC;
                signal tri_state_bridge_avalon_slave_saved_chosen_master_vector :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal tri_state_bridge_avalon_slave_slavearbiterlockenable :  STD_LOGIC;
                signal tri_state_bridge_avalon_slave_write_pending :  STD_LOGIC;
                signal wait_for_SRAM_s1_counter :  STD_LOGIC;
                signal wait_for_epc_s1_counter :  STD_LOGIC;
attribute ALTERA_ATTRIBUTE : string;
attribute ALTERA_ATTRIBUTE of be_n_to_the_SRAM : signal is "FAST_OUTPUT_REGISTER=ON";
attribute ALTERA_ATTRIBUTE of d1_in_a_write_cycle : signal is "FAST_OUTPUT_ENABLE_REGISTER=ON";
attribute ALTERA_ATTRIBUTE of d1_outgoing_tri_state_bridge_data : signal is "FAST_OUTPUT_REGISTER=ON";
attribute ALTERA_ATTRIBUTE of internal_incoming_tri_state_bridge_data : signal is "FAST_INPUT_REGISTER=ON";
attribute ALTERA_ATTRIBUTE of read_n_to_the_SRAM : signal is "FAST_OUTPUT_REGISTER=ON";
attribute ALTERA_ATTRIBUTE of select0_n_to_the_SRAM : signal is "FAST_OUTPUT_REGISTER=ON";
attribute ALTERA_ATTRIBUTE of select1_n_to_the_SRAM : signal is "FAST_OUTPUT_REGISTER=ON";
attribute ALTERA_ATTRIBUTE of select_n_to_the_epc : signal is "FAST_OUTPUT_REGISTER=ON";
attribute ALTERA_ATTRIBUTE of tri_state_bridge_address : signal is "FAST_OUTPUT_REGISTER=ON";
attribute ALTERA_ATTRIBUTE of tri_state_bridge_readn : signal is "FAST_OUTPUT_REGISTER=ON";
attribute ALTERA_ATTRIBUTE of write_n_to_the_SRAM : signal is "FAST_OUTPUT_REGISTER=ON";
attribute ALTERA_ATTRIBUTE of write_n_to_the_epc : signal is "FAST_OUTPUT_REGISTER=ON";

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT tri_state_bridge_avalon_slave_end_xfer;
      end if;
    end if;

  end process;

  tri_state_bridge_avalon_slave_begins_xfer <= NOT d1_reasons_to_wait AND ((((internal_cpu_data_master_qualified_request_SRAM_s1 OR internal_cpu_instruction_master_qualified_request_SRAM_s1) OR internal_cpu_data_master_qualified_request_epc_s1) OR internal_cpu_instruction_master_qualified_request_epc_s1));
  internal_cpu_data_master_requests_SRAM_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(23 DOWNTO 20) & std_logic_vector'("00000000000000000000")) = std_logic_vector'("100000000000000000000000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --~select0_n_to_the_SRAM of type chipselect to ~p1_select1_n_to_the_SRAM, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      select0_n_to_the_SRAM <= Vector_To_Std_Logic(NOT std_logic_vector'("00000000000000000000000000000000"));
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        select0_n_to_the_SRAM <= p1_select1_n_to_the_SRAM;
      end if;
    end if;

  end process;

  --~select1_n_to_the_SRAM of type chipselect to ~p1_select1_n_to_the_SRAM, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      select1_n_to_the_SRAM <= Vector_To_Std_Logic(NOT std_logic_vector'("00000000000000000000000000000000"));
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        select1_n_to_the_SRAM <= p1_select1_n_to_the_SRAM;
      end if;
    end if;

  end process;

  --~select_n_to_the_epc of type chipselect to ~p1_select_n_to_the_epc, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      select_n_to_the_epc <= Vector_To_Std_Logic(NOT std_logic_vector'("00000000000000000000000000000000"));
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        select_n_to_the_epc <= p1_select_n_to_the_epc;
      end if;
    end if;

  end process;

  tri_state_bridge_avalon_slave_write_pending <= std_logic'('0');
  --registered rdv signal_name registered_cpu_data_master_read_data_valid_SRAM_s1 assignment, which is an e_assign
  registered_cpu_data_master_read_data_valid_SRAM_s1 <= cpu_data_master_read_data_valid_SRAM_s1_shift_register(0);
  tri_state_bridge_avalon_slave_read_pending <= std_logic'('0');
  --tri_state_bridge_avalon_slave_arb_share_counter set values, which is an e_mux
  tri_state_bridge_avalon_slave_arb_share_set_values <= A_EXT (A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_epc_s1)) = '1'), std_logic_vector'("00000000000000000000000000000010"), A_WE_StdLogicVector((std_logic'((internal_cpu_instruction_master_granted_epc_s1)) = '1'), std_logic_vector'("00000000000000000000000000000010"), A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_epc_s1)) = '1'), std_logic_vector'("00000000000000000000000000000010"), A_WE_StdLogicVector((std_logic'((internal_cpu_instruction_master_granted_epc_s1)) = '1'), std_logic_vector'("00000000000000000000000000000010"), std_logic_vector'("00000000000000000000000000000001"))))), 2);
  --tri_state_bridge_avalon_slave_arb_share_counter_next_value assignment, which is an e_assign
  tri_state_bridge_avalon_slave_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(tri_state_bridge_avalon_slave_firsttransfer) = '1'), (((std_logic_vector'("0000000000000000000000000000000") & (tri_state_bridge_avalon_slave_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(tri_state_bridge_avalon_slave_arb_share_counter)) = '1'), (((std_logic_vector'("0000000000000000000000000000000") & (tri_state_bridge_avalon_slave_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 2);
  --tri_state_bridge_avalon_slave_allgrants all slave grants, which is an e_mux
  tri_state_bridge_avalon_slave_allgrants <= ((((((or_reduce(tri_state_bridge_avalon_slave_grant_vector) OR or_reduce(tri_state_bridge_avalon_slave_grant_vector)) OR or_reduce(tri_state_bridge_avalon_slave_grant_vector)) OR or_reduce(tri_state_bridge_avalon_slave_grant_vector)) OR or_reduce(tri_state_bridge_avalon_slave_grant_vector)) OR or_reduce(tri_state_bridge_avalon_slave_grant_vector)) OR or_reduce(tri_state_bridge_avalon_slave_grant_vector)) OR or_reduce(tri_state_bridge_avalon_slave_grant_vector);
  --tri_state_bridge_avalon_slave_end_xfer assignment, which is an e_assign
  tri_state_bridge_avalon_slave_end_xfer <= NOT ((((SRAM_s1_waits_for_read OR SRAM_s1_waits_for_write) OR epc_s1_waits_for_read) OR epc_s1_waits_for_write));
  --tri_state_bridge_avalon_slave_arb_share_counter arbitration counter enable, which is an e_assign
  tri_state_bridge_avalon_slave_arb_counter_enable <= tri_state_bridge_avalon_slave_end_xfer AND tri_state_bridge_avalon_slave_allgrants;
  --tri_state_bridge_avalon_slave_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      tri_state_bridge_avalon_slave_arb_share_counter <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if std_logic'(tri_state_bridge_avalon_slave_arb_counter_enable) = '1' then 
        tri_state_bridge_avalon_slave_arb_share_counter <= tri_state_bridge_avalon_slave_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --tri_state_bridge_avalon_slave_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      tri_state_bridge_avalon_slave_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((or_reduce(tri_state_bridge_avalon_slave_master_qreq_vector) AND tri_state_bridge_avalon_slave_end_xfer)) = '1' then 
        tri_state_bridge_avalon_slave_slavearbiterlockenable <= or_reduce(tri_state_bridge_avalon_slave_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master tri_state_bridge/avalon_slave arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= tri_state_bridge_avalon_slave_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --cpu/instruction_master tri_state_bridge/avalon_slave arbiterlock, which is an e_assign
  cpu_instruction_master_arbiterlock <= tri_state_bridge_avalon_slave_slavearbiterlockenable AND cpu_instruction_master_continuerequest;
  --cpu/instruction_master granted SRAM/s1 last time, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      last_cycle_cpu_instruction_master_granted_slave_SRAM_s1 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        last_cycle_cpu_instruction_master_granted_slave_SRAM_s1 <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(cpu_instruction_master_saved_grant_SRAM_s1) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'(((tri_state_bridge_avalon_slave_arbitration_holdoff_internal OR NOT internal_cpu_instruction_master_requests_SRAM_s1))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(last_cycle_cpu_instruction_master_granted_slave_SRAM_s1))))));
      end if;
    end if;

  end process;

  --cpu_instruction_master_continuerequest continued request, which is an e_mux
  cpu_instruction_master_continuerequest <= ((last_cycle_cpu_instruction_master_granted_slave_SRAM_s1 AND internal_cpu_instruction_master_requests_SRAM_s1)) OR ((last_cycle_cpu_instruction_master_granted_slave_epc_s1 AND internal_cpu_instruction_master_requests_epc_s1));
  --tri_state_bridge_avalon_slave_any_continuerequest at least one master continues requesting, which is an e_mux
  tri_state_bridge_avalon_slave_any_continuerequest <= ((cpu_instruction_master_continuerequest OR cpu_instruction_master_continuerequest) OR cpu_data_master_continuerequest) OR cpu_data_master_continuerequest;
  internal_cpu_data_master_qualified_request_SRAM_s1 <= internal_cpu_data_master_requests_SRAM_s1 AND NOT (((((cpu_data_master_read AND ((tri_state_bridge_avalon_slave_write_pending OR (or_reduce(cpu_data_master_read_data_valid_SRAM_s1_shift_register)))))) OR (((tri_state_bridge_avalon_slave_read_pending) AND cpu_data_master_write))) OR cpu_instruction_master_arbiterlock));
  --cpu_data_master_read_data_valid_SRAM_s1_shift_register_in mux for readlatency shift register, which is an e_mux
  cpu_data_master_read_data_valid_SRAM_s1_shift_register_in <= ((internal_cpu_data_master_granted_SRAM_s1 AND cpu_data_master_read) AND NOT SRAM_s1_waits_for_read) AND NOT (or_reduce(cpu_data_master_read_data_valid_SRAM_s1_shift_register));
  --shift register p1 cpu_data_master_read_data_valid_SRAM_s1_shift_register in if flush, otherwise shift left, which is an e_mux
  p1_cpu_data_master_read_data_valid_SRAM_s1_shift_register <= A_EXT ((cpu_data_master_read_data_valid_SRAM_s1_shift_register & A_ToStdLogicVector(cpu_data_master_read_data_valid_SRAM_s1_shift_register_in)), 2);
  --cpu_data_master_read_data_valid_SRAM_s1_shift_register for remembering which master asked for a fixed latency read, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_data_master_read_data_valid_SRAM_s1_shift_register <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        cpu_data_master_read_data_valid_SRAM_s1_shift_register <= p1_cpu_data_master_read_data_valid_SRAM_s1_shift_register;
      end if;
    end if;

  end process;

  --local readdatavalid cpu_data_master_read_data_valid_SRAM_s1, which is an e_mux
  cpu_data_master_read_data_valid_SRAM_s1 <= cpu_data_master_read_data_valid_SRAM_s1_shift_register(1);
  --tri_state_bridge_data register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_incoming_tri_state_bridge_data <= std_logic_vector'("00000000000000000000000000000000");
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        internal_incoming_tri_state_bridge_data <= tri_state_bridge_data;
      end if;
    end if;

  end process;

  --SRAM_s1_with_write_latency assignment, which is an e_assign
  SRAM_s1_with_write_latency <= in_a_write_cycle AND ((internal_cpu_data_master_qualified_request_SRAM_s1 OR internal_cpu_instruction_master_qualified_request_SRAM_s1));
  --time to write the data, which is an e_mux
  time_to_write <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'((SRAM_s1_with_write_latency)) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'((epc_s1_with_write_latency)) = '1'), std_logic_vector'("00000000000000000000000000000001"), std_logic_vector'("00000000000000000000000000000000"))));
  --d1_outgoing_tri_state_bridge_data register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_outgoing_tri_state_bridge_data <= std_logic_vector'("00000000000000000000000000000000");
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_outgoing_tri_state_bridge_data <= outgoing_tri_state_bridge_data;
      end if;
    end if;

  end process;

  --write cycle delayed by 1, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_in_a_write_cycle <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_in_a_write_cycle <= time_to_write;
      end if;
    end if;

  end process;

  --d1_outgoing_tri_state_bridge_data tristate driver, which is an e_assign
  tri_state_bridge_data <= A_WE_StdLogicVector((std_logic'((d1_in_a_write_cycle)) = '1'), d1_outgoing_tri_state_bridge_data, A_REP(std_logic'('Z'), 32));
  --outgoing_tri_state_bridge_data mux, which is an e_mux
  outgoing_tri_state_bridge_data <= A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_SRAM_s1)) = '1'), cpu_data_master_writedata, (std_logic_vector'("0000000000000000") & (cpu_data_master_dbs_write_16)));
  internal_cpu_data_master_requests_epc_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(23 DOWNTO 21) & std_logic_vector'("000000000000000000000")) = std_logic_vector'("001000000000000000000000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --registered rdv signal_name registered_cpu_data_master_read_data_valid_epc_s1 assignment, which is an e_assign
  registered_cpu_data_master_read_data_valid_epc_s1 <= cpu_data_master_read_data_valid_epc_s1_shift_register(0);
  --cpu/instruction_master granted epc/s1 last time, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      last_cycle_cpu_instruction_master_granted_slave_epc_s1 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        last_cycle_cpu_instruction_master_granted_slave_epc_s1 <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(cpu_instruction_master_saved_grant_epc_s1) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'(((tri_state_bridge_avalon_slave_arbitration_holdoff_internal OR NOT internal_cpu_instruction_master_requests_epc_s1))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(last_cycle_cpu_instruction_master_granted_slave_epc_s1))))));
      end if;
    end if;

  end process;

  internal_cpu_data_master_qualified_request_epc_s1 <= internal_cpu_data_master_requests_epc_s1 AND NOT (((((cpu_data_master_read AND ((tri_state_bridge_avalon_slave_write_pending OR (or_reduce(cpu_data_master_read_data_valid_epc_s1_shift_register)))))) OR (((((tri_state_bridge_avalon_slave_read_pending OR cpu_data_master_no_byte_enables_and_last_term) OR NOT(or_reduce(internal_cpu_data_master_byteenable_epc_s1)))) AND cpu_data_master_write))) OR cpu_instruction_master_arbiterlock));
  --cpu_data_master_read_data_valid_epc_s1_shift_register_in mux for readlatency shift register, which is an e_mux
  cpu_data_master_read_data_valid_epc_s1_shift_register_in <= ((internal_cpu_data_master_granted_epc_s1 AND cpu_data_master_read) AND NOT epc_s1_waits_for_read) AND NOT (or_reduce(cpu_data_master_read_data_valid_epc_s1_shift_register));
  --shift register p1 cpu_data_master_read_data_valid_epc_s1_shift_register in if flush, otherwise shift left, which is an e_mux
  p1_cpu_data_master_read_data_valid_epc_s1_shift_register <= A_EXT ((cpu_data_master_read_data_valid_epc_s1_shift_register & A_ToStdLogicVector(cpu_data_master_read_data_valid_epc_s1_shift_register_in)), 2);
  --cpu_data_master_read_data_valid_epc_s1_shift_register for remembering which master asked for a fixed latency read, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_data_master_read_data_valid_epc_s1_shift_register <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        cpu_data_master_read_data_valid_epc_s1_shift_register <= p1_cpu_data_master_read_data_valid_epc_s1_shift_register;
      end if;
    end if;

  end process;

  --local readdatavalid cpu_data_master_read_data_valid_epc_s1, which is an e_mux
  cpu_data_master_read_data_valid_epc_s1 <= cpu_data_master_read_data_valid_epc_s1_shift_register(1);
  --epc_s1_with_write_latency assignment, which is an e_assign
  epc_s1_with_write_latency <= in_a_write_cycle AND ((internal_cpu_data_master_qualified_request_epc_s1 OR internal_cpu_instruction_master_qualified_request_epc_s1));
  internal_cpu_instruction_master_requests_SRAM_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_instruction_master_address_to_slave(23 DOWNTO 20) & std_logic_vector'("00000000000000000000")) = std_logic_vector'("100000000000000000000000")))) AND (cpu_instruction_master_read);
  --cpu/data_master granted SRAM/s1 last time, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      last_cycle_cpu_data_master_granted_slave_SRAM_s1 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        last_cycle_cpu_data_master_granted_slave_SRAM_s1 <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(cpu_data_master_saved_grant_SRAM_s1) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'(((tri_state_bridge_avalon_slave_arbitration_holdoff_internal OR NOT internal_cpu_data_master_requests_SRAM_s1))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(last_cycle_cpu_data_master_granted_slave_SRAM_s1))))));
      end if;
    end if;

  end process;

  --cpu_data_master_continuerequest continued request, which is an e_mux
  cpu_data_master_continuerequest <= ((last_cycle_cpu_data_master_granted_slave_SRAM_s1 AND internal_cpu_data_master_requests_SRAM_s1)) OR ((last_cycle_cpu_data_master_granted_slave_epc_s1 AND internal_cpu_data_master_requests_epc_s1));
  internal_cpu_instruction_master_qualified_request_SRAM_s1 <= internal_cpu_instruction_master_requests_SRAM_s1 AND NOT ((((cpu_instruction_master_read AND ((tri_state_bridge_avalon_slave_write_pending OR (or_reduce(cpu_instruction_master_read_data_valid_SRAM_s1_shift_register)))))) OR cpu_data_master_arbiterlock));
  --cpu_instruction_master_read_data_valid_SRAM_s1_shift_register_in mux for readlatency shift register, which is an e_mux
  cpu_instruction_master_read_data_valid_SRAM_s1_shift_register_in <= ((internal_cpu_instruction_master_granted_SRAM_s1 AND cpu_instruction_master_read) AND NOT SRAM_s1_waits_for_read) AND NOT (or_reduce(cpu_instruction_master_read_data_valid_SRAM_s1_shift_register));
  --shift register p1 cpu_instruction_master_read_data_valid_SRAM_s1_shift_register in if flush, otherwise shift left, which is an e_mux
  p1_cpu_instruction_master_read_data_valid_SRAM_s1_shift_register <= A_EXT ((cpu_instruction_master_read_data_valid_SRAM_s1_shift_register & A_ToStdLogicVector(cpu_instruction_master_read_data_valid_SRAM_s1_shift_register_in)), 2);
  --cpu_instruction_master_read_data_valid_SRAM_s1_shift_register for remembering which master asked for a fixed latency read, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_instruction_master_read_data_valid_SRAM_s1_shift_register <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        cpu_instruction_master_read_data_valid_SRAM_s1_shift_register <= p1_cpu_instruction_master_read_data_valid_SRAM_s1_shift_register;
      end if;
    end if;

  end process;

  --local readdatavalid cpu_instruction_master_read_data_valid_SRAM_s1, which is an e_mux
  cpu_instruction_master_read_data_valid_SRAM_s1 <= cpu_instruction_master_read_data_valid_SRAM_s1_shift_register(1);
  internal_cpu_instruction_master_requests_epc_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_instruction_master_address_to_slave(23 DOWNTO 21) & std_logic_vector'("000000000000000000000")) = std_logic_vector'("001000000000000000000000")))) AND (cpu_instruction_master_read);
  --cpu/data_master granted epc/s1 last time, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      last_cycle_cpu_data_master_granted_slave_epc_s1 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        last_cycle_cpu_data_master_granted_slave_epc_s1 <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(cpu_data_master_saved_grant_epc_s1) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'(((tri_state_bridge_avalon_slave_arbitration_holdoff_internal OR NOT internal_cpu_data_master_requests_epc_s1))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(last_cycle_cpu_data_master_granted_slave_epc_s1))))));
      end if;
    end if;

  end process;

  internal_cpu_instruction_master_qualified_request_epc_s1 <= internal_cpu_instruction_master_requests_epc_s1 AND NOT ((((cpu_instruction_master_read AND ((tri_state_bridge_avalon_slave_write_pending OR (or_reduce(cpu_instruction_master_read_data_valid_epc_s1_shift_register)))))) OR cpu_data_master_arbiterlock));
  --cpu_instruction_master_read_data_valid_epc_s1_shift_register_in mux for readlatency shift register, which is an e_mux
  cpu_instruction_master_read_data_valid_epc_s1_shift_register_in <= ((internal_cpu_instruction_master_granted_epc_s1 AND cpu_instruction_master_read) AND NOT epc_s1_waits_for_read) AND NOT (or_reduce(cpu_instruction_master_read_data_valid_epc_s1_shift_register));
  --shift register p1 cpu_instruction_master_read_data_valid_epc_s1_shift_register in if flush, otherwise shift left, which is an e_mux
  p1_cpu_instruction_master_read_data_valid_epc_s1_shift_register <= A_EXT ((cpu_instruction_master_read_data_valid_epc_s1_shift_register & A_ToStdLogicVector(cpu_instruction_master_read_data_valid_epc_s1_shift_register_in)), 2);
  --cpu_instruction_master_read_data_valid_epc_s1_shift_register for remembering which master asked for a fixed latency read, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_instruction_master_read_data_valid_epc_s1_shift_register <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        cpu_instruction_master_read_data_valid_epc_s1_shift_register <= p1_cpu_instruction_master_read_data_valid_epc_s1_shift_register;
      end if;
    end if;

  end process;

  --local readdatavalid cpu_instruction_master_read_data_valid_epc_s1, which is an e_mux
  cpu_instruction_master_read_data_valid_epc_s1 <= cpu_instruction_master_read_data_valid_epc_s1_shift_register(1);
  --allow new arb cycle for tri_state_bridge/avalon_slave, which is an e_assign
  tri_state_bridge_avalon_slave_allow_new_arb_cycle <= NOT cpu_data_master_arbiterlock AND NOT cpu_instruction_master_arbiterlock;
  --cpu/instruction_master assignment into master qualified-requests vector for SRAM/s1, which is an e_assign
  tri_state_bridge_avalon_slave_master_qreq_vector(0) <= internal_cpu_instruction_master_qualified_request_SRAM_s1;
  --cpu/instruction_master grant SRAM/s1, which is an e_assign
  internal_cpu_instruction_master_granted_SRAM_s1 <= tri_state_bridge_avalon_slave_grant_vector(0);
  --cpu/instruction_master saved-grant SRAM/s1, which is an e_assign
  cpu_instruction_master_saved_grant_SRAM_s1 <= tri_state_bridge_avalon_slave_arb_winner(0) AND internal_cpu_instruction_master_requests_SRAM_s1;
  --cpu/data_master assignment into master qualified-requests vector for SRAM/s1, which is an e_assign
  tri_state_bridge_avalon_slave_master_qreq_vector(1) <= internal_cpu_data_master_qualified_request_SRAM_s1;
  --cpu/data_master grant SRAM/s1, which is an e_assign
  internal_cpu_data_master_granted_SRAM_s1 <= tri_state_bridge_avalon_slave_grant_vector(1);
  --cpu/data_master saved-grant SRAM/s1, which is an e_assign
  cpu_data_master_saved_grant_SRAM_s1 <= tri_state_bridge_avalon_slave_arb_winner(1) AND internal_cpu_data_master_requests_SRAM_s1;
  --cpu/instruction_master assignment into master qualified-requests vector for epc/s1, which is an e_assign
  tri_state_bridge_avalon_slave_master_qreq_vector(2) <= internal_cpu_instruction_master_qualified_request_epc_s1;
  --cpu/instruction_master grant epc/s1, which is an e_assign
  internal_cpu_instruction_master_granted_epc_s1 <= tri_state_bridge_avalon_slave_grant_vector(2);
  --cpu/instruction_master saved-grant epc/s1, which is an e_assign
  cpu_instruction_master_saved_grant_epc_s1 <= tri_state_bridge_avalon_slave_arb_winner(2) AND internal_cpu_instruction_master_requests_epc_s1;
  --cpu/data_master assignment into master qualified-requests vector for epc/s1, which is an e_assign
  tri_state_bridge_avalon_slave_master_qreq_vector(3) <= internal_cpu_data_master_qualified_request_epc_s1;
  --cpu/data_master grant epc/s1, which is an e_assign
  internal_cpu_data_master_granted_epc_s1 <= tri_state_bridge_avalon_slave_grant_vector(3);
  --cpu/data_master saved-grant epc/s1, which is an e_assign
  cpu_data_master_saved_grant_epc_s1 <= tri_state_bridge_avalon_slave_arb_winner(3) AND internal_cpu_data_master_requests_epc_s1;
  --tri_state_bridge/avalon_slave chosen-master double-vector, which is an e_assign
  tri_state_bridge_avalon_slave_chosen_master_double_vector <= A_EXT (((std_logic_vector'("0") & ((tri_state_bridge_avalon_slave_master_qreq_vector & tri_state_bridge_avalon_slave_master_qreq_vector))) AND (((std_logic_vector'("0") & (Std_Logic_Vector'(NOT tri_state_bridge_avalon_slave_master_qreq_vector & NOT tri_state_bridge_avalon_slave_master_qreq_vector))) + (std_logic_vector'("00000") & (tri_state_bridge_avalon_slave_arb_addend))))), 8);
  --stable onehot encoding of arb winner
  tri_state_bridge_avalon_slave_arb_winner <= A_WE_StdLogicVector((std_logic'(((tri_state_bridge_avalon_slave_allow_new_arb_cycle AND or_reduce(tri_state_bridge_avalon_slave_grant_vector)))) = '1'), tri_state_bridge_avalon_slave_grant_vector, tri_state_bridge_avalon_slave_saved_chosen_master_vector);
  --saved tri_state_bridge_avalon_slave_grant_vector, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      tri_state_bridge_avalon_slave_saved_chosen_master_vector <= std_logic_vector'("0000");
    elsif clk'event and clk = '1' then
      if std_logic'(tri_state_bridge_avalon_slave_allow_new_arb_cycle) = '1' then 
        tri_state_bridge_avalon_slave_saved_chosen_master_vector <= A_WE_StdLogicVector((std_logic'(or_reduce(tri_state_bridge_avalon_slave_grant_vector)) = '1'), tri_state_bridge_avalon_slave_grant_vector, tri_state_bridge_avalon_slave_saved_chosen_master_vector);
      end if;
    end if;

  end process;

  --onehot encoding of chosen master
  tri_state_bridge_avalon_slave_grant_vector <= Std_Logic_Vector'(A_ToStdLogicVector(((tri_state_bridge_avalon_slave_chosen_master_double_vector(3) OR tri_state_bridge_avalon_slave_chosen_master_double_vector(7)))) & A_ToStdLogicVector(((tri_state_bridge_avalon_slave_chosen_master_double_vector(2) OR tri_state_bridge_avalon_slave_chosen_master_double_vector(6)))) & A_ToStdLogicVector(((tri_state_bridge_avalon_slave_chosen_master_double_vector(1) OR tri_state_bridge_avalon_slave_chosen_master_double_vector(5)))) & A_ToStdLogicVector(((tri_state_bridge_avalon_slave_chosen_master_double_vector(0) OR tri_state_bridge_avalon_slave_chosen_master_double_vector(4)))));
  --tri_state_bridge/avalon_slave chosen master rotated left, which is an e_assign
  tri_state_bridge_avalon_slave_chosen_master_rot_left <= A_EXT (A_WE_StdLogicVector((((A_SLL(tri_state_bridge_avalon_slave_arb_winner,std_logic_vector'("00000000000000000000000000000001")))) /= std_logic_vector'("0000")), (std_logic_vector'("0000000000000000000000000000") & ((A_SLL(tri_state_bridge_avalon_slave_arb_winner,std_logic_vector'("00000000000000000000000000000001"))))), std_logic_vector'("00000000000000000000000000000001")), 4);
  --tri_state_bridge/avalon_slave's addend for next-master-grant
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      tri_state_bridge_avalon_slave_arb_addend <= std_logic_vector'("0001");
    elsif clk'event and clk = '1' then
      if std_logic'(or_reduce(tri_state_bridge_avalon_slave_grant_vector)) = '1' then 
        tri_state_bridge_avalon_slave_arb_addend <= A_WE_StdLogicVector((std_logic'(tri_state_bridge_avalon_slave_end_xfer) = '1'), tri_state_bridge_avalon_slave_chosen_master_rot_left, tri_state_bridge_avalon_slave_grant_vector);
      end if;
    end if;

  end process;

  p1_select1_n_to_the_SRAM <= NOT ((internal_cpu_data_master_granted_SRAM_s1 OR internal_cpu_instruction_master_granted_SRAM_s1));
  --tri_state_bridge_avalon_slave_firsttransfer first transaction, which is an e_assign
  tri_state_bridge_avalon_slave_firsttransfer <= NOT ((tri_state_bridge_avalon_slave_slavearbiterlockenable AND tri_state_bridge_avalon_slave_any_continuerequest));
  --tri_state_bridge_avalon_slave_beginbursttransfer_internal begin burst transfer, which is an e_assign
  tri_state_bridge_avalon_slave_beginbursttransfer_internal <= tri_state_bridge_avalon_slave_begins_xfer AND tri_state_bridge_avalon_slave_firsttransfer;
  --tri_state_bridge_avalon_slave_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  tri_state_bridge_avalon_slave_arbitration_holdoff_internal <= tri_state_bridge_avalon_slave_begins_xfer AND tri_state_bridge_avalon_slave_firsttransfer;
  --~read_n_to_the_SRAM of type read to ~p1_read_n_to_the_SRAM, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      read_n_to_the_SRAM <= Vector_To_Std_Logic(NOT std_logic_vector'("00000000000000000000000000000000"));
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        read_n_to_the_SRAM <= p1_read_n_to_the_SRAM;
      end if;
    end if;

  end process;

  --~write_n_to_the_SRAM of type write to ~p1_write_n_to_the_SRAM, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      write_n_to_the_SRAM <= Vector_To_Std_Logic(NOT std_logic_vector'("00000000000000000000000000000000"));
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        write_n_to_the_SRAM <= p1_write_n_to_the_SRAM;
      end if;
    end if;

  end process;

  --~p1_read_n_to_the_SRAM assignment, which is an e_mux
  p1_read_n_to_the_SRAM <= NOT ((((((internal_cpu_data_master_granted_SRAM_s1 AND cpu_data_master_read)) OR ((internal_cpu_instruction_master_granted_SRAM_s1 AND cpu_instruction_master_read)))) AND NOT tri_state_bridge_avalon_slave_begins_xfer));
  --~be_n_to_the_SRAM of type byteenable to ~p1_be_n_to_the_SRAM, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      be_n_to_the_SRAM <= A_EXT (NOT std_logic_vector'("00000000000000000000000000000000"), 4);
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        be_n_to_the_SRAM <= p1_be_n_to_the_SRAM;
      end if;
    end if;

  end process;

  --~p1_write_n_to_the_SRAM assignment, which is an e_mux
  p1_write_n_to_the_SRAM <= NOT (((((internal_cpu_data_master_granted_SRAM_s1 AND cpu_data_master_write)) AND NOT tri_state_bridge_avalon_slave_begins_xfer) AND to_std_logic((((std_logic_vector'("000000000000000000000000000000") & (SRAM_s1_wait_counter))>=std_logic_vector'("00000000000000000000000000000001"))))));
  --tri_state_bridge_address of type address to p1_tri_state_bridge_address, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      tri_state_bridge_address <= std_logic_vector'("000000000000000000000");
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        tri_state_bridge_address <= p1_tri_state_bridge_address;
      end if;
    end if;

  end process;

  --p1_tri_state_bridge_address mux, which is an e_mux
  p1_tri_state_bridge_address <= A_EXT (A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_SRAM_s1)) = '1'), (std_logic_vector'("00") & (cpu_data_master_address_to_slave)), A_WE_StdLogicVector((std_logic'((internal_cpu_instruction_master_granted_SRAM_s1)) = '1'), (std_logic_vector'("00") & (cpu_instruction_master_address_to_slave)), A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_epc_s1)) = '1'), (Std_Logic_Vector'(A_SRL(cpu_data_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010")) & A_ToStdLogicVector(cpu_data_master_dbs_address(1)) & A_ToStdLogicVector(std_logic'('0')))), (Std_Logic_Vector'(A_SRL(cpu_instruction_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010")) & A_ToStdLogicVector(cpu_instruction_master_dbs_address(1)) & A_ToStdLogicVector(std_logic'('0'))))))), 21);
  --d1_tri_state_bridge_avalon_slave_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_tri_state_bridge_avalon_slave_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_tri_state_bridge_avalon_slave_end_xfer <= tri_state_bridge_avalon_slave_end_xfer;
      end if;
    end if;

  end process;

  --SRAM_s1_waits_for_read in a cycle, which is an e_mux
  SRAM_s1_waits_for_read <= SRAM_s1_in_a_read_cycle AND wait_for_SRAM_s1_counter;
  --SRAM_s1_in_a_read_cycle assignment, which is an e_assign
  SRAM_s1_in_a_read_cycle <= ((internal_cpu_data_master_granted_SRAM_s1 AND cpu_data_master_read)) OR ((internal_cpu_instruction_master_granted_SRAM_s1 AND cpu_instruction_master_read));
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= SRAM_s1_in_a_read_cycle OR epc_s1_in_a_read_cycle;
  --SRAM_s1_wait_counter_eq_1 assignment, which is an e_assign
  SRAM_s1_wait_counter_eq_1 <= to_std_logic(((std_logic_vector'("000000000000000000000000000000") & (SRAM_s1_wait_counter)) = std_logic_vector'("00000000000000000000000000000001")));
  --SRAM_s1_waits_for_write in a cycle, which is an e_mux
  SRAM_s1_waits_for_write <= SRAM_s1_in_a_write_cycle AND wait_for_SRAM_s1_counter;
  --SRAM_s1_in_a_write_cycle assignment, which is an e_assign
  SRAM_s1_in_a_write_cycle <= internal_cpu_data_master_granted_SRAM_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= SRAM_s1_in_a_write_cycle OR epc_s1_in_a_write_cycle;
  internal_SRAM_s1_wait_counter_eq_0 <= to_std_logic(((std_logic_vector'("000000000000000000000000000000") & (SRAM_s1_wait_counter)) = std_logic_vector'("00000000000000000000000000000000")));
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      SRAM_s1_wait_counter <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        SRAM_s1_wait_counter <= SRAM_s1_counter_load_value;
      end if;
    end if;

  end process;

  SRAM_s1_counter_load_value <= A_EXT (A_WE_StdLogicVector((std_logic'(((SRAM_s1_in_a_write_cycle AND tri_state_bridge_avalon_slave_begins_xfer))) = '1'), std_logic_vector'("000000000000000000000000000000010"), A_WE_StdLogicVector((std_logic'(((SRAM_s1_in_a_read_cycle AND tri_state_bridge_avalon_slave_begins_xfer))) = '1'), std_logic_vector'("000000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'((NOT internal_SRAM_s1_wait_counter_eq_0)) = '1'), ((std_logic_vector'("0000000000000000000000000000000") & (SRAM_s1_wait_counter)) - std_logic_vector'("000000000000000000000000000000001")), std_logic_vector'("000000000000000000000000000000000")))), 2);
  wait_for_SRAM_s1_counter <= tri_state_bridge_avalon_slave_begins_xfer OR NOT internal_SRAM_s1_wait_counter_eq_0;
  --~p1_be_n_to_the_SRAM byte enable port mux, which is an e_mux
  p1_be_n_to_the_SRAM <= A_EXT (NOT (A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_SRAM_s1)) = '1'), (std_logic_vector'("0000000000000000000000000000") & (cpu_data_master_byteenable)), -SIGNED(std_logic_vector'("00000000000000000000000000000001")))), 4);
  p1_select_n_to_the_epc <= NOT ((internal_cpu_data_master_granted_epc_s1 OR internal_cpu_instruction_master_granted_epc_s1));
  --~tri_state_bridge_readn of type read to ~p1_tri_state_bridge_readn, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      tri_state_bridge_readn <= Vector_To_Std_Logic(NOT std_logic_vector'("00000000000000000000000000000000"));
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        tri_state_bridge_readn <= p1_tri_state_bridge_readn;
      end if;
    end if;

  end process;

  --~write_n_to_the_epc of type write to ~p1_write_n_to_the_epc, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      write_n_to_the_epc <= Vector_To_Std_Logic(NOT std_logic_vector'("00000000000000000000000000000000"));
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        write_n_to_the_epc <= p1_write_n_to_the_epc;
      end if;
    end if;

  end process;

  --~p1_tri_state_bridge_readn assignment, which is an e_mux
  p1_tri_state_bridge_readn <= NOT (((((((internal_cpu_data_master_granted_epc_s1 AND cpu_data_master_read)) OR ((internal_cpu_instruction_master_granted_epc_s1 AND cpu_instruction_master_read)))) AND NOT tri_state_bridge_avalon_slave_begins_xfer) AND to_std_logic((((std_logic_vector'("000000000000000000000000000") & (epc_s1_wait_counter))<std_logic_vector'("00000000000000000000000000001011"))))));
  --~p1_write_n_to_the_epc assignment, which is an e_mux
  p1_write_n_to_the_epc <= NOT ((((((internal_cpu_data_master_granted_epc_s1 AND cpu_data_master_write)) AND NOT tri_state_bridge_avalon_slave_begins_xfer) AND to_std_logic((((std_logic_vector'("000000000000000000000000000") & (epc_s1_wait_counter))>=std_logic_vector'("00000000000000000000000000000100"))))) AND to_std_logic((((std_logic_vector'("000000000000000000000000000") & (epc_s1_wait_counter))<std_logic_vector'("00000000000000000000000000001111"))))));
  --epc_s1_wait_counter_eq_1 assignment, which is an e_assign
  epc_s1_wait_counter_eq_1 <= to_std_logic(((std_logic_vector'("000000000000000000000000000") & (epc_s1_wait_counter)) = std_logic_vector'("00000000000000000000000000000001")));
  --epc_s1_waits_for_read in a cycle, which is an e_mux
  epc_s1_waits_for_read <= epc_s1_in_a_read_cycle AND wait_for_epc_s1_counter;
  --epc_s1_in_a_read_cycle assignment, which is an e_assign
  epc_s1_in_a_read_cycle <= ((internal_cpu_data_master_granted_epc_s1 AND cpu_data_master_read)) OR ((internal_cpu_instruction_master_granted_epc_s1 AND cpu_instruction_master_read));
  --epc_s1_waits_for_write in a cycle, which is an e_mux
  epc_s1_waits_for_write <= epc_s1_in_a_write_cycle AND wait_for_epc_s1_counter;
  --epc_s1_in_a_write_cycle assignment, which is an e_assign
  epc_s1_in_a_write_cycle <= internal_cpu_data_master_granted_epc_s1 AND cpu_data_master_write;
  internal_epc_s1_wait_counter_eq_0 <= to_std_logic(((std_logic_vector'("000000000000000000000000000") & (epc_s1_wait_counter)) = std_logic_vector'("00000000000000000000000000000000")));
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      epc_s1_wait_counter <= std_logic_vector'("00000");
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        epc_s1_wait_counter <= epc_s1_counter_load_value;
      end if;
    end if;

  end process;

  epc_s1_counter_load_value <= A_EXT (A_WE_StdLogicVector((std_logic'(((epc_s1_in_a_read_cycle AND tri_state_bridge_avalon_slave_begins_xfer))) = '1'), std_logic_vector'("000000000000000000000000000001101"), A_WE_StdLogicVector((std_logic'(((epc_s1_in_a_write_cycle AND tri_state_bridge_avalon_slave_begins_xfer))) = '1'), std_logic_vector'("000000000000000000000000000010001"), A_WE_StdLogicVector((std_logic'((NOT internal_epc_s1_wait_counter_eq_0)) = '1'), ((std_logic_vector'("0000000000000000000000000000") & (epc_s1_wait_counter)) - std_logic_vector'("000000000000000000000000000000001")), std_logic_vector'("000000000000000000000000000000000")))), 5);
  wait_for_epc_s1_counter <= tri_state_bridge_avalon_slave_begins_xfer OR NOT internal_epc_s1_wait_counter_eq_0;
  (cpu_data_master_byteenable_epc_s1_segment_1(1), cpu_data_master_byteenable_epc_s1_segment_1(0), cpu_data_master_byteenable_epc_s1_segment_0(1), cpu_data_master_byteenable_epc_s1_segment_0(0)) <= cpu_data_master_byteenable;
  internal_cpu_data_master_byteenable_epc_s1 <= A_WE_StdLogicVector((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_dbs_address(1)))) = std_logic_vector'("00000000000000000000000000000000"))), cpu_data_master_byteenable_epc_s1_segment_0, cpu_data_master_byteenable_epc_s1_segment_1);
  --vhdl renameroo for output signals
  SRAM_s1_wait_counter_eq_0 <= internal_SRAM_s1_wait_counter_eq_0;
  --vhdl renameroo for output signals
  cpu_data_master_byteenable_epc_s1 <= internal_cpu_data_master_byteenable_epc_s1;
  --vhdl renameroo for output signals
  cpu_data_master_granted_SRAM_s1 <= internal_cpu_data_master_granted_SRAM_s1;
  --vhdl renameroo for output signals
  cpu_data_master_granted_epc_s1 <= internal_cpu_data_master_granted_epc_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_SRAM_s1 <= internal_cpu_data_master_qualified_request_SRAM_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_epc_s1 <= internal_cpu_data_master_qualified_request_epc_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_SRAM_s1 <= internal_cpu_data_master_requests_SRAM_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_epc_s1 <= internal_cpu_data_master_requests_epc_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_granted_SRAM_s1 <= internal_cpu_instruction_master_granted_SRAM_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_granted_epc_s1 <= internal_cpu_instruction_master_granted_epc_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_qualified_request_SRAM_s1 <= internal_cpu_instruction_master_qualified_request_SRAM_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_qualified_request_epc_s1 <= internal_cpu_instruction_master_qualified_request_epc_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_requests_SRAM_s1 <= internal_cpu_instruction_master_requests_SRAM_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_requests_epc_s1 <= internal_cpu_instruction_master_requests_epc_s1;
  --vhdl renameroo for output signals
  epc_s1_wait_counter_eq_0 <= internal_epc_s1_wait_counter_eq_0;
  --vhdl renameroo for output signals
  incoming_tri_state_bridge_data <= internal_incoming_tri_state_bridge_data;
--synthesis translate_off
    --incoming_tri_state_bridge_data_bit_0_is_x x check, which is an e_assign_is_x
    incoming_tri_state_bridge_data_bit_0_is_x <= A_WE_StdLogic(is_x(std_ulogic(internal_incoming_tri_state_bridge_data(0))), '1','0');
    --Crush incoming_tri_state_bridge_data_with_Xs_converted_to_0[0] Xs to 0, which is an e_assign
    incoming_tri_state_bridge_data_with_Xs_converted_to_0(0) <= A_WE_StdLogic((std_logic'(incoming_tri_state_bridge_data_bit_0_is_x) = '1'), std_logic'('0'), internal_incoming_tri_state_bridge_data(0));
    --incoming_tri_state_bridge_data_bit_1_is_x x check, which is an e_assign_is_x
    incoming_tri_state_bridge_data_bit_1_is_x <= A_WE_StdLogic(is_x(std_ulogic(internal_incoming_tri_state_bridge_data(1))), '1','0');
    --Crush incoming_tri_state_bridge_data_with_Xs_converted_to_0[1] Xs to 0, which is an e_assign
    incoming_tri_state_bridge_data_with_Xs_converted_to_0(1) <= A_WE_StdLogic((std_logic'(incoming_tri_state_bridge_data_bit_1_is_x) = '1'), std_logic'('0'), internal_incoming_tri_state_bridge_data(1));
    --incoming_tri_state_bridge_data_bit_2_is_x x check, which is an e_assign_is_x
    incoming_tri_state_bridge_data_bit_2_is_x <= A_WE_StdLogic(is_x(std_ulogic(internal_incoming_tri_state_bridge_data(2))), '1','0');
    --Crush incoming_tri_state_bridge_data_with_Xs_converted_to_0[2] Xs to 0, which is an e_assign
    incoming_tri_state_bridge_data_with_Xs_converted_to_0(2) <= A_WE_StdLogic((std_logic'(incoming_tri_state_bridge_data_bit_2_is_x) = '1'), std_logic'('0'), internal_incoming_tri_state_bridge_data(2));
    --incoming_tri_state_bridge_data_bit_3_is_x x check, which is an e_assign_is_x
    incoming_tri_state_bridge_data_bit_3_is_x <= A_WE_StdLogic(is_x(std_ulogic(internal_incoming_tri_state_bridge_data(3))), '1','0');
    --Crush incoming_tri_state_bridge_data_with_Xs_converted_to_0[3] Xs to 0, which is an e_assign
    incoming_tri_state_bridge_data_with_Xs_converted_to_0(3) <= A_WE_StdLogic((std_logic'(incoming_tri_state_bridge_data_bit_3_is_x) = '1'), std_logic'('0'), internal_incoming_tri_state_bridge_data(3));
    --incoming_tri_state_bridge_data_bit_4_is_x x check, which is an e_assign_is_x
    incoming_tri_state_bridge_data_bit_4_is_x <= A_WE_StdLogic(is_x(std_ulogic(internal_incoming_tri_state_bridge_data(4))), '1','0');
    --Crush incoming_tri_state_bridge_data_with_Xs_converted_to_0[4] Xs to 0, which is an e_assign
    incoming_tri_state_bridge_data_with_Xs_converted_to_0(4) <= A_WE_StdLogic((std_logic'(incoming_tri_state_bridge_data_bit_4_is_x) = '1'), std_logic'('0'), internal_incoming_tri_state_bridge_data(4));
    --incoming_tri_state_bridge_data_bit_5_is_x x check, which is an e_assign_is_x
    incoming_tri_state_bridge_data_bit_5_is_x <= A_WE_StdLogic(is_x(std_ulogic(internal_incoming_tri_state_bridge_data(5))), '1','0');
    --Crush incoming_tri_state_bridge_data_with_Xs_converted_to_0[5] Xs to 0, which is an e_assign
    incoming_tri_state_bridge_data_with_Xs_converted_to_0(5) <= A_WE_StdLogic((std_logic'(incoming_tri_state_bridge_data_bit_5_is_x) = '1'), std_logic'('0'), internal_incoming_tri_state_bridge_data(5));
    --incoming_tri_state_bridge_data_bit_6_is_x x check, which is an e_assign_is_x
    incoming_tri_state_bridge_data_bit_6_is_x <= A_WE_StdLogic(is_x(std_ulogic(internal_incoming_tri_state_bridge_data(6))), '1','0');
    --Crush incoming_tri_state_bridge_data_with_Xs_converted_to_0[6] Xs to 0, which is an e_assign
    incoming_tri_state_bridge_data_with_Xs_converted_to_0(6) <= A_WE_StdLogic((std_logic'(incoming_tri_state_bridge_data_bit_6_is_x) = '1'), std_logic'('0'), internal_incoming_tri_state_bridge_data(6));
    --incoming_tri_state_bridge_data_bit_7_is_x x check, which is an e_assign_is_x
    incoming_tri_state_bridge_data_bit_7_is_x <= A_WE_StdLogic(is_x(std_ulogic(internal_incoming_tri_state_bridge_data(7))), '1','0');
    --Crush incoming_tri_state_bridge_data_with_Xs_converted_to_0[7] Xs to 0, which is an e_assign
    incoming_tri_state_bridge_data_with_Xs_converted_to_0(7) <= A_WE_StdLogic((std_logic'(incoming_tri_state_bridge_data_bit_7_is_x) = '1'), std_logic'('0'), internal_incoming_tri_state_bridge_data(7));
    --incoming_tri_state_bridge_data_bit_8_is_x x check, which is an e_assign_is_x
    incoming_tri_state_bridge_data_bit_8_is_x <= A_WE_StdLogic(is_x(std_ulogic(internal_incoming_tri_state_bridge_data(8))), '1','0');
    --Crush incoming_tri_state_bridge_data_with_Xs_converted_to_0[8] Xs to 0, which is an e_assign
    incoming_tri_state_bridge_data_with_Xs_converted_to_0(8) <= A_WE_StdLogic((std_logic'(incoming_tri_state_bridge_data_bit_8_is_x) = '1'), std_logic'('0'), internal_incoming_tri_state_bridge_data(8));
    --incoming_tri_state_bridge_data_bit_9_is_x x check, which is an e_assign_is_x
    incoming_tri_state_bridge_data_bit_9_is_x <= A_WE_StdLogic(is_x(std_ulogic(internal_incoming_tri_state_bridge_data(9))), '1','0');
    --Crush incoming_tri_state_bridge_data_with_Xs_converted_to_0[9] Xs to 0, which is an e_assign
    incoming_tri_state_bridge_data_with_Xs_converted_to_0(9) <= A_WE_StdLogic((std_logic'(incoming_tri_state_bridge_data_bit_9_is_x) = '1'), std_logic'('0'), internal_incoming_tri_state_bridge_data(9));
    --incoming_tri_state_bridge_data_bit_10_is_x x check, which is an e_assign_is_x
    incoming_tri_state_bridge_data_bit_10_is_x <= A_WE_StdLogic(is_x(std_ulogic(internal_incoming_tri_state_bridge_data(10))), '1','0');
    --Crush incoming_tri_state_bridge_data_with_Xs_converted_to_0[10] Xs to 0, which is an e_assign
    incoming_tri_state_bridge_data_with_Xs_converted_to_0(10) <= A_WE_StdLogic((std_logic'(incoming_tri_state_bridge_data_bit_10_is_x) = '1'), std_logic'('0'), internal_incoming_tri_state_bridge_data(10));
    --incoming_tri_state_bridge_data_bit_11_is_x x check, which is an e_assign_is_x
    incoming_tri_state_bridge_data_bit_11_is_x <= A_WE_StdLogic(is_x(std_ulogic(internal_incoming_tri_state_bridge_data(11))), '1','0');
    --Crush incoming_tri_state_bridge_data_with_Xs_converted_to_0[11] Xs to 0, which is an e_assign
    incoming_tri_state_bridge_data_with_Xs_converted_to_0(11) <= A_WE_StdLogic((std_logic'(incoming_tri_state_bridge_data_bit_11_is_x) = '1'), std_logic'('0'), internal_incoming_tri_state_bridge_data(11));
    --incoming_tri_state_bridge_data_bit_12_is_x x check, which is an e_assign_is_x
    incoming_tri_state_bridge_data_bit_12_is_x <= A_WE_StdLogic(is_x(std_ulogic(internal_incoming_tri_state_bridge_data(12))), '1','0');
    --Crush incoming_tri_state_bridge_data_with_Xs_converted_to_0[12] Xs to 0, which is an e_assign
    incoming_tri_state_bridge_data_with_Xs_converted_to_0(12) <= A_WE_StdLogic((std_logic'(incoming_tri_state_bridge_data_bit_12_is_x) = '1'), std_logic'('0'), internal_incoming_tri_state_bridge_data(12));
    --incoming_tri_state_bridge_data_bit_13_is_x x check, which is an e_assign_is_x
    incoming_tri_state_bridge_data_bit_13_is_x <= A_WE_StdLogic(is_x(std_ulogic(internal_incoming_tri_state_bridge_data(13))), '1','0');
    --Crush incoming_tri_state_bridge_data_with_Xs_converted_to_0[13] Xs to 0, which is an e_assign
    incoming_tri_state_bridge_data_with_Xs_converted_to_0(13) <= A_WE_StdLogic((std_logic'(incoming_tri_state_bridge_data_bit_13_is_x) = '1'), std_logic'('0'), internal_incoming_tri_state_bridge_data(13));
    --incoming_tri_state_bridge_data_bit_14_is_x x check, which is an e_assign_is_x
    incoming_tri_state_bridge_data_bit_14_is_x <= A_WE_StdLogic(is_x(std_ulogic(internal_incoming_tri_state_bridge_data(14))), '1','0');
    --Crush incoming_tri_state_bridge_data_with_Xs_converted_to_0[14] Xs to 0, which is an e_assign
    incoming_tri_state_bridge_data_with_Xs_converted_to_0(14) <= A_WE_StdLogic((std_logic'(incoming_tri_state_bridge_data_bit_14_is_x) = '1'), std_logic'('0'), internal_incoming_tri_state_bridge_data(14));
    --incoming_tri_state_bridge_data_bit_15_is_x x check, which is an e_assign_is_x
    incoming_tri_state_bridge_data_bit_15_is_x <= A_WE_StdLogic(is_x(std_ulogic(internal_incoming_tri_state_bridge_data(15))), '1','0');
    --Crush incoming_tri_state_bridge_data_with_Xs_converted_to_0[15] Xs to 0, which is an e_assign
    incoming_tri_state_bridge_data_with_Xs_converted_to_0(15) <= A_WE_StdLogic((std_logic'(incoming_tri_state_bridge_data_bit_15_is_x) = '1'), std_logic'('0'), internal_incoming_tri_state_bridge_data(15));
    --grant signals are active simultaneously, which is an e_process
    process (clk)
    VARIABLE write_line6 : line;
    begin
      if clk'event and clk = '1' then
        if (std_logic_vector'("0000000000000000000000000000") & (((std_logic_vector'("0") & (((std_logic_vector'("0") & (((std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(internal_cpu_data_master_granted_SRAM_s1))) + (std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(internal_cpu_data_master_granted_epc_s1)))))) + (std_logic_vector'("00") & (A_TOSTDLOGICVECTOR(internal_cpu_instruction_master_granted_SRAM_s1)))))) + (std_logic_vector'("000") & (A_TOSTDLOGICVECTOR(internal_cpu_instruction_master_granted_epc_s1))))))>std_logic_vector'("00000000000000000000000000000001") then 
          write(write_line6, now);
          write(write_line6, string'(": "));
          write(write_line6, string'("> 1 of grant signals are active simultaneously"));
          write(output, write_line6.all);
          deallocate (write_line6);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

    --saved_grant signals are active simultaneously, which is an e_process
    process (clk)
    VARIABLE write_line7 : line;
    begin
      if clk'event and clk = '1' then
        if (std_logic_vector'("0000000000000000000000000000") & (((std_logic_vector'("0") & (((std_logic_vector'("0") & (((std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(cpu_data_master_saved_grant_SRAM_s1))) + (std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(cpu_data_master_saved_grant_epc_s1)))))) + (std_logic_vector'("00") & (A_TOSTDLOGICVECTOR(cpu_instruction_master_saved_grant_SRAM_s1)))))) + (std_logic_vector'("000") & (A_TOSTDLOGICVECTOR(cpu_instruction_master_saved_grant_epc_s1))))))>std_logic_vector'("00000000000000000000000000000001") then 
          write(write_line7, now);
          write(write_line7, string'(": "));
          write(write_line7, string'("> 1 of saved_grant signals are active simultaneously"));
          write(output, write_line7.all);
          deallocate (write_line7);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

--synthesis translate_on
--synthesis read_comments_as_HDL on
--    
--    incoming_tri_state_bridge_data_with_Xs_converted_to_0 <= internal_incoming_tri_state_bridge_data (15 DOWNTO 0);
--synthesis read_comments_as_HDL off

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity tri_state_bridge_bridge_arbitrator is 
end entity tri_state_bridge_bridge_arbitrator;


architecture europa of tri_state_bridge_bridge_arbitrator is

begin


end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity nios_reset_clk_domain_synch_module is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal data_in : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal data_out : OUT STD_LOGIC
              );
end entity nios_reset_clk_domain_synch_module;


architecture europa of nios_reset_clk_domain_synch_module is
                signal data_in_d1 :  STD_LOGIC;
attribute ALTERA_ATTRIBUTE : string;
attribute ALTERA_ATTRIBUTE of data_in_d1 : signal is "PRESERVE_REGISTER=ON";
attribute ALTERA_ATTRIBUTE of data_out : signal is "PRESERVE_REGISTER=ON";

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      data_in_d1 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        data_in_d1 <= data_in;
      end if;
    end if;

  end process;

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      data_out <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        data_out <= data_in_d1;
      end if;
    end if;

  end process;


end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity nios is 
        port (
              -- 1) global signals:
                 signal clk : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;

              -- the_J23_SW
                 signal in_port_to_the_J23_SW : IN STD_LOGIC;

              -- the_dev_uart
                 signal rxd_to_the_dev_uart : IN STD_LOGIC;
                 signal txd_from_the_dev_uart : OUT STD_LOGIC;

              -- the_test_0_test
                 signal addr_to_the_test_0 : OUT STD_LOGIC_VECTOR (5 DOWNTO 0);
                 signal cs_to_the_test_0 : OUT STD_LOGIC;
                 signal readdata_from_the_test_0 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal wreq_from_the_test_0 : IN STD_LOGIC;
                 signal write_n_to_the_test_0 : OUT STD_LOGIC;
                 signal writedata_to_the_test_0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);

              -- the_tri_state_bridge_avalon_slave
                 signal be_n_to_the_SRAM : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal read_n_to_the_SRAM : OUT STD_LOGIC;
                 signal select0_n_to_the_SRAM : OUT STD_LOGIC;
                 signal select1_n_to_the_SRAM : OUT STD_LOGIC;
                 signal select_n_to_the_epc : OUT STD_LOGIC;
                 signal tri_state_bridge_address : OUT STD_LOGIC_VECTOR (20 DOWNTO 0);
                 signal tri_state_bridge_data : INOUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal tri_state_bridge_readn : OUT STD_LOGIC;
                 signal write_n_to_the_SRAM : OUT STD_LOGIC;
                 signal write_n_to_the_epc : OUT STD_LOGIC
              );
end entity nios;


architecture europa of nios is
component J23_SW_s1_arbitrator is 
           port (
                 -- inputs:
                    signal J23_SW_s1_irq : IN STD_LOGIC;
                    signal J23_SW_s1_readdata : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_waitrequest : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal J23_SW_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal J23_SW_s1_chipselect : OUT STD_LOGIC;
                    signal J23_SW_s1_irq_from_sa : OUT STD_LOGIC;
                    signal J23_SW_s1_readdata_from_sa : OUT STD_LOGIC;
                    signal J23_SW_s1_reset_n : OUT STD_LOGIC;
                    signal J23_SW_s1_write_n : OUT STD_LOGIC;
                    signal J23_SW_s1_writedata : OUT STD_LOGIC;
                    signal cpu_data_master_granted_J23_SW_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_J23_SW_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_J23_SW_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_J23_SW_s1 : OUT STD_LOGIC;
                    signal d1_J23_SW_s1_end_xfer : OUT STD_LOGIC
                 );
end component J23_SW_s1_arbitrator;

component J23_SW is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal in_port : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC;

                 -- outputs:
                    signal irq : OUT STD_LOGIC;
                    signal readdata : OUT STD_LOGIC
                 );
end component J23_SW;

component cpu_jtag_debug_module_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_data_master_debugaccess : IN STD_LOGIC;
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_instruction_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_instruction_master_read : IN STD_LOGIC;
                    signal cpu_jtag_debug_module_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_jtag_debug_module_resetrequest : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_data_master_granted_cpu_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_cpu_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_cpu_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_data_master_requests_cpu_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_instruction_master_granted_cpu_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_cpu_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_cpu_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_instruction_master_requests_cpu_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_jtag_debug_module_address : OUT STD_LOGIC_VECTOR (8 DOWNTO 0);
                    signal cpu_jtag_debug_module_begintransfer : OUT STD_LOGIC;
                    signal cpu_jtag_debug_module_byteenable : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_jtag_debug_module_chipselect : OUT STD_LOGIC;
                    signal cpu_jtag_debug_module_debugaccess : OUT STD_LOGIC;
                    signal cpu_jtag_debug_module_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_jtag_debug_module_reset : OUT STD_LOGIC;
                    signal cpu_jtag_debug_module_reset_n : OUT STD_LOGIC;
                    signal cpu_jtag_debug_module_resetrequest_from_sa : OUT STD_LOGIC;
                    signal cpu_jtag_debug_module_write : OUT STD_LOGIC;
                    signal cpu_jtag_debug_module_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal d1_cpu_jtag_debug_module_end_xfer : OUT STD_LOGIC
                 );
end component cpu_jtag_debug_module_arbitrator;

component cpu_data_master_arbitrator is 
           port (
                 -- inputs:
                    signal J23_SW_s1_irq_from_sa : IN STD_LOGIC;
                    signal J23_SW_s1_readdata_from_sa : IN STD_LOGIC;
                    signal SRAM_s1_wait_counter_eq_0 : IN STD_LOGIC;
                    signal SRAM_s1_wait_counter_eq_1 : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_data_master_byteenable_epc_s1 : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_data_master_debugaccess : IN STD_LOGIC;
                    signal cpu_data_master_granted_J23_SW_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_SRAM_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_cpu_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_data_master_granted_dev_uart_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_epc_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_onchip_RAM_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_onchip_ROM_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_sysid_control_slave : IN STD_LOGIC;
                    signal cpu_data_master_granted_test_0_test : IN STD_LOGIC;
                    signal cpu_data_master_granted_timer_0_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_J23_SW_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_SRAM_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_cpu_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_dev_uart_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_epc_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_onchip_RAM_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_onchip_ROM_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_sysid_control_slave : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_test_0_test : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_timer_0_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_J23_SW_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_SRAM_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_cpu_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_dev_uart_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_epc_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_onchip_RAM_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_onchip_ROM_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_sysid_control_slave : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_test_0_test : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_timer_0_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_J23_SW_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_SRAM_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_cpu_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_data_master_requests_dev_uart_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_epc_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_onchip_RAM_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_onchip_ROM_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_sysid_control_slave : IN STD_LOGIC;
                    signal cpu_data_master_requests_test_0_test : IN STD_LOGIC;
                    signal cpu_data_master_requests_timer_0_s1 : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_jtag_debug_module_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal d1_J23_SW_s1_end_xfer : IN STD_LOGIC;
                    signal d1_cpu_jtag_debug_module_end_xfer : IN STD_LOGIC;
                    signal d1_dev_uart_s1_end_xfer : IN STD_LOGIC;
                    signal d1_onchip_RAM_s1_end_xfer : IN STD_LOGIC;
                    signal d1_onchip_ROM_s1_end_xfer : IN STD_LOGIC;
                    signal d1_sysid_control_slave_end_xfer : IN STD_LOGIC;
                    signal d1_test_0_test_end_xfer : IN STD_LOGIC;
                    signal d1_timer_0_s1_end_xfer : IN STD_LOGIC;
                    signal d1_tri_state_bridge_avalon_slave_end_xfer : IN STD_LOGIC;
                    signal dev_uart_s1_irq_from_sa : IN STD_LOGIC;
                    signal dev_uart_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal epc_s1_wait_counter_eq_0 : IN STD_LOGIC;
                    signal epc_s1_wait_counter_eq_1 : IN STD_LOGIC;
                    signal incoming_tri_state_bridge_data : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal incoming_tri_state_bridge_data_with_Xs_converted_to_0 : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal onchip_RAM_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal onchip_ROM_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal readdata_from_the_test_0_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal registered_cpu_data_master_read_data_valid_SRAM_s1 : IN STD_LOGIC;
                    signal registered_cpu_data_master_read_data_valid_epc_s1 : IN STD_LOGIC;
                    signal registered_cpu_data_master_read_data_valid_onchip_RAM_s1 : IN STD_LOGIC;
                    signal registered_cpu_data_master_read_data_valid_onchip_ROM_s1 : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal sysid_control_slave_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal timer_0_s1_irq_from_sa : IN STD_LOGIC;
                    signal timer_0_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal wreq_from_the_test_0_from_sa : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_data_master_address_to_slave : OUT STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_data_master_dbs_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_data_master_dbs_write_16 : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal cpu_data_master_irq : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_data_master_no_byte_enables_and_last_term : OUT STD_LOGIC;
                    signal cpu_data_master_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_data_master_waitrequest : OUT STD_LOGIC
                 );
end component cpu_data_master_arbitrator;

component cpu_instruction_master_arbitrator is 
           port (
                 -- inputs:
                    signal SRAM_s1_wait_counter_eq_0 : IN STD_LOGIC;
                    signal SRAM_s1_wait_counter_eq_1 : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal cpu_instruction_master_address : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_instruction_master_granted_SRAM_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_granted_cpu_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_instruction_master_granted_epc_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_granted_onchip_ROM_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_SRAM_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_cpu_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_epc_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_onchip_ROM_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_read : IN STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_SRAM_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_cpu_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_epc_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_onchip_ROM_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_requests_SRAM_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_requests_cpu_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_instruction_master_requests_epc_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_requests_onchip_ROM_s1 : IN STD_LOGIC;
                    signal cpu_jtag_debug_module_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal d1_cpu_jtag_debug_module_end_xfer : IN STD_LOGIC;
                    signal d1_onchip_ROM_s1_end_xfer : IN STD_LOGIC;
                    signal d1_tri_state_bridge_avalon_slave_end_xfer : IN STD_LOGIC;
                    signal epc_s1_wait_counter_eq_0 : IN STD_LOGIC;
                    signal epc_s1_wait_counter_eq_1 : IN STD_LOGIC;
                    signal incoming_tri_state_bridge_data : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal onchip_ROM_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_instruction_master_address_to_slave : OUT STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_instruction_master_dbs_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_instruction_master_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_instruction_master_waitrequest : OUT STD_LOGIC
                 );
end component cpu_instruction_master_arbitrator;

component cpu is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal d_irq : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal d_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal d_waitrequest : IN STD_LOGIC;
                    signal i_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal i_waitrequest : IN STD_LOGIC;
                    signal jtag_debug_module_address : IN STD_LOGIC_VECTOR (8 DOWNTO 0);
                    signal jtag_debug_module_begintransfer : IN STD_LOGIC;
                    signal jtag_debug_module_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal jtag_debug_module_clk : IN STD_LOGIC;
                    signal jtag_debug_module_debugaccess : IN STD_LOGIC;
                    signal jtag_debug_module_reset : IN STD_LOGIC;
                    signal jtag_debug_module_select : IN STD_LOGIC;
                    signal jtag_debug_module_write : IN STD_LOGIC;
                    signal jtag_debug_module_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal d_address : OUT STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal d_byteenable : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal d_read : OUT STD_LOGIC;
                    signal d_write : OUT STD_LOGIC;
                    signal d_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal i_address : OUT STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal i_read : OUT STD_LOGIC;
                    signal jtag_debug_module_debugaccess_to_roms : OUT STD_LOGIC;
                    signal jtag_debug_module_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal jtag_debug_module_resetrequest : OUT STD_LOGIC
                 );
end component cpu;

component dev_uart_s1_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal dev_uart_s1_dataavailable : IN STD_LOGIC;
                    signal dev_uart_s1_irq : IN STD_LOGIC;
                    signal dev_uart_s1_readdata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal dev_uart_s1_readyfordata : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_data_master_granted_dev_uart_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_dev_uart_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_dev_uart_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_dev_uart_s1 : OUT STD_LOGIC;
                    signal d1_dev_uart_s1_end_xfer : OUT STD_LOGIC;
                    signal dev_uart_s1_address : OUT STD_LOGIC_VECTOR (2 DOWNTO 0);
                    signal dev_uart_s1_begintransfer : OUT STD_LOGIC;
                    signal dev_uart_s1_chipselect : OUT STD_LOGIC;
                    signal dev_uart_s1_dataavailable_from_sa : OUT STD_LOGIC;
                    signal dev_uart_s1_irq_from_sa : OUT STD_LOGIC;
                    signal dev_uart_s1_read_n : OUT STD_LOGIC;
                    signal dev_uart_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal dev_uart_s1_readyfordata_from_sa : OUT STD_LOGIC;
                    signal dev_uart_s1_reset_n : OUT STD_LOGIC;
                    signal dev_uart_s1_write_n : OUT STD_LOGIC;
                    signal dev_uart_s1_writedata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
                 );
end component dev_uart_s1_arbitrator;

component dev_uart is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (2 DOWNTO 0);
                    signal begintransfer : IN STD_LOGIC;
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal read_n : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal rxd : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);

                 -- outputs:
                    signal dataavailable : OUT STD_LOGIC;
                    signal irq : OUT STD_LOGIC;
                    signal readdata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal readyfordata : OUT STD_LOGIC;
                    signal txd : OUT STD_LOGIC
                 );
end component dev_uart;

component onchip_RAM_s1_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_waitrequest : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal onchip_RAM_s1_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_data_master_granted_onchip_RAM_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_onchip_RAM_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_onchip_RAM_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_onchip_RAM_s1 : OUT STD_LOGIC;
                    signal d1_onchip_RAM_s1_end_xfer : OUT STD_LOGIC;
                    signal onchip_RAM_s1_address : OUT STD_LOGIC_VECTOR (13 DOWNTO 0);
                    signal onchip_RAM_s1_byteenable : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal onchip_RAM_s1_chipselect : OUT STD_LOGIC;
                    signal onchip_RAM_s1_clken : OUT STD_LOGIC;
                    signal onchip_RAM_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal onchip_RAM_s1_write : OUT STD_LOGIC;
                    signal onchip_RAM_s1_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal registered_cpu_data_master_read_data_valid_onchip_RAM_s1 : OUT STD_LOGIC
                 );
end component onchip_RAM_s1_arbitrator;

component onchip_RAM is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (13 DOWNTO 0);
                    signal byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal clken : IN STD_LOGIC;
                    signal write : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

                 -- outputs:
                    signal readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component onchip_RAM;

component onchip_ROM_s1_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_data_master_debugaccess : IN STD_LOGIC;
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_waitrequest : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_instruction_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_instruction_master_read : IN STD_LOGIC;
                    signal onchip_ROM_s1_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_data_master_granted_onchip_ROM_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_onchip_ROM_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_onchip_ROM_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_onchip_ROM_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_granted_onchip_ROM_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_onchip_ROM_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_onchip_ROM_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_requests_onchip_ROM_s1 : OUT STD_LOGIC;
                    signal d1_onchip_ROM_s1_end_xfer : OUT STD_LOGIC;
                    signal onchip_ROM_s1_address : OUT STD_LOGIC_VECTOR (13 DOWNTO 0);
                    signal onchip_ROM_s1_byteenable : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal onchip_ROM_s1_chipselect : OUT STD_LOGIC;
                    signal onchip_ROM_s1_clken : OUT STD_LOGIC;
                    signal onchip_ROM_s1_debugaccess : OUT STD_LOGIC;
                    signal onchip_ROM_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal onchip_ROM_s1_write : OUT STD_LOGIC;
                    signal onchip_ROM_s1_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal registered_cpu_data_master_read_data_valid_onchip_ROM_s1 : OUT STD_LOGIC
                 );
end component onchip_ROM_s1_arbitrator;

component onchip_ROM is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (13 DOWNTO 0);
                    signal byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal clken : IN STD_LOGIC;
                    signal debugaccess : IN STD_LOGIC;
                    signal write : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

                 -- outputs:
                    signal readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component onchip_ROM;

component sysid_control_slave_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal sysid_control_slave_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

                 -- outputs:
                    signal cpu_data_master_granted_sysid_control_slave : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_sysid_control_slave : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_sysid_control_slave : OUT STD_LOGIC;
                    signal cpu_data_master_requests_sysid_control_slave : OUT STD_LOGIC;
                    signal d1_sysid_control_slave_end_xfer : OUT STD_LOGIC;
                    signal sysid_control_slave_address : OUT STD_LOGIC;
                    signal sysid_control_slave_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component sysid_control_slave_arbitrator;

component sysid is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC;

                 -- outputs:
                    signal readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component sysid;

component test_0_test_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_waitrequest : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal readdata_from_the_test_0 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;
                    signal wreq_from_the_test_0 : IN STD_LOGIC;

                 -- outputs:
                    signal addr_to_the_test_0 : OUT STD_LOGIC_VECTOR (5 DOWNTO 0);
                    signal cpu_data_master_granted_test_0_test : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_test_0_test : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_test_0_test : OUT STD_LOGIC;
                    signal cpu_data_master_requests_test_0_test : OUT STD_LOGIC;
                    signal cs_to_the_test_0 : OUT STD_LOGIC;
                    signal d1_test_0_test_end_xfer : OUT STD_LOGIC;
                    signal readdata_from_the_test_0_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal wreq_from_the_test_0_from_sa : OUT STD_LOGIC;
                    signal write_n_to_the_test_0 : OUT STD_LOGIC;
                    signal writedata_to_the_test_0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component test_0_test_arbitrator;

component timer_0_s1_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_waitrequest : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;
                    signal timer_0_s1_irq : IN STD_LOGIC;
                    signal timer_0_s1_readdata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);

                 -- outputs:
                    signal cpu_data_master_granted_timer_0_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_timer_0_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_timer_0_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_timer_0_s1 : OUT STD_LOGIC;
                    signal d1_timer_0_s1_end_xfer : OUT STD_LOGIC;
                    signal timer_0_s1_address : OUT STD_LOGIC_VECTOR (2 DOWNTO 0);
                    signal timer_0_s1_chipselect : OUT STD_LOGIC;
                    signal timer_0_s1_irq_from_sa : OUT STD_LOGIC;
                    signal timer_0_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal timer_0_s1_reset_n : OUT STD_LOGIC;
                    signal timer_0_s1_write_n : OUT STD_LOGIC;
                    signal timer_0_s1_writedata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
                 );
end component timer_0_s1_arbitrator;

component timer_0 is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (2 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);

                 -- outputs:
                    signal irq : OUT STD_LOGIC;
                    signal readdata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
                 );
end component timer_0;

component tri_state_bridge_avalon_slave_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_data_master_dbs_address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_data_master_dbs_write_16 : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal cpu_data_master_no_byte_enables_and_last_term : IN STD_LOGIC;
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_instruction_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_instruction_master_dbs_address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_instruction_master_read : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal SRAM_s1_wait_counter_eq_0 : OUT STD_LOGIC;
                    signal SRAM_s1_wait_counter_eq_1 : OUT STD_LOGIC;
                    signal be_n_to_the_SRAM : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_data_master_byteenable_epc_s1 : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_data_master_granted_SRAM_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_granted_epc_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_SRAM_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_epc_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_SRAM_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_epc_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_SRAM_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_epc_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_granted_SRAM_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_granted_epc_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_SRAM_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_epc_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_SRAM_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_epc_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_requests_SRAM_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_requests_epc_s1 : OUT STD_LOGIC;
                    signal d1_tri_state_bridge_avalon_slave_end_xfer : OUT STD_LOGIC;
                    signal epc_s1_wait_counter_eq_0 : OUT STD_LOGIC;
                    signal epc_s1_wait_counter_eq_1 : OUT STD_LOGIC;
                    signal incoming_tri_state_bridge_data : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal incoming_tri_state_bridge_data_with_Xs_converted_to_0 : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal read_n_to_the_SRAM : OUT STD_LOGIC;
                    signal registered_cpu_data_master_read_data_valid_SRAM_s1 : OUT STD_LOGIC;
                    signal registered_cpu_data_master_read_data_valid_epc_s1 : OUT STD_LOGIC;
                    signal select0_n_to_the_SRAM : OUT STD_LOGIC;
                    signal select1_n_to_the_SRAM : OUT STD_LOGIC;
                    signal select_n_to_the_epc : OUT STD_LOGIC;
                    signal tri_state_bridge_address : OUT STD_LOGIC_VECTOR (20 DOWNTO 0);
                    signal tri_state_bridge_data : INOUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal tri_state_bridge_readn : OUT STD_LOGIC;
                    signal write_n_to_the_SRAM : OUT STD_LOGIC;
                    signal write_n_to_the_epc : OUT STD_LOGIC
                 );
end component tri_state_bridge_avalon_slave_arbitrator;

component tri_state_bridge is 
end component tri_state_bridge;

component tri_state_bridge_bridge_arbitrator is 
end component tri_state_bridge_bridge_arbitrator;

component nios_reset_clk_domain_synch_module is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal data_in : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal data_out : OUT STD_LOGIC
                 );
end component nios_reset_clk_domain_synch_module;

                signal J23_SW_s1_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal J23_SW_s1_chipselect :  STD_LOGIC;
                signal J23_SW_s1_irq :  STD_LOGIC;
                signal J23_SW_s1_irq_from_sa :  STD_LOGIC;
                signal J23_SW_s1_readdata :  STD_LOGIC;
                signal J23_SW_s1_readdata_from_sa :  STD_LOGIC;
                signal J23_SW_s1_reset_n :  STD_LOGIC;
                signal J23_SW_s1_write_n :  STD_LOGIC;
                signal J23_SW_s1_writedata :  STD_LOGIC;
                signal SRAM_s1_wait_counter_eq_0 :  STD_LOGIC;
                signal SRAM_s1_wait_counter_eq_1 :  STD_LOGIC;
                signal clk_reset_n :  STD_LOGIC;
                signal cpu_data_master_address :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal cpu_data_master_address_to_slave :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal cpu_data_master_byteenable :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal cpu_data_master_byteenable_epc_s1 :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_data_master_dbs_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_data_master_dbs_write_16 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal cpu_data_master_debugaccess :  STD_LOGIC;
                signal cpu_data_master_granted_J23_SW_s1 :  STD_LOGIC;
                signal cpu_data_master_granted_SRAM_s1 :  STD_LOGIC;
                signal cpu_data_master_granted_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_data_master_granted_dev_uart_s1 :  STD_LOGIC;
                signal cpu_data_master_granted_epc_s1 :  STD_LOGIC;
                signal cpu_data_master_granted_onchip_RAM_s1 :  STD_LOGIC;
                signal cpu_data_master_granted_onchip_ROM_s1 :  STD_LOGIC;
                signal cpu_data_master_granted_sysid_control_slave :  STD_LOGIC;
                signal cpu_data_master_granted_test_0_test :  STD_LOGIC;
                signal cpu_data_master_granted_timer_0_s1 :  STD_LOGIC;
                signal cpu_data_master_irq :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_data_master_no_byte_enables_and_last_term :  STD_LOGIC;
                signal cpu_data_master_qualified_request_J23_SW_s1 :  STD_LOGIC;
                signal cpu_data_master_qualified_request_SRAM_s1 :  STD_LOGIC;
                signal cpu_data_master_qualified_request_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_data_master_qualified_request_dev_uart_s1 :  STD_LOGIC;
                signal cpu_data_master_qualified_request_epc_s1 :  STD_LOGIC;
                signal cpu_data_master_qualified_request_onchip_RAM_s1 :  STD_LOGIC;
                signal cpu_data_master_qualified_request_onchip_ROM_s1 :  STD_LOGIC;
                signal cpu_data_master_qualified_request_sysid_control_slave :  STD_LOGIC;
                signal cpu_data_master_qualified_request_test_0_test :  STD_LOGIC;
                signal cpu_data_master_qualified_request_timer_0_s1 :  STD_LOGIC;
                signal cpu_data_master_read :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_J23_SW_s1 :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_SRAM_s1 :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_dev_uart_s1 :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_epc_s1 :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_onchip_RAM_s1 :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_onchip_ROM_s1 :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_sysid_control_slave :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_test_0_test :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_timer_0_s1 :  STD_LOGIC;
                signal cpu_data_master_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_data_master_requests_J23_SW_s1 :  STD_LOGIC;
                signal cpu_data_master_requests_SRAM_s1 :  STD_LOGIC;
                signal cpu_data_master_requests_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_data_master_requests_dev_uart_s1 :  STD_LOGIC;
                signal cpu_data_master_requests_epc_s1 :  STD_LOGIC;
                signal cpu_data_master_requests_onchip_RAM_s1 :  STD_LOGIC;
                signal cpu_data_master_requests_onchip_ROM_s1 :  STD_LOGIC;
                signal cpu_data_master_requests_sysid_control_slave :  STD_LOGIC;
                signal cpu_data_master_requests_test_0_test :  STD_LOGIC;
                signal cpu_data_master_requests_timer_0_s1 :  STD_LOGIC;
                signal cpu_data_master_waitrequest :  STD_LOGIC;
                signal cpu_data_master_write :  STD_LOGIC;
                signal cpu_data_master_writedata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_instruction_master_address :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal cpu_instruction_master_address_to_slave :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal cpu_instruction_master_dbs_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_instruction_master_granted_SRAM_s1 :  STD_LOGIC;
                signal cpu_instruction_master_granted_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_instruction_master_granted_epc_s1 :  STD_LOGIC;
                signal cpu_instruction_master_granted_onchip_ROM_s1 :  STD_LOGIC;
                signal cpu_instruction_master_qualified_request_SRAM_s1 :  STD_LOGIC;
                signal cpu_instruction_master_qualified_request_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_instruction_master_qualified_request_epc_s1 :  STD_LOGIC;
                signal cpu_instruction_master_qualified_request_onchip_ROM_s1 :  STD_LOGIC;
                signal cpu_instruction_master_read :  STD_LOGIC;
                signal cpu_instruction_master_read_data_valid_SRAM_s1 :  STD_LOGIC;
                signal cpu_instruction_master_read_data_valid_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_instruction_master_read_data_valid_epc_s1 :  STD_LOGIC;
                signal cpu_instruction_master_read_data_valid_onchip_ROM_s1 :  STD_LOGIC;
                signal cpu_instruction_master_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_instruction_master_requests_SRAM_s1 :  STD_LOGIC;
                signal cpu_instruction_master_requests_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_instruction_master_requests_epc_s1 :  STD_LOGIC;
                signal cpu_instruction_master_requests_onchip_ROM_s1 :  STD_LOGIC;
                signal cpu_instruction_master_waitrequest :  STD_LOGIC;
                signal cpu_jtag_debug_module_address :  STD_LOGIC_VECTOR (8 DOWNTO 0);
                signal cpu_jtag_debug_module_begintransfer :  STD_LOGIC;
                signal cpu_jtag_debug_module_byteenable :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal cpu_jtag_debug_module_chipselect :  STD_LOGIC;
                signal cpu_jtag_debug_module_debugaccess :  STD_LOGIC;
                signal cpu_jtag_debug_module_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_jtag_debug_module_readdata_from_sa :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_jtag_debug_module_reset :  STD_LOGIC;
                signal cpu_jtag_debug_module_reset_n :  STD_LOGIC;
                signal cpu_jtag_debug_module_resetrequest :  STD_LOGIC;
                signal cpu_jtag_debug_module_resetrequest_from_sa :  STD_LOGIC;
                signal cpu_jtag_debug_module_write :  STD_LOGIC;
                signal cpu_jtag_debug_module_writedata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal d1_J23_SW_s1_end_xfer :  STD_LOGIC;
                signal d1_cpu_jtag_debug_module_end_xfer :  STD_LOGIC;
                signal d1_dev_uart_s1_end_xfer :  STD_LOGIC;
                signal d1_onchip_RAM_s1_end_xfer :  STD_LOGIC;
                signal d1_onchip_ROM_s1_end_xfer :  STD_LOGIC;
                signal d1_sysid_control_slave_end_xfer :  STD_LOGIC;
                signal d1_test_0_test_end_xfer :  STD_LOGIC;
                signal d1_timer_0_s1_end_xfer :  STD_LOGIC;
                signal d1_tri_state_bridge_avalon_slave_end_xfer :  STD_LOGIC;
                signal dev_uart_s1_address :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal dev_uart_s1_begintransfer :  STD_LOGIC;
                signal dev_uart_s1_chipselect :  STD_LOGIC;
                signal dev_uart_s1_dataavailable :  STD_LOGIC;
                signal dev_uart_s1_dataavailable_from_sa :  STD_LOGIC;
                signal dev_uart_s1_irq :  STD_LOGIC;
                signal dev_uart_s1_irq_from_sa :  STD_LOGIC;
                signal dev_uart_s1_read_n :  STD_LOGIC;
                signal dev_uart_s1_readdata :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dev_uart_s1_readdata_from_sa :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dev_uart_s1_readyfordata :  STD_LOGIC;
                signal dev_uart_s1_readyfordata_from_sa :  STD_LOGIC;
                signal dev_uart_s1_reset_n :  STD_LOGIC;
                signal dev_uart_s1_write_n :  STD_LOGIC;
                signal dev_uart_s1_writedata :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal epc_s1_wait_counter_eq_0 :  STD_LOGIC;
                signal epc_s1_wait_counter_eq_1 :  STD_LOGIC;
                signal incoming_tri_state_bridge_data :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal incoming_tri_state_bridge_data_with_Xs_converted_to_0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal internal_addr_to_the_test_0 :  STD_LOGIC_VECTOR (5 DOWNTO 0);
                signal internal_be_n_to_the_SRAM :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal internal_cs_to_the_test_0 :  STD_LOGIC;
                signal internal_read_n_to_the_SRAM :  STD_LOGIC;
                signal internal_select0_n_to_the_SRAM :  STD_LOGIC;
                signal internal_select1_n_to_the_SRAM :  STD_LOGIC;
                signal internal_select_n_to_the_epc :  STD_LOGIC;
                signal internal_tri_state_bridge_address :  STD_LOGIC_VECTOR (20 DOWNTO 0);
                signal internal_tri_state_bridge_readn :  STD_LOGIC;
                signal internal_txd_from_the_dev_uart :  STD_LOGIC;
                signal internal_write_n_to_the_SRAM :  STD_LOGIC;
                signal internal_write_n_to_the_epc :  STD_LOGIC;
                signal internal_write_n_to_the_test_0 :  STD_LOGIC;
                signal internal_writedata_to_the_test_0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal module_input :  STD_LOGIC;
                signal onchip_RAM_s1_address :  STD_LOGIC_VECTOR (13 DOWNTO 0);
                signal onchip_RAM_s1_byteenable :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal onchip_RAM_s1_chipselect :  STD_LOGIC;
                signal onchip_RAM_s1_clken :  STD_LOGIC;
                signal onchip_RAM_s1_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal onchip_RAM_s1_readdata_from_sa :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal onchip_RAM_s1_write :  STD_LOGIC;
                signal onchip_RAM_s1_writedata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal onchip_ROM_s1_address :  STD_LOGIC_VECTOR (13 DOWNTO 0);
                signal onchip_ROM_s1_byteenable :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal onchip_ROM_s1_chipselect :  STD_LOGIC;
                signal onchip_ROM_s1_clken :  STD_LOGIC;
                signal onchip_ROM_s1_debugaccess :  STD_LOGIC;
                signal onchip_ROM_s1_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal onchip_ROM_s1_readdata_from_sa :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal onchip_ROM_s1_write :  STD_LOGIC;
                signal onchip_ROM_s1_writedata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal readdata_from_the_test_0_from_sa :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal registered_cpu_data_master_read_data_valid_SRAM_s1 :  STD_LOGIC;
                signal registered_cpu_data_master_read_data_valid_epc_s1 :  STD_LOGIC;
                signal registered_cpu_data_master_read_data_valid_onchip_RAM_s1 :  STD_LOGIC;
                signal registered_cpu_data_master_read_data_valid_onchip_ROM_s1 :  STD_LOGIC;
                signal reset_n_sources :  STD_LOGIC;
                signal sysid_control_slave_address :  STD_LOGIC;
                signal sysid_control_slave_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal sysid_control_slave_readdata_from_sa :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal timer_0_s1_address :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal timer_0_s1_chipselect :  STD_LOGIC;
                signal timer_0_s1_irq :  STD_LOGIC;
                signal timer_0_s1_irq_from_sa :  STD_LOGIC;
                signal timer_0_s1_readdata :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal timer_0_s1_readdata_from_sa :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal timer_0_s1_reset_n :  STD_LOGIC;
                signal timer_0_s1_write_n :  STD_LOGIC;
                signal timer_0_s1_writedata :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal wreq_from_the_test_0_from_sa :  STD_LOGIC;

begin

  --the_J23_SW_s1, which is an e_instance
  the_J23_SW_s1 : J23_SW_s1_arbitrator
    port map(
      J23_SW_s1_address => J23_SW_s1_address,
      J23_SW_s1_chipselect => J23_SW_s1_chipselect,
      J23_SW_s1_irq_from_sa => J23_SW_s1_irq_from_sa,
      J23_SW_s1_readdata_from_sa => J23_SW_s1_readdata_from_sa,
      J23_SW_s1_reset_n => J23_SW_s1_reset_n,
      J23_SW_s1_write_n => J23_SW_s1_write_n,
      J23_SW_s1_writedata => J23_SW_s1_writedata,
      cpu_data_master_granted_J23_SW_s1 => cpu_data_master_granted_J23_SW_s1,
      cpu_data_master_qualified_request_J23_SW_s1 => cpu_data_master_qualified_request_J23_SW_s1,
      cpu_data_master_read_data_valid_J23_SW_s1 => cpu_data_master_read_data_valid_J23_SW_s1,
      cpu_data_master_requests_J23_SW_s1 => cpu_data_master_requests_J23_SW_s1,
      d1_J23_SW_s1_end_xfer => d1_J23_SW_s1_end_xfer,
      J23_SW_s1_irq => J23_SW_s1_irq,
      J23_SW_s1_readdata => J23_SW_s1_readdata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_waitrequest => cpu_data_master_waitrequest,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      reset_n => clk_reset_n
    );


  --the_J23_SW, which is an e_ptf_instance
  the_J23_SW : J23_SW
    port map(
      irq => J23_SW_s1_irq,
      readdata => J23_SW_s1_readdata,
      address => J23_SW_s1_address,
      chipselect => J23_SW_s1_chipselect,
      clk => clk,
      in_port => in_port_to_the_J23_SW,
      reset_n => J23_SW_s1_reset_n,
      write_n => J23_SW_s1_write_n,
      writedata => J23_SW_s1_writedata
    );


  --the_cpu_jtag_debug_module, which is an e_instance
  the_cpu_jtag_debug_module : cpu_jtag_debug_module_arbitrator
    port map(
      cpu_data_master_granted_cpu_jtag_debug_module => cpu_data_master_granted_cpu_jtag_debug_module,
      cpu_data_master_qualified_request_cpu_jtag_debug_module => cpu_data_master_qualified_request_cpu_jtag_debug_module,
      cpu_data_master_read_data_valid_cpu_jtag_debug_module => cpu_data_master_read_data_valid_cpu_jtag_debug_module,
      cpu_data_master_requests_cpu_jtag_debug_module => cpu_data_master_requests_cpu_jtag_debug_module,
      cpu_instruction_master_granted_cpu_jtag_debug_module => cpu_instruction_master_granted_cpu_jtag_debug_module,
      cpu_instruction_master_qualified_request_cpu_jtag_debug_module => cpu_instruction_master_qualified_request_cpu_jtag_debug_module,
      cpu_instruction_master_read_data_valid_cpu_jtag_debug_module => cpu_instruction_master_read_data_valid_cpu_jtag_debug_module,
      cpu_instruction_master_requests_cpu_jtag_debug_module => cpu_instruction_master_requests_cpu_jtag_debug_module,
      cpu_jtag_debug_module_address => cpu_jtag_debug_module_address,
      cpu_jtag_debug_module_begintransfer => cpu_jtag_debug_module_begintransfer,
      cpu_jtag_debug_module_byteenable => cpu_jtag_debug_module_byteenable,
      cpu_jtag_debug_module_chipselect => cpu_jtag_debug_module_chipselect,
      cpu_jtag_debug_module_debugaccess => cpu_jtag_debug_module_debugaccess,
      cpu_jtag_debug_module_readdata_from_sa => cpu_jtag_debug_module_readdata_from_sa,
      cpu_jtag_debug_module_reset => cpu_jtag_debug_module_reset,
      cpu_jtag_debug_module_reset_n => cpu_jtag_debug_module_reset_n,
      cpu_jtag_debug_module_resetrequest_from_sa => cpu_jtag_debug_module_resetrequest_from_sa,
      cpu_jtag_debug_module_write => cpu_jtag_debug_module_write,
      cpu_jtag_debug_module_writedata => cpu_jtag_debug_module_writedata,
      d1_cpu_jtag_debug_module_end_xfer => d1_cpu_jtag_debug_module_end_xfer,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_byteenable => cpu_data_master_byteenable,
      cpu_data_master_debugaccess => cpu_data_master_debugaccess,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      cpu_instruction_master_address_to_slave => cpu_instruction_master_address_to_slave,
      cpu_instruction_master_read => cpu_instruction_master_read,
      cpu_jtag_debug_module_readdata => cpu_jtag_debug_module_readdata,
      cpu_jtag_debug_module_resetrequest => cpu_jtag_debug_module_resetrequest,
      reset_n => clk_reset_n
    );


  --the_cpu_data_master, which is an e_instance
  the_cpu_data_master : cpu_data_master_arbitrator
    port map(
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_dbs_address => cpu_data_master_dbs_address,
      cpu_data_master_dbs_write_16 => cpu_data_master_dbs_write_16,
      cpu_data_master_irq => cpu_data_master_irq,
      cpu_data_master_no_byte_enables_and_last_term => cpu_data_master_no_byte_enables_and_last_term,
      cpu_data_master_readdata => cpu_data_master_readdata,
      cpu_data_master_waitrequest => cpu_data_master_waitrequest,
      J23_SW_s1_irq_from_sa => J23_SW_s1_irq_from_sa,
      J23_SW_s1_readdata_from_sa => J23_SW_s1_readdata_from_sa,
      SRAM_s1_wait_counter_eq_0 => SRAM_s1_wait_counter_eq_0,
      SRAM_s1_wait_counter_eq_1 => SRAM_s1_wait_counter_eq_1,
      clk => clk,
      cpu_data_master_address => cpu_data_master_address,
      cpu_data_master_byteenable_epc_s1 => cpu_data_master_byteenable_epc_s1,
      cpu_data_master_debugaccess => cpu_data_master_debugaccess,
      cpu_data_master_granted_J23_SW_s1 => cpu_data_master_granted_J23_SW_s1,
      cpu_data_master_granted_SRAM_s1 => cpu_data_master_granted_SRAM_s1,
      cpu_data_master_granted_cpu_jtag_debug_module => cpu_data_master_granted_cpu_jtag_debug_module,
      cpu_data_master_granted_dev_uart_s1 => cpu_data_master_granted_dev_uart_s1,
      cpu_data_master_granted_epc_s1 => cpu_data_master_granted_epc_s1,
      cpu_data_master_granted_onchip_RAM_s1 => cpu_data_master_granted_onchip_RAM_s1,
      cpu_data_master_granted_onchip_ROM_s1 => cpu_data_master_granted_onchip_ROM_s1,
      cpu_data_master_granted_sysid_control_slave => cpu_data_master_granted_sysid_control_slave,
      cpu_data_master_granted_test_0_test => cpu_data_master_granted_test_0_test,
      cpu_data_master_granted_timer_0_s1 => cpu_data_master_granted_timer_0_s1,
      cpu_data_master_qualified_request_J23_SW_s1 => cpu_data_master_qualified_request_J23_SW_s1,
      cpu_data_master_qualified_request_SRAM_s1 => cpu_data_master_qualified_request_SRAM_s1,
      cpu_data_master_qualified_request_cpu_jtag_debug_module => cpu_data_master_qualified_request_cpu_jtag_debug_module,
      cpu_data_master_qualified_request_dev_uart_s1 => cpu_data_master_qualified_request_dev_uart_s1,
      cpu_data_master_qualified_request_epc_s1 => cpu_data_master_qualified_request_epc_s1,
      cpu_data_master_qualified_request_onchip_RAM_s1 => cpu_data_master_qualified_request_onchip_RAM_s1,
      cpu_data_master_qualified_request_onchip_ROM_s1 => cpu_data_master_qualified_request_onchip_ROM_s1,
      cpu_data_master_qualified_request_sysid_control_slave => cpu_data_master_qualified_request_sysid_control_slave,
      cpu_data_master_qualified_request_test_0_test => cpu_data_master_qualified_request_test_0_test,
      cpu_data_master_qualified_request_timer_0_s1 => cpu_data_master_qualified_request_timer_0_s1,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_read_data_valid_J23_SW_s1 => cpu_data_master_read_data_valid_J23_SW_s1,
      cpu_data_master_read_data_valid_SRAM_s1 => cpu_data_master_read_data_valid_SRAM_s1,
      cpu_data_master_read_data_valid_cpu_jtag_debug_module => cpu_data_master_read_data_valid_cpu_jtag_debug_module,
      cpu_data_master_read_data_valid_dev_uart_s1 => cpu_data_master_read_data_valid_dev_uart_s1,
      cpu_data_master_read_data_valid_epc_s1 => cpu_data_master_read_data_valid_epc_s1,
      cpu_data_master_read_data_valid_onchip_RAM_s1 => cpu_data_master_read_data_valid_onchip_RAM_s1,
      cpu_data_master_read_data_valid_onchip_ROM_s1 => cpu_data_master_read_data_valid_onchip_ROM_s1,
      cpu_data_master_read_data_valid_sysid_control_slave => cpu_data_master_read_data_valid_sysid_control_slave,
      cpu_data_master_read_data_valid_test_0_test => cpu_data_master_read_data_valid_test_0_test,
      cpu_data_master_read_data_valid_timer_0_s1 => cpu_data_master_read_data_valid_timer_0_s1,
      cpu_data_master_requests_J23_SW_s1 => cpu_data_master_requests_J23_SW_s1,
      cpu_data_master_requests_SRAM_s1 => cpu_data_master_requests_SRAM_s1,
      cpu_data_master_requests_cpu_jtag_debug_module => cpu_data_master_requests_cpu_jtag_debug_module,
      cpu_data_master_requests_dev_uart_s1 => cpu_data_master_requests_dev_uart_s1,
      cpu_data_master_requests_epc_s1 => cpu_data_master_requests_epc_s1,
      cpu_data_master_requests_onchip_RAM_s1 => cpu_data_master_requests_onchip_RAM_s1,
      cpu_data_master_requests_onchip_ROM_s1 => cpu_data_master_requests_onchip_ROM_s1,
      cpu_data_master_requests_sysid_control_slave => cpu_data_master_requests_sysid_control_slave,
      cpu_data_master_requests_test_0_test => cpu_data_master_requests_test_0_test,
      cpu_data_master_requests_timer_0_s1 => cpu_data_master_requests_timer_0_s1,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      cpu_jtag_debug_module_readdata_from_sa => cpu_jtag_debug_module_readdata_from_sa,
      d1_J23_SW_s1_end_xfer => d1_J23_SW_s1_end_xfer,
      d1_cpu_jtag_debug_module_end_xfer => d1_cpu_jtag_debug_module_end_xfer,
      d1_dev_uart_s1_end_xfer => d1_dev_uart_s1_end_xfer,
      d1_onchip_RAM_s1_end_xfer => d1_onchip_RAM_s1_end_xfer,
      d1_onchip_ROM_s1_end_xfer => d1_onchip_ROM_s1_end_xfer,
      d1_sysid_control_slave_end_xfer => d1_sysid_control_slave_end_xfer,
      d1_test_0_test_end_xfer => d1_test_0_test_end_xfer,
      d1_timer_0_s1_end_xfer => d1_timer_0_s1_end_xfer,
      d1_tri_state_bridge_avalon_slave_end_xfer => d1_tri_state_bridge_avalon_slave_end_xfer,
      dev_uart_s1_irq_from_sa => dev_uart_s1_irq_from_sa,
      dev_uart_s1_readdata_from_sa => dev_uart_s1_readdata_from_sa,
      epc_s1_wait_counter_eq_0 => epc_s1_wait_counter_eq_0,
      epc_s1_wait_counter_eq_1 => epc_s1_wait_counter_eq_1,
      incoming_tri_state_bridge_data => incoming_tri_state_bridge_data,
      incoming_tri_state_bridge_data_with_Xs_converted_to_0 => incoming_tri_state_bridge_data_with_Xs_converted_to_0,
      onchip_RAM_s1_readdata_from_sa => onchip_RAM_s1_readdata_from_sa,
      onchip_ROM_s1_readdata_from_sa => onchip_ROM_s1_readdata_from_sa,
      readdata_from_the_test_0_from_sa => readdata_from_the_test_0_from_sa,
      registered_cpu_data_master_read_data_valid_SRAM_s1 => registered_cpu_data_master_read_data_valid_SRAM_s1,
      registered_cpu_data_master_read_data_valid_epc_s1 => registered_cpu_data_master_read_data_valid_epc_s1,
      registered_cpu_data_master_read_data_valid_onchip_RAM_s1 => registered_cpu_data_master_read_data_valid_onchip_RAM_s1,
      registered_cpu_data_master_read_data_valid_onchip_ROM_s1 => registered_cpu_data_master_read_data_valid_onchip_ROM_s1,
      reset_n => clk_reset_n,
      sysid_control_slave_readdata_from_sa => sysid_control_slave_readdata_from_sa,
      timer_0_s1_irq_from_sa => timer_0_s1_irq_from_sa,
      timer_0_s1_readdata_from_sa => timer_0_s1_readdata_from_sa,
      wreq_from_the_test_0_from_sa => wreq_from_the_test_0_from_sa
    );


  --the_cpu_instruction_master, which is an e_instance
  the_cpu_instruction_master : cpu_instruction_master_arbitrator
    port map(
      cpu_instruction_master_address_to_slave => cpu_instruction_master_address_to_slave,
      cpu_instruction_master_dbs_address => cpu_instruction_master_dbs_address,
      cpu_instruction_master_readdata => cpu_instruction_master_readdata,
      cpu_instruction_master_waitrequest => cpu_instruction_master_waitrequest,
      SRAM_s1_wait_counter_eq_0 => SRAM_s1_wait_counter_eq_0,
      SRAM_s1_wait_counter_eq_1 => SRAM_s1_wait_counter_eq_1,
      clk => clk,
      cpu_instruction_master_address => cpu_instruction_master_address,
      cpu_instruction_master_granted_SRAM_s1 => cpu_instruction_master_granted_SRAM_s1,
      cpu_instruction_master_granted_cpu_jtag_debug_module => cpu_instruction_master_granted_cpu_jtag_debug_module,
      cpu_instruction_master_granted_epc_s1 => cpu_instruction_master_granted_epc_s1,
      cpu_instruction_master_granted_onchip_ROM_s1 => cpu_instruction_master_granted_onchip_ROM_s1,
      cpu_instruction_master_qualified_request_SRAM_s1 => cpu_instruction_master_qualified_request_SRAM_s1,
      cpu_instruction_master_qualified_request_cpu_jtag_debug_module => cpu_instruction_master_qualified_request_cpu_jtag_debug_module,
      cpu_instruction_master_qualified_request_epc_s1 => cpu_instruction_master_qualified_request_epc_s1,
      cpu_instruction_master_qualified_request_onchip_ROM_s1 => cpu_instruction_master_qualified_request_onchip_ROM_s1,
      cpu_instruction_master_read => cpu_instruction_master_read,
      cpu_instruction_master_read_data_valid_SRAM_s1 => cpu_instruction_master_read_data_valid_SRAM_s1,
      cpu_instruction_master_read_data_valid_cpu_jtag_debug_module => cpu_instruction_master_read_data_valid_cpu_jtag_debug_module,
      cpu_instruction_master_read_data_valid_epc_s1 => cpu_instruction_master_read_data_valid_epc_s1,
      cpu_instruction_master_read_data_valid_onchip_ROM_s1 => cpu_instruction_master_read_data_valid_onchip_ROM_s1,
      cpu_instruction_master_requests_SRAM_s1 => cpu_instruction_master_requests_SRAM_s1,
      cpu_instruction_master_requests_cpu_jtag_debug_module => cpu_instruction_master_requests_cpu_jtag_debug_module,
      cpu_instruction_master_requests_epc_s1 => cpu_instruction_master_requests_epc_s1,
      cpu_instruction_master_requests_onchip_ROM_s1 => cpu_instruction_master_requests_onchip_ROM_s1,
      cpu_jtag_debug_module_readdata_from_sa => cpu_jtag_debug_module_readdata_from_sa,
      d1_cpu_jtag_debug_module_end_xfer => d1_cpu_jtag_debug_module_end_xfer,
      d1_onchip_ROM_s1_end_xfer => d1_onchip_ROM_s1_end_xfer,
      d1_tri_state_bridge_avalon_slave_end_xfer => d1_tri_state_bridge_avalon_slave_end_xfer,
      epc_s1_wait_counter_eq_0 => epc_s1_wait_counter_eq_0,
      epc_s1_wait_counter_eq_1 => epc_s1_wait_counter_eq_1,
      incoming_tri_state_bridge_data => incoming_tri_state_bridge_data,
      onchip_ROM_s1_readdata_from_sa => onchip_ROM_s1_readdata_from_sa,
      reset_n => clk_reset_n
    );


  --the_cpu, which is an e_ptf_instance
  the_cpu : cpu
    port map(
      d_address => cpu_data_master_address,
      d_byteenable => cpu_data_master_byteenable,
      d_read => cpu_data_master_read,
      d_write => cpu_data_master_write,
      d_writedata => cpu_data_master_writedata,
      i_address => cpu_instruction_master_address,
      i_read => cpu_instruction_master_read,
      jtag_debug_module_debugaccess_to_roms => cpu_data_master_debugaccess,
      jtag_debug_module_readdata => cpu_jtag_debug_module_readdata,
      jtag_debug_module_resetrequest => cpu_jtag_debug_module_resetrequest,
      clk => clk,
      d_irq => cpu_data_master_irq,
      d_readdata => cpu_data_master_readdata,
      d_waitrequest => cpu_data_master_waitrequest,
      i_readdata => cpu_instruction_master_readdata,
      i_waitrequest => cpu_instruction_master_waitrequest,
      jtag_debug_module_address => cpu_jtag_debug_module_address,
      jtag_debug_module_begintransfer => cpu_jtag_debug_module_begintransfer,
      jtag_debug_module_byteenable => cpu_jtag_debug_module_byteenable,
      jtag_debug_module_clk => clk,
      jtag_debug_module_debugaccess => cpu_jtag_debug_module_debugaccess,
      jtag_debug_module_reset => cpu_jtag_debug_module_reset,
      jtag_debug_module_select => cpu_jtag_debug_module_chipselect,
      jtag_debug_module_write => cpu_jtag_debug_module_write,
      jtag_debug_module_writedata => cpu_jtag_debug_module_writedata,
      reset_n => cpu_jtag_debug_module_reset_n
    );


  --the_dev_uart_s1, which is an e_instance
  the_dev_uart_s1 : dev_uart_s1_arbitrator
    port map(
      cpu_data_master_granted_dev_uart_s1 => cpu_data_master_granted_dev_uart_s1,
      cpu_data_master_qualified_request_dev_uart_s1 => cpu_data_master_qualified_request_dev_uart_s1,
      cpu_data_master_read_data_valid_dev_uart_s1 => cpu_data_master_read_data_valid_dev_uart_s1,
      cpu_data_master_requests_dev_uart_s1 => cpu_data_master_requests_dev_uart_s1,
      d1_dev_uart_s1_end_xfer => d1_dev_uart_s1_end_xfer,
      dev_uart_s1_address => dev_uart_s1_address,
      dev_uart_s1_begintransfer => dev_uart_s1_begintransfer,
      dev_uart_s1_chipselect => dev_uart_s1_chipselect,
      dev_uart_s1_dataavailable_from_sa => dev_uart_s1_dataavailable_from_sa,
      dev_uart_s1_irq_from_sa => dev_uart_s1_irq_from_sa,
      dev_uart_s1_read_n => dev_uart_s1_read_n,
      dev_uart_s1_readdata_from_sa => dev_uart_s1_readdata_from_sa,
      dev_uart_s1_readyfordata_from_sa => dev_uart_s1_readyfordata_from_sa,
      dev_uart_s1_reset_n => dev_uart_s1_reset_n,
      dev_uart_s1_write_n => dev_uart_s1_write_n,
      dev_uart_s1_writedata => dev_uart_s1_writedata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      dev_uart_s1_dataavailable => dev_uart_s1_dataavailable,
      dev_uart_s1_irq => dev_uart_s1_irq,
      dev_uart_s1_readdata => dev_uart_s1_readdata,
      dev_uart_s1_readyfordata => dev_uart_s1_readyfordata,
      reset_n => clk_reset_n
    );


  --the_dev_uart, which is an e_ptf_instance
  the_dev_uart : dev_uart
    port map(
      dataavailable => dev_uart_s1_dataavailable,
      irq => dev_uart_s1_irq,
      readdata => dev_uart_s1_readdata,
      readyfordata => dev_uart_s1_readyfordata,
      txd => internal_txd_from_the_dev_uart,
      address => dev_uart_s1_address,
      begintransfer => dev_uart_s1_begintransfer,
      chipselect => dev_uart_s1_chipselect,
      clk => clk,
      read_n => dev_uart_s1_read_n,
      reset_n => dev_uart_s1_reset_n,
      rxd => rxd_to_the_dev_uart,
      write_n => dev_uart_s1_write_n,
      writedata => dev_uart_s1_writedata
    );


  --the_onchip_RAM_s1, which is an e_instance
  the_onchip_RAM_s1 : onchip_RAM_s1_arbitrator
    port map(
      cpu_data_master_granted_onchip_RAM_s1 => cpu_data_master_granted_onchip_RAM_s1,
      cpu_data_master_qualified_request_onchip_RAM_s1 => cpu_data_master_qualified_request_onchip_RAM_s1,
      cpu_data_master_read_data_valid_onchip_RAM_s1 => cpu_data_master_read_data_valid_onchip_RAM_s1,
      cpu_data_master_requests_onchip_RAM_s1 => cpu_data_master_requests_onchip_RAM_s1,
      d1_onchip_RAM_s1_end_xfer => d1_onchip_RAM_s1_end_xfer,
      onchip_RAM_s1_address => onchip_RAM_s1_address,
      onchip_RAM_s1_byteenable => onchip_RAM_s1_byteenable,
      onchip_RAM_s1_chipselect => onchip_RAM_s1_chipselect,
      onchip_RAM_s1_clken => onchip_RAM_s1_clken,
      onchip_RAM_s1_readdata_from_sa => onchip_RAM_s1_readdata_from_sa,
      onchip_RAM_s1_write => onchip_RAM_s1_write,
      onchip_RAM_s1_writedata => onchip_RAM_s1_writedata,
      registered_cpu_data_master_read_data_valid_onchip_RAM_s1 => registered_cpu_data_master_read_data_valid_onchip_RAM_s1,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_byteenable => cpu_data_master_byteenable,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_waitrequest => cpu_data_master_waitrequest,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      onchip_RAM_s1_readdata => onchip_RAM_s1_readdata,
      reset_n => clk_reset_n
    );


  --the_onchip_RAM, which is an e_ptf_instance
  the_onchip_RAM : onchip_RAM
    port map(
      readdata => onchip_RAM_s1_readdata,
      address => onchip_RAM_s1_address,
      byteenable => onchip_RAM_s1_byteenable,
      chipselect => onchip_RAM_s1_chipselect,
      clk => clk,
      clken => onchip_RAM_s1_clken,
      write => onchip_RAM_s1_write,
      writedata => onchip_RAM_s1_writedata
    );


  --the_onchip_ROM_s1, which is an e_instance
  the_onchip_ROM_s1 : onchip_ROM_s1_arbitrator
    port map(
      cpu_data_master_granted_onchip_ROM_s1 => cpu_data_master_granted_onchip_ROM_s1,
      cpu_data_master_qualified_request_onchip_ROM_s1 => cpu_data_master_qualified_request_onchip_ROM_s1,
      cpu_data_master_read_data_valid_onchip_ROM_s1 => cpu_data_master_read_data_valid_onchip_ROM_s1,
      cpu_data_master_requests_onchip_ROM_s1 => cpu_data_master_requests_onchip_ROM_s1,
      cpu_instruction_master_granted_onchip_ROM_s1 => cpu_instruction_master_granted_onchip_ROM_s1,
      cpu_instruction_master_qualified_request_onchip_ROM_s1 => cpu_instruction_master_qualified_request_onchip_ROM_s1,
      cpu_instruction_master_read_data_valid_onchip_ROM_s1 => cpu_instruction_master_read_data_valid_onchip_ROM_s1,
      cpu_instruction_master_requests_onchip_ROM_s1 => cpu_instruction_master_requests_onchip_ROM_s1,
      d1_onchip_ROM_s1_end_xfer => d1_onchip_ROM_s1_end_xfer,
      onchip_ROM_s1_address => onchip_ROM_s1_address,
      onchip_ROM_s1_byteenable => onchip_ROM_s1_byteenable,
      onchip_ROM_s1_chipselect => onchip_ROM_s1_chipselect,
      onchip_ROM_s1_clken => onchip_ROM_s1_clken,
      onchip_ROM_s1_debugaccess => onchip_ROM_s1_debugaccess,
      onchip_ROM_s1_readdata_from_sa => onchip_ROM_s1_readdata_from_sa,
      onchip_ROM_s1_write => onchip_ROM_s1_write,
      onchip_ROM_s1_writedata => onchip_ROM_s1_writedata,
      registered_cpu_data_master_read_data_valid_onchip_ROM_s1 => registered_cpu_data_master_read_data_valid_onchip_ROM_s1,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_byteenable => cpu_data_master_byteenable,
      cpu_data_master_debugaccess => cpu_data_master_debugaccess,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_waitrequest => cpu_data_master_waitrequest,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      cpu_instruction_master_address_to_slave => cpu_instruction_master_address_to_slave,
      cpu_instruction_master_read => cpu_instruction_master_read,
      onchip_ROM_s1_readdata => onchip_ROM_s1_readdata,
      reset_n => clk_reset_n
    );


  --the_onchip_ROM, which is an e_ptf_instance
  the_onchip_ROM : onchip_ROM
    port map(
      readdata => onchip_ROM_s1_readdata,
      address => onchip_ROM_s1_address,
      byteenable => onchip_ROM_s1_byteenable,
      chipselect => onchip_ROM_s1_chipselect,
      clk => clk,
      clken => onchip_ROM_s1_clken,
      debugaccess => onchip_ROM_s1_debugaccess,
      write => onchip_ROM_s1_write,
      writedata => onchip_ROM_s1_writedata
    );


  --the_sysid_control_slave, which is an e_instance
  the_sysid_control_slave : sysid_control_slave_arbitrator
    port map(
      cpu_data_master_granted_sysid_control_slave => cpu_data_master_granted_sysid_control_slave,
      cpu_data_master_qualified_request_sysid_control_slave => cpu_data_master_qualified_request_sysid_control_slave,
      cpu_data_master_read_data_valid_sysid_control_slave => cpu_data_master_read_data_valid_sysid_control_slave,
      cpu_data_master_requests_sysid_control_slave => cpu_data_master_requests_sysid_control_slave,
      d1_sysid_control_slave_end_xfer => d1_sysid_control_slave_end_xfer,
      sysid_control_slave_address => sysid_control_slave_address,
      sysid_control_slave_readdata_from_sa => sysid_control_slave_readdata_from_sa,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_write => cpu_data_master_write,
      reset_n => clk_reset_n,
      sysid_control_slave_readdata => sysid_control_slave_readdata
    );


  --the_sysid, which is an e_ptf_instance
  the_sysid : sysid
    port map(
      readdata => sysid_control_slave_readdata,
      address => sysid_control_slave_address
    );


  --the_test_0_test, which is an e_instance
  the_test_0_test : test_0_test_arbitrator
    port map(
      addr_to_the_test_0 => internal_addr_to_the_test_0,
      cpu_data_master_granted_test_0_test => cpu_data_master_granted_test_0_test,
      cpu_data_master_qualified_request_test_0_test => cpu_data_master_qualified_request_test_0_test,
      cpu_data_master_read_data_valid_test_0_test => cpu_data_master_read_data_valid_test_0_test,
      cpu_data_master_requests_test_0_test => cpu_data_master_requests_test_0_test,
      cs_to_the_test_0 => internal_cs_to_the_test_0,
      d1_test_0_test_end_xfer => d1_test_0_test_end_xfer,
      readdata_from_the_test_0_from_sa => readdata_from_the_test_0_from_sa,
      wreq_from_the_test_0_from_sa => wreq_from_the_test_0_from_sa,
      write_n_to_the_test_0 => internal_write_n_to_the_test_0,
      writedata_to_the_test_0 => internal_writedata_to_the_test_0,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_waitrequest => cpu_data_master_waitrequest,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      readdata_from_the_test_0 => readdata_from_the_test_0,
      reset_n => clk_reset_n,
      wreq_from_the_test_0 => wreq_from_the_test_0
    );


  --the_timer_0_s1, which is an e_instance
  the_timer_0_s1 : timer_0_s1_arbitrator
    port map(
      cpu_data_master_granted_timer_0_s1 => cpu_data_master_granted_timer_0_s1,
      cpu_data_master_qualified_request_timer_0_s1 => cpu_data_master_qualified_request_timer_0_s1,
      cpu_data_master_read_data_valid_timer_0_s1 => cpu_data_master_read_data_valid_timer_0_s1,
      cpu_data_master_requests_timer_0_s1 => cpu_data_master_requests_timer_0_s1,
      d1_timer_0_s1_end_xfer => d1_timer_0_s1_end_xfer,
      timer_0_s1_address => timer_0_s1_address,
      timer_0_s1_chipselect => timer_0_s1_chipselect,
      timer_0_s1_irq_from_sa => timer_0_s1_irq_from_sa,
      timer_0_s1_readdata_from_sa => timer_0_s1_readdata_from_sa,
      timer_0_s1_reset_n => timer_0_s1_reset_n,
      timer_0_s1_write_n => timer_0_s1_write_n,
      timer_0_s1_writedata => timer_0_s1_writedata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_waitrequest => cpu_data_master_waitrequest,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      reset_n => clk_reset_n,
      timer_0_s1_irq => timer_0_s1_irq,
      timer_0_s1_readdata => timer_0_s1_readdata
    );


  --the_timer_0, which is an e_ptf_instance
  the_timer_0 : timer_0
    port map(
      irq => timer_0_s1_irq,
      readdata => timer_0_s1_readdata,
      address => timer_0_s1_address,
      chipselect => timer_0_s1_chipselect,
      clk => clk,
      reset_n => timer_0_s1_reset_n,
      write_n => timer_0_s1_write_n,
      writedata => timer_0_s1_writedata
    );


  --the_tri_state_bridge_avalon_slave, which is an e_instance
  the_tri_state_bridge_avalon_slave : tri_state_bridge_avalon_slave_arbitrator
    port map(
      SRAM_s1_wait_counter_eq_0 => SRAM_s1_wait_counter_eq_0,
      SRAM_s1_wait_counter_eq_1 => SRAM_s1_wait_counter_eq_1,
      be_n_to_the_SRAM => internal_be_n_to_the_SRAM,
      cpu_data_master_byteenable_epc_s1 => cpu_data_master_byteenable_epc_s1,
      cpu_data_master_granted_SRAM_s1 => cpu_data_master_granted_SRAM_s1,
      cpu_data_master_granted_epc_s1 => cpu_data_master_granted_epc_s1,
      cpu_data_master_qualified_request_SRAM_s1 => cpu_data_master_qualified_request_SRAM_s1,
      cpu_data_master_qualified_request_epc_s1 => cpu_data_master_qualified_request_epc_s1,
      cpu_data_master_read_data_valid_SRAM_s1 => cpu_data_master_read_data_valid_SRAM_s1,
      cpu_data_master_read_data_valid_epc_s1 => cpu_data_master_read_data_valid_epc_s1,
      cpu_data_master_requests_SRAM_s1 => cpu_data_master_requests_SRAM_s1,
      cpu_data_master_requests_epc_s1 => cpu_data_master_requests_epc_s1,
      cpu_instruction_master_granted_SRAM_s1 => cpu_instruction_master_granted_SRAM_s1,
      cpu_instruction_master_granted_epc_s1 => cpu_instruction_master_granted_epc_s1,
      cpu_instruction_master_qualified_request_SRAM_s1 => cpu_instruction_master_qualified_request_SRAM_s1,
      cpu_instruction_master_qualified_request_epc_s1 => cpu_instruction_master_qualified_request_epc_s1,
      cpu_instruction_master_read_data_valid_SRAM_s1 => cpu_instruction_master_read_data_valid_SRAM_s1,
      cpu_instruction_master_read_data_valid_epc_s1 => cpu_instruction_master_read_data_valid_epc_s1,
      cpu_instruction_master_requests_SRAM_s1 => cpu_instruction_master_requests_SRAM_s1,
      cpu_instruction_master_requests_epc_s1 => cpu_instruction_master_requests_epc_s1,
      d1_tri_state_bridge_avalon_slave_end_xfer => d1_tri_state_bridge_avalon_slave_end_xfer,
      epc_s1_wait_counter_eq_0 => epc_s1_wait_counter_eq_0,
      epc_s1_wait_counter_eq_1 => epc_s1_wait_counter_eq_1,
      incoming_tri_state_bridge_data => incoming_tri_state_bridge_data,
      incoming_tri_state_bridge_data_with_Xs_converted_to_0 => incoming_tri_state_bridge_data_with_Xs_converted_to_0,
      read_n_to_the_SRAM => internal_read_n_to_the_SRAM,
      registered_cpu_data_master_read_data_valid_SRAM_s1 => registered_cpu_data_master_read_data_valid_SRAM_s1,
      registered_cpu_data_master_read_data_valid_epc_s1 => registered_cpu_data_master_read_data_valid_epc_s1,
      select0_n_to_the_SRAM => internal_select0_n_to_the_SRAM,
      select1_n_to_the_SRAM => internal_select1_n_to_the_SRAM,
      select_n_to_the_epc => internal_select_n_to_the_epc,
      tri_state_bridge_address => internal_tri_state_bridge_address,
      tri_state_bridge_data => tri_state_bridge_data,
      tri_state_bridge_readn => internal_tri_state_bridge_readn,
      write_n_to_the_SRAM => internal_write_n_to_the_SRAM,
      write_n_to_the_epc => internal_write_n_to_the_epc,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_byteenable => cpu_data_master_byteenable,
      cpu_data_master_dbs_address => cpu_data_master_dbs_address,
      cpu_data_master_dbs_write_16 => cpu_data_master_dbs_write_16,
      cpu_data_master_no_byte_enables_and_last_term => cpu_data_master_no_byte_enables_and_last_term,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      cpu_instruction_master_address_to_slave => cpu_instruction_master_address_to_slave,
      cpu_instruction_master_dbs_address => cpu_instruction_master_dbs_address,
      cpu_instruction_master_read => cpu_instruction_master_read,
      reset_n => clk_reset_n
    );


  --reset is asserted asynchronously and deasserted synchronously
  nios_reset_clk_domain_synch : nios_reset_clk_domain_synch_module
    port map(
      data_out => clk_reset_n,
      clk => clk,
      data_in => module_input,
      reset_n => reset_n_sources
    );

  module_input <= std_logic'('1');

  --reset sources mux, which is an e_mux
  reset_n_sources <= Vector_To_Std_Logic(NOT (((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT reset_n))) OR std_logic_vector'("00000000000000000000000000000000")) OR (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_jtag_debug_module_resetrequest_from_sa)))) OR (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_jtag_debug_module_resetrequest_from_sa))))));
  --vhdl renameroo for output signals
  addr_to_the_test_0 <= internal_addr_to_the_test_0;
  --vhdl renameroo for output signals
  be_n_to_the_SRAM <= internal_be_n_to_the_SRAM;
  --vhdl renameroo for output signals
  cs_to_the_test_0 <= internal_cs_to_the_test_0;
  --vhdl renameroo for output signals
  read_n_to_the_SRAM <= internal_read_n_to_the_SRAM;
  --vhdl renameroo for output signals
  select0_n_to_the_SRAM <= internal_select0_n_to_the_SRAM;
  --vhdl renameroo for output signals
  select1_n_to_the_SRAM <= internal_select1_n_to_the_SRAM;
  --vhdl renameroo for output signals
  select_n_to_the_epc <= internal_select_n_to_the_epc;
  --vhdl renameroo for output signals
  tri_state_bridge_address <= internal_tri_state_bridge_address;
  --vhdl renameroo for output signals
  tri_state_bridge_readn <= internal_tri_state_bridge_readn;
  --vhdl renameroo for output signals
  txd_from_the_dev_uart <= internal_txd_from_the_dev_uart;
  --vhdl renameroo for output signals
  write_n_to_the_SRAM <= internal_write_n_to_the_SRAM;
  --vhdl renameroo for output signals
  write_n_to_the_epc <= internal_write_n_to_the_epc;
  --vhdl renameroo for output signals
  write_n_to_the_test_0 <= internal_write_n_to_the_test_0;
  --vhdl renameroo for output signals
  writedata_to_the_test_0 <= internal_writedata_to_the_test_0;

end europa;


--synthesis translate_off

library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library std;
use std.textio.all;

entity SRAM_lane0_module is 
        port (
              -- inputs:
                 signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal rdaddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                 signal rdclken : IN STD_LOGIC;
                 signal wraddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                 signal wrclock : IN STD_LOGIC;
                 signal wren : IN STD_LOGIC;

              -- outputs:
                 signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
              );
end entity SRAM_lane0_module;


architecture europa of SRAM_lane0_module is
              signal internal_q :  STD_LOGIC_VECTOR (7 DOWNTO 0);
              TYPE mem_array is ARRAY( 262143 DOWNTO 0) of STD_LOGIC_VECTOR(7 DOWNTO 0);
              signal memory_has_been_read :  STD_LOGIC;
              signal read_address :  STD_LOGIC_VECTOR (17 DOWNTO 0);

      
FUNCTION convert_string_to_number(string_to_convert : STRING;
      final_char_index : NATURAL := 0)
RETURN NATURAL IS
   VARIABLE result: NATURAL := 0;
   VARIABLE current_index : NATURAL := 1;
   VARIABLE the_char : CHARACTER;

   BEGIN
      IF final_char_index = 0 THEN
         result := 0;
	 ELSE
         WHILE current_index <= final_char_index LOOP
            the_char := string_to_convert(current_index);
            IF    '0' <= the_char AND the_char <= '9' THEN
               result := result * 16 + character'pos(the_char) - character'pos('0');
            ELSIF 'A' <= the_char AND the_char <= 'F' THEN
               result := result * 16 + character'pos(the_char) - character'pos('A') + 10;
            ELSIF 'a' <= the_char AND the_char <= 'f' THEN
               result := result * 16 + character'pos(the_char) - character'pos('a') + 10;
            ELSE
               report "Ack, a formatting error!";
            END IF;
            current_index := current_index + 1;
         END LOOP;
      END IF; 
   RETURN result;
END convert_string_to_number;

 FUNCTION convert_string_to_std_logic(value : STRING; num_chars : INTEGER; mem_width_bits : INTEGER)
 RETURN STD_LOGIC_VECTOR is			   
     VARIABLE conv_string: std_logic_vector((mem_width_bits + 4)-1 downto 0);
     VARIABLE result : std_logic_vector((mem_width_bits -1) downto 0);
     VARIABLE curr_char : integer;
              
     BEGIN
     result := (others => '0');
     conv_string := (others => '0');
     
          FOR I IN 1 TO num_chars LOOP
	     curr_char := num_chars - (I-1);

             CASE value(I) IS
               WHEN '0' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0000";
               WHEN '1' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0001";
               WHEN '2' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0010";
               WHEN '3' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0011";
               WHEN '4' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0100";
               WHEN '5' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0101";
               WHEN '6' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0110";
               WHEN '7' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0111";
               WHEN '8' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1000";
               WHEN '9' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1001";
               WHEN 'A' | 'a' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1010";
               WHEN 'B' | 'b' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1011";
               WHEN 'C' | 'c' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1100";
               WHEN 'D' | 'd' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1101";
               WHEN 'E' | 'e' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1110";
               WHEN 'F' | 'f' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1111";
               WHEN 'X' | 'x' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "XXXX";
               WHEN ' ' => EXIT;
               WHEN HT  => exit;
               WHEN others =>
                  ASSERT False
                  REPORT "function From_Hex: string """ & value & """ contains non-hex character"
                       severity Error;
                  EXIT;
               END case;
            END loop;

          -- convert back to normal bit size
          result(mem_width_bits - 1 downto 0) := conv_string(mem_width_bits - 1 downto 0);

          RETURN result;
        END convert_string_to_std_logic;



begin
   process (wrclock, rdaddress) -- MG
    VARIABLE data_line : LINE;
    VARIABLE the_character_from_data_line : CHARACTER;
    VARIABLE b_munging_address : BOOLEAN := FALSE;
    VARIABLE converted_number : NATURAL := 0;
    VARIABLE found_string_array : STRING(1 TO 128);
    VARIABLE string_index : NATURAL := 0;
    VARIABLE line_length : NATURAL := 0;
    VARIABLE b_convert : BOOLEAN := FALSE;
    VARIABLE b_found_new_val : BOOLEAN := FALSE;
    VARIABLE load_address : NATURAL := 0;
    VARIABLE mem_index : NATURAL := 0;
    VARIABLE mem_init : BOOLEAN := FALSE;
    
    VARIABLE wr_address_internal : STD_LOGIC_VECTOR (17 DOWNTO 0) := (others => '0');
    FILE memory_contents_file : TEXT OPEN read_mode IS "SRAM_lane0.dat";  
    variable Marc_Gaucherons_Memory_Variable : mem_array; -- MG
    
    begin
   -- need an initialization process
   -- this process initializes the whole memory array from a named file by copying the
   -- contents of the *.dat file to the memory array.

   -- find the @<address> thingy to load the memory from this point 
IF(NOT mem_init) THEN
   WHILE NOT(endfile(memory_contents_file)) LOOP

      readline(memory_contents_file, data_line);
      line_length := data_line'LENGTH;


      WHILE line_length > 0 LOOP
         read(data_line, the_character_from_data_line);

	       -- check for the @ character indicating a new address wad
 	       -- if not found, we're either still reading the new address _or_loading data
         IF '@' = the_character_from_data_line AND NOT b_munging_address THEN
  	    b_munging_address := TRUE;
            b_found_new_val := TRUE; 
	    -- get the rest of characters before white space and then convert them
	    -- to a number
	 ELSE 

            IF (' ' = the_character_from_data_line AND b_found_new_val) 
		OR (line_length = 1) THEN
               b_convert := TRUE;
	    END IF;

            IF NOT(' ' = the_character_from_data_line) THEN
               string_index := string_index + 1;
               found_string_array(string_index) := the_character_from_data_line;
--               IF NOT(b_munging_address) THEN
--                 dat_string_array(string_index) := the_character_from_data_line;
--               END IF;
	       b_found_new_val := TRUE;
            END IF;
	 END IF;

     IF b_convert THEN

       IF b_munging_address THEN
          converted_number := convert_string_to_number(found_string_array, string_index);    
          load_address := converted_number;
          mem_index := load_address;
--          mem_index := load_address / 1;
          b_munging_address := FALSE;
       ELSE
	  IF (mem_index < 262144) THEN
	    Marc_Gaucherons_Memory_Variable(mem_index) := convert_string_to_std_logic(found_string_array, string_index, 8);
            mem_index := mem_index + 1;
          END IF;
       END IF; 
       b_convert := FALSE;
       b_found_new_val := FALSE;
       string_index := 0;
    END IF;
    line_length := line_length - 1; 
    END LOOP;

END LOOP;
-- get the first _real_ block of data, sized to our memory width
-- and keep on loading.
  mem_init := TRUE;
END IF;
-- END OF READMEM



      -- Write data
      if wrclock'event and wrclock = '1' then
        wr_address_internal := wraddress;
        if wren = '1' then 
          Marc_Gaucherons_Memory_Variable(CONV_INTEGER(UNSIGNED(wr_address_internal))) := data;
        end if;
      end if;

      -- read data
      q <= Marc_Gaucherons_Memory_Variable(CONV_INTEGER(UNSIGNED(rdaddress)));
      


    end process;
end europa;

--synthesis translate_on


--synthesis read_comments_as_HDL on
--library altera_vhdl_support;
--use altera_vhdl_support.altera_vhdl_support_lib.all;
--
--library ieee;
--use ieee.std_logic_1164.all;
--use ieee.std_logic_arith.all;
--use ieee.std_logic_unsigned.all;
--
--library std;
--use std.textio.all;
--
--entity SRAM_lane0_module is 
--        port (
--              
--                 signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
--                 signal rdaddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
--                 signal rdclken : IN STD_LOGIC;
--                 signal wraddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
--                 signal wrclock : IN STD_LOGIC;
--                 signal wren : IN STD_LOGIC;
--
--              
--                 signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
--              );
--end entity SRAM_lane0_module;
--
--
--architecture europa of SRAM_lane0_module is
--  component lpm_ram_dp is
--GENERIC (
--      lpm_file : STRING;
--        lpm_hint : STRING;
--        lpm_indata : STRING;
--        lpm_outdata : STRING;
--        lpm_rdaddress_control : STRING;
--        lpm_width : NATURAL;
--        lpm_widthad : NATURAL;
--        lpm_wraddress_control : STRING;
--        suppress_memory_conversion_warnings : STRING
--      );
--    PORT (
--    signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
--        signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
--        signal wraddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
--        signal wrclock : IN STD_LOGIC;
--        signal rdaddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
--        signal rdclken : IN STD_LOGIC;
--        signal wren : IN STD_LOGIC
--      );
--  end component lpm_ram_dp;
--                signal internal_q :  STD_LOGIC_VECTOR (7 DOWNTO 0);
--                TYPE mem_array is ARRAY( 262143 DOWNTO 0) of STD_LOGIC_VECTOR(7 DOWNTO 0);
--                signal memory_has_been_read :  STD_LOGIC;
--                signal read_address :  STD_LOGIC_VECTOR (17 DOWNTO 0);
--
--begin
--
--  process (rdaddress)
--  begin
--      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
--        read_address <= rdaddress;
--      end if;
--
--  end process;
--
--  lpm_ram_dp_component : lpm_ram_dp
--    generic map(
--      lpm_file => "SRAM_lane0.mif",
--      lpm_hint => "USE_EAB=ON",
--      lpm_indata => "REGISTERED",
--      lpm_outdata => "UNREGISTERED",
--      lpm_rdaddress_control => "UNREGISTERED",
--      lpm_width => 8,
--      lpm_widthad => 18,
--      lpm_wraddress_control => "REGISTERED",
--      suppress_memory_conversion_warnings => "ON"
--    )
--    port map(
--            data => data,
--            q => internal_q,
--            rdaddress => read_address,
--            rdclken => rdclken,
--            wraddress => wraddress,
--            wrclock => wrclock,
--            wren => wren
--    );
--
--  
--  q <= internal_q;
--end europa;
--
--synthesis read_comments_as_HDL off

--synthesis translate_off

library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library std;
use std.textio.all;

entity SRAM_lane1_module is 
        port (
              -- inputs:
                 signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal rdaddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                 signal rdclken : IN STD_LOGIC;
                 signal wraddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                 signal wrclock : IN STD_LOGIC;
                 signal wren : IN STD_LOGIC;

              -- outputs:
                 signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
              );
end entity SRAM_lane1_module;


architecture europa of SRAM_lane1_module is
              signal internal_q1 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
              TYPE mem_array is ARRAY( 262143 DOWNTO 0) of STD_LOGIC_VECTOR(7 DOWNTO 0);
              signal memory_has_been_read :  STD_LOGIC;
              signal read_address :  STD_LOGIC_VECTOR (17 DOWNTO 0);

      
FUNCTION convert_string_to_number(string_to_convert : STRING;
      final_char_index : NATURAL := 0)
RETURN NATURAL IS
   VARIABLE result: NATURAL := 0;
   VARIABLE current_index : NATURAL := 1;
   VARIABLE the_char : CHARACTER;

   BEGIN
      IF final_char_index = 0 THEN
         result := 0;
	 ELSE
         WHILE current_index <= final_char_index LOOP
            the_char := string_to_convert(current_index);
            IF    '0' <= the_char AND the_char <= '9' THEN
               result := result * 16 + character'pos(the_char) - character'pos('0');
            ELSIF 'A' <= the_char AND the_char <= 'F' THEN
               result := result * 16 + character'pos(the_char) - character'pos('A') + 10;
            ELSIF 'a' <= the_char AND the_char <= 'f' THEN
               result := result * 16 + character'pos(the_char) - character'pos('a') + 10;
            ELSE
               report "Ack, a formatting error!";
            END IF;
            current_index := current_index + 1;
         END LOOP;
      END IF; 
   RETURN result;
END convert_string_to_number;

 FUNCTION convert_string_to_std_logic(value : STRING; num_chars : INTEGER; mem_width_bits : INTEGER)
 RETURN STD_LOGIC_VECTOR is			   
     VARIABLE conv_string: std_logic_vector((mem_width_bits + 4)-1 downto 0);
     VARIABLE result : std_logic_vector((mem_width_bits -1) downto 0);
     VARIABLE curr_char : integer;
              
     BEGIN
     result := (others => '0');
     conv_string := (others => '0');
     
          FOR I IN 1 TO num_chars LOOP
	     curr_char := num_chars - (I-1);

             CASE value(I) IS
               WHEN '0' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0000";
               WHEN '1' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0001";
               WHEN '2' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0010";
               WHEN '3' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0011";
               WHEN '4' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0100";
               WHEN '5' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0101";
               WHEN '6' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0110";
               WHEN '7' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0111";
               WHEN '8' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1000";
               WHEN '9' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1001";
               WHEN 'A' | 'a' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1010";
               WHEN 'B' | 'b' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1011";
               WHEN 'C' | 'c' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1100";
               WHEN 'D' | 'd' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1101";
               WHEN 'E' | 'e' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1110";
               WHEN 'F' | 'f' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1111";
               WHEN 'X' | 'x' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "XXXX";
               WHEN ' ' => EXIT;
               WHEN HT  => exit;
               WHEN others =>
                  ASSERT False
                  REPORT "function From_Hex: string """ & value & """ contains non-hex character"
                       severity Error;
                  EXIT;
               END case;
            END loop;

          -- convert back to normal bit size
          result(mem_width_bits - 1 downto 0) := conv_string(mem_width_bits - 1 downto 0);

          RETURN result;
        END convert_string_to_std_logic;



begin
   process (wrclock, rdaddress) -- MG
    VARIABLE data_line : LINE;
    VARIABLE the_character_from_data_line : CHARACTER;
    VARIABLE b_munging_address : BOOLEAN := FALSE;
    VARIABLE converted_number : NATURAL := 0;
    VARIABLE found_string_array : STRING(1 TO 128);
    VARIABLE string_index : NATURAL := 0;
    VARIABLE line_length : NATURAL := 0;
    VARIABLE b_convert : BOOLEAN := FALSE;
    VARIABLE b_found_new_val : BOOLEAN := FALSE;
    VARIABLE load_address : NATURAL := 0;
    VARIABLE mem_index : NATURAL := 0;
    VARIABLE mem_init : BOOLEAN := FALSE;
    
    VARIABLE wr_address_internal : STD_LOGIC_VECTOR (17 DOWNTO 0) := (others => '0');
    FILE memory_contents_file : TEXT OPEN read_mode IS "SRAM_lane1.dat";  
    variable Marc_Gaucherons_Memory_Variable : mem_array; -- MG
    
    begin
   -- need an initialization process
   -- this process initializes the whole memory array from a named file by copying the
   -- contents of the *.dat file to the memory array.

   -- find the @<address> thingy to load the memory from this point 
IF(NOT mem_init) THEN
   WHILE NOT(endfile(memory_contents_file)) LOOP

      readline(memory_contents_file, data_line);
      line_length := data_line'LENGTH;


      WHILE line_length > 0 LOOP
         read(data_line, the_character_from_data_line);

	       -- check for the @ character indicating a new address wad
 	       -- if not found, we're either still reading the new address _or_loading data
         IF '@' = the_character_from_data_line AND NOT b_munging_address THEN
  	    b_munging_address := TRUE;
            b_found_new_val := TRUE; 
	    -- get the rest of characters before white space and then convert them
	    -- to a number
	 ELSE 

            IF (' ' = the_character_from_data_line AND b_found_new_val) 
		OR (line_length = 1) THEN
               b_convert := TRUE;
	    END IF;

            IF NOT(' ' = the_character_from_data_line) THEN
               string_index := string_index + 1;
               found_string_array(string_index) := the_character_from_data_line;
--               IF NOT(b_munging_address) THEN
--                 dat_string_array(string_index) := the_character_from_data_line;
--               END IF;
	       b_found_new_val := TRUE;
            END IF;
	 END IF;

     IF b_convert THEN

       IF b_munging_address THEN
          converted_number := convert_string_to_number(found_string_array, string_index);    
          load_address := converted_number;
          mem_index := load_address;
--          mem_index := load_address / 1;
          b_munging_address := FALSE;
       ELSE
	  IF (mem_index < 262144) THEN
	    Marc_Gaucherons_Memory_Variable(mem_index) := convert_string_to_std_logic(found_string_array, string_index, 8);
            mem_index := mem_index + 1;
          END IF;
       END IF; 
       b_convert := FALSE;
       b_found_new_val := FALSE;
       string_index := 0;
    END IF;
    line_length := line_length - 1; 
    END LOOP;

END LOOP;
-- get the first _real_ block of data, sized to our memory width
-- and keep on loading.
  mem_init := TRUE;
END IF;
-- END OF READMEM



      -- Write data
      if wrclock'event and wrclock = '1' then
        wr_address_internal := wraddress;
        if wren = '1' then 
          Marc_Gaucherons_Memory_Variable(CONV_INTEGER(UNSIGNED(wr_address_internal))) := data;
        end if;
      end if;

      -- read data
      q <= Marc_Gaucherons_Memory_Variable(CONV_INTEGER(UNSIGNED(rdaddress)));
      


    end process;
end europa;

--synthesis translate_on


--synthesis read_comments_as_HDL on
--library altera_vhdl_support;
--use altera_vhdl_support.altera_vhdl_support_lib.all;
--
--library ieee;
--use ieee.std_logic_1164.all;
--use ieee.std_logic_arith.all;
--use ieee.std_logic_unsigned.all;
--
--library std;
--use std.textio.all;
--
--entity SRAM_lane1_module is 
--        port (
--              
--                 signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
--                 signal rdaddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
--                 signal rdclken : IN STD_LOGIC;
--                 signal wraddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
--                 signal wrclock : IN STD_LOGIC;
--                 signal wren : IN STD_LOGIC;
--
--              
--                 signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
--              );
--end entity SRAM_lane1_module;
--
--
--architecture europa of SRAM_lane1_module is
--  component lpm_ram_dp is
--GENERIC (
--      lpm_file : STRING;
--        lpm_hint : STRING;
--        lpm_indata : STRING;
--        lpm_outdata : STRING;
--        lpm_rdaddress_control : STRING;
--        lpm_width : NATURAL;
--        lpm_widthad : NATURAL;
--        lpm_wraddress_control : STRING;
--        suppress_memory_conversion_warnings : STRING
--      );
--    PORT (
--    signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
--        signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
--        signal wraddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
--        signal wrclock : IN STD_LOGIC;
--        signal rdaddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
--        signal rdclken : IN STD_LOGIC;
--        signal wren : IN STD_LOGIC
--      );
--  end component lpm_ram_dp;
--                signal internal_q1 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
--                TYPE mem_array is ARRAY( 262143 DOWNTO 0) of STD_LOGIC_VECTOR(7 DOWNTO 0);
--                signal memory_has_been_read :  STD_LOGIC;
--                signal read_address :  STD_LOGIC_VECTOR (17 DOWNTO 0);
--
--begin
--
--  process (rdaddress)
--  begin
--      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
--        read_address <= rdaddress;
--      end if;
--
--  end process;
--
--  lpm_ram_dp_component : lpm_ram_dp
--    generic map(
--      lpm_file => "SRAM_lane1.mif",
--      lpm_hint => "USE_EAB=ON",
--      lpm_indata => "REGISTERED",
--      lpm_outdata => "UNREGISTERED",
--      lpm_rdaddress_control => "UNREGISTERED",
--      lpm_width => 8,
--      lpm_widthad => 18,
--      lpm_wraddress_control => "REGISTERED",
--      suppress_memory_conversion_warnings => "ON"
--    )
--    port map(
--            data => data,
--            q => internal_q1,
--            rdaddress => read_address,
--            rdclken => rdclken,
--            wraddress => wraddress,
--            wrclock => wrclock,
--            wren => wren
--    );
--
--  
--  q <= internal_q1;
--end europa;
--
--synthesis read_comments_as_HDL off

--synthesis translate_off

library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library std;
use std.textio.all;

entity SRAM_lane2_module is 
        port (
              -- inputs:
                 signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal rdaddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                 signal rdclken : IN STD_LOGIC;
                 signal wraddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                 signal wrclock : IN STD_LOGIC;
                 signal wren : IN STD_LOGIC;

              -- outputs:
                 signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
              );
end entity SRAM_lane2_module;


architecture europa of SRAM_lane2_module is
              signal internal_q2 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
              TYPE mem_array is ARRAY( 262143 DOWNTO 0) of STD_LOGIC_VECTOR(7 DOWNTO 0);
              signal memory_has_been_read :  STD_LOGIC;
              signal read_address :  STD_LOGIC_VECTOR (17 DOWNTO 0);

      
FUNCTION convert_string_to_number(string_to_convert : STRING;
      final_char_index : NATURAL := 0)
RETURN NATURAL IS
   VARIABLE result: NATURAL := 0;
   VARIABLE current_index : NATURAL := 1;
   VARIABLE the_char : CHARACTER;

   BEGIN
      IF final_char_index = 0 THEN
         result := 0;
	 ELSE
         WHILE current_index <= final_char_index LOOP
            the_char := string_to_convert(current_index);
            IF    '0' <= the_char AND the_char <= '9' THEN
               result := result * 16 + character'pos(the_char) - character'pos('0');
            ELSIF 'A' <= the_char AND the_char <= 'F' THEN
               result := result * 16 + character'pos(the_char) - character'pos('A') + 10;
            ELSIF 'a' <= the_char AND the_char <= 'f' THEN
               result := result * 16 + character'pos(the_char) - character'pos('a') + 10;
            ELSE
               report "Ack, a formatting error!";
            END IF;
            current_index := current_index + 1;
         END LOOP;
      END IF; 
   RETURN result;
END convert_string_to_number;

 FUNCTION convert_string_to_std_logic(value : STRING; num_chars : INTEGER; mem_width_bits : INTEGER)
 RETURN STD_LOGIC_VECTOR is			   
     VARIABLE conv_string: std_logic_vector((mem_width_bits + 4)-1 downto 0);
     VARIABLE result : std_logic_vector((mem_width_bits -1) downto 0);
     VARIABLE curr_char : integer;
              
     BEGIN
     result := (others => '0');
     conv_string := (others => '0');
     
          FOR I IN 1 TO num_chars LOOP
	     curr_char := num_chars - (I-1);

             CASE value(I) IS
               WHEN '0' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0000";
               WHEN '1' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0001";
               WHEN '2' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0010";
               WHEN '3' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0011";
               WHEN '4' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0100";
               WHEN '5' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0101";
               WHEN '6' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0110";
               WHEN '7' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0111";
               WHEN '8' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1000";
               WHEN '9' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1001";
               WHEN 'A' | 'a' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1010";
               WHEN 'B' | 'b' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1011";
               WHEN 'C' | 'c' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1100";
               WHEN 'D' | 'd' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1101";
               WHEN 'E' | 'e' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1110";
               WHEN 'F' | 'f' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1111";
               WHEN 'X' | 'x' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "XXXX";
               WHEN ' ' => EXIT;
               WHEN HT  => exit;
               WHEN others =>
                  ASSERT False
                  REPORT "function From_Hex: string """ & value & """ contains non-hex character"
                       severity Error;
                  EXIT;
               END case;
            END loop;

          -- convert back to normal bit size
          result(mem_width_bits - 1 downto 0) := conv_string(mem_width_bits - 1 downto 0);

          RETURN result;
        END convert_string_to_std_logic;



begin
   process (wrclock, rdaddress) -- MG
    VARIABLE data_line : LINE;
    VARIABLE the_character_from_data_line : CHARACTER;
    VARIABLE b_munging_address : BOOLEAN := FALSE;
    VARIABLE converted_number : NATURAL := 0;
    VARIABLE found_string_array : STRING(1 TO 128);
    VARIABLE string_index : NATURAL := 0;
    VARIABLE line_length : NATURAL := 0;
    VARIABLE b_convert : BOOLEAN := FALSE;
    VARIABLE b_found_new_val : BOOLEAN := FALSE;
    VARIABLE load_address : NATURAL := 0;
    VARIABLE mem_index : NATURAL := 0;
    VARIABLE mem_init : BOOLEAN := FALSE;
    
    VARIABLE wr_address_internal : STD_LOGIC_VECTOR (17 DOWNTO 0) := (others => '0');
    FILE memory_contents_file : TEXT OPEN read_mode IS "SRAM_lane2.dat";  
    variable Marc_Gaucherons_Memory_Variable : mem_array; -- MG
    
    begin
   -- need an initialization process
   -- this process initializes the whole memory array from a named file by copying the
   -- contents of the *.dat file to the memory array.

   -- find the @<address> thingy to load the memory from this point 
IF(NOT mem_init) THEN
   WHILE NOT(endfile(memory_contents_file)) LOOP

      readline(memory_contents_file, data_line);
      line_length := data_line'LENGTH;


      WHILE line_length > 0 LOOP
         read(data_line, the_character_from_data_line);

	       -- check for the @ character indicating a new address wad
 	       -- if not found, we're either still reading the new address _or_loading data
         IF '@' = the_character_from_data_line AND NOT b_munging_address THEN
  	    b_munging_address := TRUE;
            b_found_new_val := TRUE; 
	    -- get the rest of characters before white space and then convert them
	    -- to a number
	 ELSE 

            IF (' ' = the_character_from_data_line AND b_found_new_val) 
		OR (line_length = 1) THEN
               b_convert := TRUE;
	    END IF;

            IF NOT(' ' = the_character_from_data_line) THEN
               string_index := string_index + 1;
               found_string_array(string_index) := the_character_from_data_line;
--               IF NOT(b_munging_address) THEN
--                 dat_string_array(string_index) := the_character_from_data_line;
--               END IF;
	       b_found_new_val := TRUE;
            END IF;
	 END IF;

     IF b_convert THEN

       IF b_munging_address THEN
          converted_number := convert_string_to_number(found_string_array, string_index);    
          load_address := converted_number;
          mem_index := load_address;
--          mem_index := load_address / 1;
          b_munging_address := FALSE;
       ELSE
	  IF (mem_index < 262144) THEN
	    Marc_Gaucherons_Memory_Variable(mem_index) := convert_string_to_std_logic(found_string_array, string_index, 8);
            mem_index := mem_index + 1;
          END IF;
       END IF; 
       b_convert := FALSE;
       b_found_new_val := FALSE;
       string_index := 0;
    END IF;
    line_length := line_length - 1; 
    END LOOP;

END LOOP;
-- get the first _real_ block of data, sized to our memory width
-- and keep on loading.
  mem_init := TRUE;
END IF;
-- END OF READMEM



      -- Write data
      if wrclock'event and wrclock = '1' then
        wr_address_internal := wraddress;
        if wren = '1' then 
          Marc_Gaucherons_Memory_Variable(CONV_INTEGER(UNSIGNED(wr_address_internal))) := data;
        end if;
      end if;

      -- read data
      q <= Marc_Gaucherons_Memory_Variable(CONV_INTEGER(UNSIGNED(rdaddress)));
      


    end process;
end europa;

--synthesis translate_on


--synthesis read_comments_as_HDL on
--library altera_vhdl_support;
--use altera_vhdl_support.altera_vhdl_support_lib.all;
--
--library ieee;
--use ieee.std_logic_1164.all;
--use ieee.std_logic_arith.all;
--use ieee.std_logic_unsigned.all;
--
--library std;
--use std.textio.all;
--
--entity SRAM_lane2_module is 
--        port (
--              
--                 signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
--                 signal rdaddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
--                 signal rdclken : IN STD_LOGIC;
--                 signal wraddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
--                 signal wrclock : IN STD_LOGIC;
--                 signal wren : IN STD_LOGIC;
--
--              
--                 signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
--              );
--end entity SRAM_lane2_module;
--
--
--architecture europa of SRAM_lane2_module is
--  component lpm_ram_dp is
--GENERIC (
--      lpm_file : STRING;
--        lpm_hint : STRING;
--        lpm_indata : STRING;
--        lpm_outdata : STRING;
--        lpm_rdaddress_control : STRING;
--        lpm_width : NATURAL;
--        lpm_widthad : NATURAL;
--        lpm_wraddress_control : STRING;
--        suppress_memory_conversion_warnings : STRING
--      );
--    PORT (
--    signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
--        signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
--        signal wraddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
--        signal wrclock : IN STD_LOGIC;
--        signal rdaddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
--        signal rdclken : IN STD_LOGIC;
--        signal wren : IN STD_LOGIC
--      );
--  end component lpm_ram_dp;
--                signal internal_q2 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
--                TYPE mem_array is ARRAY( 262143 DOWNTO 0) of STD_LOGIC_VECTOR(7 DOWNTO 0);
--                signal memory_has_been_read :  STD_LOGIC;
--                signal read_address :  STD_LOGIC_VECTOR (17 DOWNTO 0);
--
--begin
--
--  process (rdaddress)
--  begin
--      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
--        read_address <= rdaddress;
--      end if;
--
--  end process;
--
--  lpm_ram_dp_component : lpm_ram_dp
--    generic map(
--      lpm_file => "SRAM_lane2.mif",
--      lpm_hint => "USE_EAB=ON",
--      lpm_indata => "REGISTERED",
--      lpm_outdata => "UNREGISTERED",
--      lpm_rdaddress_control => "UNREGISTERED",
--      lpm_width => 8,
--      lpm_widthad => 18,
--      lpm_wraddress_control => "REGISTERED",
--      suppress_memory_conversion_warnings => "ON"
--    )
--    port map(
--            data => data,
--            q => internal_q2,
--            rdaddress => read_address,
--            rdclken => rdclken,
--            wraddress => wraddress,
--            wrclock => wrclock,
--            wren => wren
--    );
--
--  
--  q <= internal_q2;
--end europa;
--
--synthesis read_comments_as_HDL off

--synthesis translate_off

library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library std;
use std.textio.all;

entity SRAM_lane3_module is 
        port (
              -- inputs:
                 signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal rdaddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                 signal rdclken : IN STD_LOGIC;
                 signal wraddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                 signal wrclock : IN STD_LOGIC;
                 signal wren : IN STD_LOGIC;

              -- outputs:
                 signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
              );
end entity SRAM_lane3_module;


architecture europa of SRAM_lane3_module is
              signal internal_q3 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
              TYPE mem_array is ARRAY( 262143 DOWNTO 0) of STD_LOGIC_VECTOR(7 DOWNTO 0);
              signal memory_has_been_read :  STD_LOGIC;
              signal read_address :  STD_LOGIC_VECTOR (17 DOWNTO 0);

      
FUNCTION convert_string_to_number(string_to_convert : STRING;
      final_char_index : NATURAL := 0)
RETURN NATURAL IS
   VARIABLE result: NATURAL := 0;
   VARIABLE current_index : NATURAL := 1;
   VARIABLE the_char : CHARACTER;

   BEGIN
      IF final_char_index = 0 THEN
         result := 0;
	 ELSE
         WHILE current_index <= final_char_index LOOP
            the_char := string_to_convert(current_index);
            IF    '0' <= the_char AND the_char <= '9' THEN
               result := result * 16 + character'pos(the_char) - character'pos('0');
            ELSIF 'A' <= the_char AND the_char <= 'F' THEN
               result := result * 16 + character'pos(the_char) - character'pos('A') + 10;
            ELSIF 'a' <= the_char AND the_char <= 'f' THEN
               result := result * 16 + character'pos(the_char) - character'pos('a') + 10;
            ELSE
               report "Ack, a formatting error!";
            END IF;
            current_index := current_index + 1;
         END LOOP;
      END IF; 
   RETURN result;
END convert_string_to_number;

 FUNCTION convert_string_to_std_logic(value : STRING; num_chars : INTEGER; mem_width_bits : INTEGER)
 RETURN STD_LOGIC_VECTOR is			   
     VARIABLE conv_string: std_logic_vector((mem_width_bits + 4)-1 downto 0);
     VARIABLE result : std_logic_vector((mem_width_bits -1) downto 0);
     VARIABLE curr_char : integer;
              
     BEGIN
     result := (others => '0');
     conv_string := (others => '0');
     
          FOR I IN 1 TO num_chars LOOP
	     curr_char := num_chars - (I-1);

             CASE value(I) IS
               WHEN '0' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0000";
               WHEN '1' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0001";
               WHEN '2' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0010";
               WHEN '3' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0011";
               WHEN '4' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0100";
               WHEN '5' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0101";
               WHEN '6' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0110";
               WHEN '7' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0111";
               WHEN '8' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1000";
               WHEN '9' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1001";
               WHEN 'A' | 'a' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1010";
               WHEN 'B' | 'b' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1011";
               WHEN 'C' | 'c' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1100";
               WHEN 'D' | 'd' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1101";
               WHEN 'E' | 'e' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1110";
               WHEN 'F' | 'f' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1111";
               WHEN 'X' | 'x' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "XXXX";
               WHEN ' ' => EXIT;
               WHEN HT  => exit;
               WHEN others =>
                  ASSERT False
                  REPORT "function From_Hex: string """ & value & """ contains non-hex character"
                       severity Error;
                  EXIT;
               END case;
            END loop;

          -- convert back to normal bit size
          result(mem_width_bits - 1 downto 0) := conv_string(mem_width_bits - 1 downto 0);

          RETURN result;
        END convert_string_to_std_logic;



begin
   process (wrclock, rdaddress) -- MG
    VARIABLE data_line : LINE;
    VARIABLE the_character_from_data_line : CHARACTER;
    VARIABLE b_munging_address : BOOLEAN := FALSE;
    VARIABLE converted_number : NATURAL := 0;
    VARIABLE found_string_array : STRING(1 TO 128);
    VARIABLE string_index : NATURAL := 0;
    VARIABLE line_length : NATURAL := 0;
    VARIABLE b_convert : BOOLEAN := FALSE;
    VARIABLE b_found_new_val : BOOLEAN := FALSE;
    VARIABLE load_address : NATURAL := 0;
    VARIABLE mem_index : NATURAL := 0;
    VARIABLE mem_init : BOOLEAN := FALSE;
    
    VARIABLE wr_address_internal : STD_LOGIC_VECTOR (17 DOWNTO 0) := (others => '0');
    FILE memory_contents_file : TEXT OPEN read_mode IS "SRAM_lane3.dat";  
    variable Marc_Gaucherons_Memory_Variable : mem_array; -- MG
    
    begin
   -- need an initialization process
   -- this process initializes the whole memory array from a named file by copying the
   -- contents of the *.dat file to the memory array.

   -- find the @<address> thingy to load the memory from this point 
IF(NOT mem_init) THEN
   WHILE NOT(endfile(memory_contents_file)) LOOP

      readline(memory_contents_file, data_line);
      line_length := data_line'LENGTH;


      WHILE line_length > 0 LOOP
         read(data_line, the_character_from_data_line);

	       -- check for the @ character indicating a new address wad
 	       -- if not found, we're either still reading the new address _or_loading data
         IF '@' = the_character_from_data_line AND NOT b_munging_address THEN
  	    b_munging_address := TRUE;
            b_found_new_val := TRUE; 
	    -- get the rest of characters before white space and then convert them
	    -- to a number
	 ELSE 

            IF (' ' = the_character_from_data_line AND b_found_new_val) 
		OR (line_length = 1) THEN
               b_convert := TRUE;
	    END IF;

            IF NOT(' ' = the_character_from_data_line) THEN
               string_index := string_index + 1;
               found_string_array(string_index) := the_character_from_data_line;
--               IF NOT(b_munging_address) THEN
--                 dat_string_array(string_index) := the_character_from_data_line;
--               END IF;
	       b_found_new_val := TRUE;
            END IF;
	 END IF;

     IF b_convert THEN

       IF b_munging_address THEN
          converted_number := convert_string_to_number(found_string_array, string_index);    
          load_address := converted_number;
          mem_index := load_address;
--          mem_index := load_address / 1;
          b_munging_address := FALSE;
       ELSE
	  IF (mem_index < 262144) THEN
	    Marc_Gaucherons_Memory_Variable(mem_index) := convert_string_to_std_logic(found_string_array, string_index, 8);
            mem_index := mem_index + 1;
          END IF;
       END IF; 
       b_convert := FALSE;
       b_found_new_val := FALSE;
       string_index := 0;
    END IF;
    line_length := line_length - 1; 
    END LOOP;

END LOOP;
-- get the first _real_ block of data, sized to our memory width
-- and keep on loading.
  mem_init := TRUE;
END IF;
-- END OF READMEM



      -- Write data
      if wrclock'event and wrclock = '1' then
        wr_address_internal := wraddress;
        if wren = '1' then 
          Marc_Gaucherons_Memory_Variable(CONV_INTEGER(UNSIGNED(wr_address_internal))) := data;
        end if;
      end if;

      -- read data
      q <= Marc_Gaucherons_Memory_Variable(CONV_INTEGER(UNSIGNED(rdaddress)));
      


    end process;
end europa;

--synthesis translate_on


--synthesis read_comments_as_HDL on
--library altera_vhdl_support;
--use altera_vhdl_support.altera_vhdl_support_lib.all;
--
--library ieee;
--use ieee.std_logic_1164.all;
--use ieee.std_logic_arith.all;
--use ieee.std_logic_unsigned.all;
--
--library std;
--use std.textio.all;
--
--entity SRAM_lane3_module is 
--        port (
--              
--                 signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
--                 signal rdaddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
--                 signal rdclken : IN STD_LOGIC;
--                 signal wraddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
--                 signal wrclock : IN STD_LOGIC;
--                 signal wren : IN STD_LOGIC;
--
--              
--                 signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
--              );
--end entity SRAM_lane3_module;
--
--
--architecture europa of SRAM_lane3_module is
--  component lpm_ram_dp is
--GENERIC (
--      lpm_file : STRING;
--        lpm_hint : STRING;
--        lpm_indata : STRING;
--        lpm_outdata : STRING;
--        lpm_rdaddress_control : STRING;
--        lpm_width : NATURAL;
--        lpm_widthad : NATURAL;
--        lpm_wraddress_control : STRING;
--        suppress_memory_conversion_warnings : STRING
--      );
--    PORT (
--    signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
--        signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
--        signal wraddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
--        signal wrclock : IN STD_LOGIC;
--        signal rdaddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
--        signal rdclken : IN STD_LOGIC;
--        signal wren : IN STD_LOGIC
--      );
--  end component lpm_ram_dp;
--                signal internal_q3 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
--                TYPE mem_array is ARRAY( 262143 DOWNTO 0) of STD_LOGIC_VECTOR(7 DOWNTO 0);
--                signal memory_has_been_read :  STD_LOGIC;
--                signal read_address :  STD_LOGIC_VECTOR (17 DOWNTO 0);
--
--begin
--
--  process (rdaddress)
--  begin
--      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
--        read_address <= rdaddress;
--      end if;
--
--  end process;
--
--  lpm_ram_dp_component : lpm_ram_dp
--    generic map(
--      lpm_file => "SRAM_lane3.mif",
--      lpm_hint => "USE_EAB=ON",
--      lpm_indata => "REGISTERED",
--      lpm_outdata => "UNREGISTERED",
--      lpm_rdaddress_control => "UNREGISTERED",
--      lpm_width => 8,
--      lpm_widthad => 18,
--      lpm_wraddress_control => "REGISTERED",
--      suppress_memory_conversion_warnings => "ON"
--    )
--    port map(
--            data => data,
--            q => internal_q3,
--            rdaddress => read_address,
--            rdclken => rdclken,
--            wraddress => wraddress,
--            wrclock => wrclock,
--            wren => wren
--    );
--
--  
--  q <= internal_q3;
--end europa;
--
--synthesis read_comments_as_HDL off

library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity SRAM is 
        port (
              -- inputs:
                 signal address : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                 signal be_n : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal read_n : IN STD_LOGIC;
                 signal select0_n : IN STD_LOGIC;
                 signal select1_n : IN STD_LOGIC;
                 signal write_n : IN STD_LOGIC;

              -- outputs:
                 signal data : INOUT STD_LOGIC_VECTOR (31 DOWNTO 0)
              );
end entity SRAM;


architecture europa of SRAM is
--synthesis translate_off
component SRAM_lane0_module is 
           port (
                 -- inputs:
                    signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal rdaddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                    signal rdclken : IN STD_LOGIC;
                    signal wraddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                    signal wrclock : IN STD_LOGIC;
                    signal wren : IN STD_LOGIC;

                 -- outputs:
                    signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
                 );
end component SRAM_lane0_module;

component SRAM_lane1_module is 
           port (
                 -- inputs:
                    signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal rdaddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                    signal rdclken : IN STD_LOGIC;
                    signal wraddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                    signal wrclock : IN STD_LOGIC;
                    signal wren : IN STD_LOGIC;

                 -- outputs:
                    signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
                 );
end component SRAM_lane1_module;

component SRAM_lane2_module is 
           port (
                 -- inputs:
                    signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal rdaddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                    signal rdclken : IN STD_LOGIC;
                    signal wraddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                    signal wrclock : IN STD_LOGIC;
                    signal wren : IN STD_LOGIC;

                 -- outputs:
                    signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
                 );
end component SRAM_lane2_module;

component SRAM_lane3_module is 
           port (
                 -- inputs:
                    signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal rdaddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                    signal rdclken : IN STD_LOGIC;
                    signal wraddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                    signal wrclock : IN STD_LOGIC;
                    signal wren : IN STD_LOGIC;

                 -- outputs:
                    signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
                 );
end component SRAM_lane3_module;

--synthesis translate_on
                signal data_0 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal data_1 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal data_2 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal data_3 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal logic_vector_gasket :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal module_input1 :  STD_LOGIC;
                signal module_input2 :  STD_LOGIC;
                signal module_input3 :  STD_LOGIC;
                signal module_input4 :  STD_LOGIC;
                signal module_input5 :  STD_LOGIC;
                signal module_input6 :  STD_LOGIC;
                signal module_input7 :  STD_LOGIC;
                signal module_input8 :  STD_LOGIC;
                signal q_0 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal q_1 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal q_2 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal q_3 :  STD_LOGIC_VECTOR (7 DOWNTO 0);

begin

  --s1, which is an e_ptf_slave
--synthesis translate_off
    logic_vector_gasket <= data;
    data_0 <= logic_vector_gasket(7 DOWNTO 0);
    --SRAM_lane0, which is an e_ram
    SRAM_lane0 : SRAM_lane0_module
      port map(
        q => q_0,
        data => data_0,
        rdaddress => address,
        rdclken => module_input1,
        wraddress => address,
        wrclock => write_n,
        wren => module_input2
      );

    module_input1 <= std_logic'('1');
    module_input2 <= NOT select1_n AND NOT be_n(0);

    data_1 <= logic_vector_gasket(15 DOWNTO 8);
    --SRAM_lane1, which is an e_ram
    SRAM_lane1 : SRAM_lane1_module
      port map(
        q => q_1,
        data => data_1,
        rdaddress => address,
        rdclken => module_input3,
        wraddress => address,
        wrclock => write_n,
        wren => module_input4
      );

    module_input3 <= std_logic'('1');
    module_input4 <= NOT select1_n AND NOT be_n(1);

    data_2 <= logic_vector_gasket(23 DOWNTO 16);
    --SRAM_lane2, which is an e_ram
    SRAM_lane2 : SRAM_lane2_module
      port map(
        q => q_2,
        data => data_2,
        rdaddress => address,
        rdclken => module_input5,
        wraddress => address,
        wrclock => write_n,
        wren => module_input6
      );

    module_input5 <= std_logic'('1');
    module_input6 <= NOT select1_n AND NOT be_n(2);

    data_3 <= logic_vector_gasket(31 DOWNTO 24);
    --SRAM_lane3, which is an e_ram
    SRAM_lane3 : SRAM_lane3_module
      port map(
        q => q_3,
        data => data_3,
        rdaddress => address,
        rdclken => module_input7,
        wraddress => address,
        wrclock => write_n,
        wren => module_input8
      );

    module_input7 <= std_logic'('1');
    module_input8 <= NOT select1_n AND NOT be_n(3);

    data <= A_WE_StdLogicVector((std_logic'(((NOT select1_n AND NOT read_n))) = '1'), (q_3 & q_2 & q_1 & q_0), A_REP(std_logic'('Z'), 32));
--synthesis translate_on

end europa;


--synthesis translate_off

library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library std;
use std.textio.all;

entity epc_lane0_module is 
        port (
              -- inputs:
                 signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal rdaddress : IN STD_LOGIC_VECTOR (19 DOWNTO 0);
                 signal rdclken : IN STD_LOGIC;
                 signal wraddress : IN STD_LOGIC_VECTOR (19 DOWNTO 0);
                 signal wrclock : IN STD_LOGIC;
                 signal wren : IN STD_LOGIC;

              -- outputs:
                 signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
              );
end entity epc_lane0_module;


architecture europa of epc_lane0_module is
              signal internal_q4 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
              TYPE mem_array is ARRAY( 1048575 DOWNTO 0) of STD_LOGIC_VECTOR(7 DOWNTO 0);
              signal memory_has_been_read :  STD_LOGIC;
              signal read_address :  STD_LOGIC_VECTOR (19 DOWNTO 0);

      
FUNCTION convert_string_to_number(string_to_convert : STRING;
      final_char_index : NATURAL := 0)
RETURN NATURAL IS
   VARIABLE result: NATURAL := 0;
   VARIABLE current_index : NATURAL := 1;
   VARIABLE the_char : CHARACTER;

   BEGIN
      IF final_char_index = 0 THEN
         result := 0;
	 ELSE
         WHILE current_index <= final_char_index LOOP
            the_char := string_to_convert(current_index);
            IF    '0' <= the_char AND the_char <= '9' THEN
               result := result * 16 + character'pos(the_char) - character'pos('0');
            ELSIF 'A' <= the_char AND the_char <= 'F' THEN
               result := result * 16 + character'pos(the_char) - character'pos('A') + 10;
            ELSIF 'a' <= the_char AND the_char <= 'f' THEN
               result := result * 16 + character'pos(the_char) - character'pos('a') + 10;
            ELSE
               report "Ack, a formatting error!";
            END IF;
            current_index := current_index + 1;
         END LOOP;
      END IF; 
   RETURN result;
END convert_string_to_number;

 FUNCTION convert_string_to_std_logic(value : STRING; num_chars : INTEGER; mem_width_bits : INTEGER)
 RETURN STD_LOGIC_VECTOR is			   
     VARIABLE conv_string: std_logic_vector((mem_width_bits + 4)-1 downto 0);
     VARIABLE result : std_logic_vector((mem_width_bits -1) downto 0);
     VARIABLE curr_char : integer;
              
     BEGIN
     result := (others => '0');
     conv_string := (others => '0');
     
          FOR I IN 1 TO num_chars LOOP
	     curr_char := num_chars - (I-1);

             CASE value(I) IS
               WHEN '0' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0000";
               WHEN '1' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0001";
               WHEN '2' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0010";
               WHEN '3' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0011";
               WHEN '4' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0100";
               WHEN '5' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0101";
               WHEN '6' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0110";
               WHEN '7' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0111";
               WHEN '8' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1000";
               WHEN '9' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1001";
               WHEN 'A' | 'a' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1010";
               WHEN 'B' | 'b' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1011";
               WHEN 'C' | 'c' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1100";
               WHEN 'D' | 'd' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1101";
               WHEN 'E' | 'e' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1110";
               WHEN 'F' | 'f' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1111";
               WHEN 'X' | 'x' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "XXXX";
               WHEN ' ' => EXIT;
               WHEN HT  => exit;
               WHEN others =>
                  ASSERT False
                  REPORT "function From_Hex: string """ & value & """ contains non-hex character"
                       severity Error;
                  EXIT;
               END case;
            END loop;

          -- convert back to normal bit size
          result(mem_width_bits - 1 downto 0) := conv_string(mem_width_bits - 1 downto 0);

          RETURN result;
        END convert_string_to_std_logic;



begin
   process (wrclock, rdaddress) -- MG
    VARIABLE data_line : LINE;
    VARIABLE the_character_from_data_line : CHARACTER;
    VARIABLE b_munging_address : BOOLEAN := FALSE;
    VARIABLE converted_number : NATURAL := 0;
    VARIABLE found_string_array : STRING(1 TO 128);
    VARIABLE string_index : NATURAL := 0;
    VARIABLE line_length : NATURAL := 0;
    VARIABLE b_convert : BOOLEAN := FALSE;
    VARIABLE b_found_new_val : BOOLEAN := FALSE;
    VARIABLE load_address : NATURAL := 0;
    VARIABLE mem_index : NATURAL := 0;
    VARIABLE mem_init : BOOLEAN := FALSE;
    
    VARIABLE wr_address_internal : STD_LOGIC_VECTOR (19 DOWNTO 0) := (others => '0');
    FILE memory_contents_file : TEXT OPEN read_mode IS "epc_lane0.dat";  
    variable Marc_Gaucherons_Memory_Variable : mem_array; -- MG
    
    begin
   -- need an initialization process
   -- this process initializes the whole memory array from a named file by copying the
   -- contents of the *.dat file to the memory array.

   -- find the @<address> thingy to load the memory from this point 
IF(NOT mem_init) THEN
   WHILE NOT(endfile(memory_contents_file)) LOOP

      readline(memory_contents_file, data_line);
      line_length := data_line'LENGTH;


      WHILE line_length > 0 LOOP
         read(data_line, the_character_from_data_line);

	       -- check for the @ character indicating a new address wad
 	       -- if not found, we're either still reading the new address _or_loading data
         IF '@' = the_character_from_data_line AND NOT b_munging_address THEN
  	    b_munging_address := TRUE;
            b_found_new_val := TRUE; 
	    -- get the rest of characters before white space and then convert them
	    -- to a number
	 ELSE 

            IF (' ' = the_character_from_data_line AND b_found_new_val) 
		OR (line_length = 1) THEN
               b_convert := TRUE;
	    END IF;

            IF NOT(' ' = the_character_from_data_line) THEN
               string_index := string_index + 1;
               found_string_array(string_index) := the_character_from_data_line;
--               IF NOT(b_munging_address) THEN
--                 dat_string_array(string_index) := the_character_from_data_line;
--               END IF;
	       b_found_new_val := TRUE;
            END IF;
	 END IF;

     IF b_convert THEN

       IF b_munging_address THEN
          converted_number := convert_string_to_number(found_string_array, string_index);    
          load_address := converted_number;
          mem_index := load_address;
--          mem_index := load_address / 1;
          b_munging_address := FALSE;
       ELSE
	  IF (mem_index < 1048576) THEN
	    Marc_Gaucherons_Memory_Variable(mem_index) := convert_string_to_std_logic(found_string_array, string_index, 8);
            mem_index := mem_index + 1;
          END IF;
       END IF; 
       b_convert := FALSE;
       b_found_new_val := FALSE;
       string_index := 0;
    END IF;
    line_length := line_length - 1; 
    END LOOP;

END LOOP;
-- get the first _real_ block of data, sized to our memory width
-- and keep on loading.
  mem_init := TRUE;
END IF;
-- END OF READMEM



      -- Write data
      if wrclock'event and wrclock = '1' then
        wr_address_internal := wraddress;
        if wren = '1' then 
          Marc_Gaucherons_Memory_Variable(CONV_INTEGER(UNSIGNED(wr_address_internal))) := data;
        end if;
      end if;

      -- read data
      q <= Marc_Gaucherons_Memory_Variable(CONV_INTEGER(UNSIGNED(rdaddress)));
      


    end process;
end europa;

--synthesis translate_on


--synthesis read_comments_as_HDL on
--library altera_vhdl_support;
--use altera_vhdl_support.altera_vhdl_support_lib.all;
--
--library ieee;
--use ieee.std_logic_1164.all;
--use ieee.std_logic_arith.all;
--use ieee.std_logic_unsigned.all;
--
--library std;
--use std.textio.all;
--
--entity epc_lane0_module is 
--        port (
--              
--                 signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
--                 signal rdaddress : IN STD_LOGIC_VECTOR (19 DOWNTO 0);
--                 signal rdclken : IN STD_LOGIC;
--                 signal wraddress : IN STD_LOGIC_VECTOR (19 DOWNTO 0);
--                 signal wrclock : IN STD_LOGIC;
--                 signal wren : IN STD_LOGIC;
--
--              
--                 signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
--              );
--end entity epc_lane0_module;
--
--
--architecture europa of epc_lane0_module is
--  component lpm_ram_dp is
--GENERIC (
--      lpm_file : STRING;
--        lpm_hint : STRING;
--        lpm_indata : STRING;
--        lpm_outdata : STRING;
--        lpm_rdaddress_control : STRING;
--        lpm_width : NATURAL;
--        lpm_widthad : NATURAL;
--        lpm_wraddress_control : STRING;
--        suppress_memory_conversion_warnings : STRING
--      );
--    PORT (
--    signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
--        signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
--        signal wraddress : IN STD_LOGIC_VECTOR (19 DOWNTO 0);
--        signal wrclock : IN STD_LOGIC;
--        signal rdaddress : IN STD_LOGIC_VECTOR (19 DOWNTO 0);
--        signal rdclken : IN STD_LOGIC;
--        signal wren : IN STD_LOGIC
--      );
--  end component lpm_ram_dp;
--                signal internal_q4 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
--                TYPE mem_array is ARRAY( 1048575 DOWNTO 0) of STD_LOGIC_VECTOR(7 DOWNTO 0);
--                signal memory_has_been_read :  STD_LOGIC;
--                signal read_address :  STD_LOGIC_VECTOR (19 DOWNTO 0);
--
--begin
--
--  process (rdaddress)
--  begin
--      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
--        read_address <= rdaddress;
--      end if;
--
--  end process;
--
--  lpm_ram_dp_component : lpm_ram_dp
--    generic map(
--      lpm_file => "epc_lane0.mif",
--      lpm_hint => "USE_EAB=ON",
--      lpm_indata => "REGISTERED",
--      lpm_outdata => "UNREGISTERED",
--      lpm_rdaddress_control => "UNREGISTERED",
--      lpm_width => 8,
--      lpm_widthad => 20,
--      lpm_wraddress_control => "REGISTERED",
--      suppress_memory_conversion_warnings => "ON"
--    )
--    port map(
--            data => data,
--            q => internal_q4,
--            rdaddress => read_address,
--            rdclken => rdclken,
--            wraddress => wraddress,
--            wrclock => wrclock,
--            wren => wren
--    );
--
--  
--  q <= internal_q4;
--end europa;
--
--synthesis read_comments_as_HDL off

--synthesis translate_off

library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library std;
use std.textio.all;

entity epc_lane1_module is 
        port (
              -- inputs:
                 signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal rdaddress : IN STD_LOGIC_VECTOR (19 DOWNTO 0);
                 signal rdclken : IN STD_LOGIC;
                 signal wraddress : IN STD_LOGIC_VECTOR (19 DOWNTO 0);
                 signal wrclock : IN STD_LOGIC;
                 signal wren : IN STD_LOGIC;

              -- outputs:
                 signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
              );
end entity epc_lane1_module;


architecture europa of epc_lane1_module is
              signal internal_q5 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
              TYPE mem_array is ARRAY( 1048575 DOWNTO 0) of STD_LOGIC_VECTOR(7 DOWNTO 0);
              signal memory_has_been_read :  STD_LOGIC;
              signal read_address :  STD_LOGIC_VECTOR (19 DOWNTO 0);

      
FUNCTION convert_string_to_number(string_to_convert : STRING;
      final_char_index : NATURAL := 0)
RETURN NATURAL IS
   VARIABLE result: NATURAL := 0;
   VARIABLE current_index : NATURAL := 1;
   VARIABLE the_char : CHARACTER;

   BEGIN
      IF final_char_index = 0 THEN
         result := 0;
	 ELSE
         WHILE current_index <= final_char_index LOOP
            the_char := string_to_convert(current_index);
            IF    '0' <= the_char AND the_char <= '9' THEN
               result := result * 16 + character'pos(the_char) - character'pos('0');
            ELSIF 'A' <= the_char AND the_char <= 'F' THEN
               result := result * 16 + character'pos(the_char) - character'pos('A') + 10;
            ELSIF 'a' <= the_char AND the_char <= 'f' THEN
               result := result * 16 + character'pos(the_char) - character'pos('a') + 10;
            ELSE
               report "Ack, a formatting error!";
            END IF;
            current_index := current_index + 1;
         END LOOP;
      END IF; 
   RETURN result;
END convert_string_to_number;

 FUNCTION convert_string_to_std_logic(value : STRING; num_chars : INTEGER; mem_width_bits : INTEGER)
 RETURN STD_LOGIC_VECTOR is			   
     VARIABLE conv_string: std_logic_vector((mem_width_bits + 4)-1 downto 0);
     VARIABLE result : std_logic_vector((mem_width_bits -1) downto 0);
     VARIABLE curr_char : integer;
              
     BEGIN
     result := (others => '0');
     conv_string := (others => '0');
     
          FOR I IN 1 TO num_chars LOOP
	     curr_char := num_chars - (I-1);

             CASE value(I) IS
               WHEN '0' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0000";
               WHEN '1' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0001";
               WHEN '2' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0010";
               WHEN '3' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0011";
               WHEN '4' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0100";
               WHEN '5' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0101";
               WHEN '6' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0110";
               WHEN '7' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0111";
               WHEN '8' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1000";
               WHEN '9' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1001";
               WHEN 'A' | 'a' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1010";
               WHEN 'B' | 'b' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1011";
               WHEN 'C' | 'c' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1100";
               WHEN 'D' | 'd' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1101";
               WHEN 'E' | 'e' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1110";
               WHEN 'F' | 'f' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1111";
               WHEN 'X' | 'x' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "XXXX";
               WHEN ' ' => EXIT;
               WHEN HT  => exit;
               WHEN others =>
                  ASSERT False
                  REPORT "function From_Hex: string """ & value & """ contains non-hex character"
                       severity Error;
                  EXIT;
               END case;
            END loop;

          -- convert back to normal bit size
          result(mem_width_bits - 1 downto 0) := conv_string(mem_width_bits - 1 downto 0);

          RETURN result;
        END convert_string_to_std_logic;



begin
   process (wrclock, rdaddress) -- MG
    VARIABLE data_line : LINE;
    VARIABLE the_character_from_data_line : CHARACTER;
    VARIABLE b_munging_address : BOOLEAN := FALSE;
    VARIABLE converted_number : NATURAL := 0;
    VARIABLE found_string_array : STRING(1 TO 128);
    VARIABLE string_index : NATURAL := 0;
    VARIABLE line_length : NATURAL := 0;
    VARIABLE b_convert : BOOLEAN := FALSE;
    VARIABLE b_found_new_val : BOOLEAN := FALSE;
    VARIABLE load_address : NATURAL := 0;
    VARIABLE mem_index : NATURAL := 0;
    VARIABLE mem_init : BOOLEAN := FALSE;
    
    VARIABLE wr_address_internal : STD_LOGIC_VECTOR (19 DOWNTO 0) := (others => '0');
    FILE memory_contents_file : TEXT OPEN read_mode IS "epc_lane1.dat";  
    variable Marc_Gaucherons_Memory_Variable : mem_array; -- MG
    
    begin
   -- need an initialization process
   -- this process initializes the whole memory array from a named file by copying the
   -- contents of the *.dat file to the memory array.

   -- find the @<address> thingy to load the memory from this point 
IF(NOT mem_init) THEN
   WHILE NOT(endfile(memory_contents_file)) LOOP

      readline(memory_contents_file, data_line);
      line_length := data_line'LENGTH;


      WHILE line_length > 0 LOOP
         read(data_line, the_character_from_data_line);

	       -- check for the @ character indicating a new address wad
 	       -- if not found, we're either still reading the new address _or_loading data
         IF '@' = the_character_from_data_line AND NOT b_munging_address THEN
  	    b_munging_address := TRUE;
            b_found_new_val := TRUE; 
	    -- get the rest of characters before white space and then convert them
	    -- to a number
	 ELSE 

            IF (' ' = the_character_from_data_line AND b_found_new_val) 
		OR (line_length = 1) THEN
               b_convert := TRUE;
	    END IF;

            IF NOT(' ' = the_character_from_data_line) THEN
               string_index := string_index + 1;
               found_string_array(string_index) := the_character_from_data_line;
--               IF NOT(b_munging_address) THEN
--                 dat_string_array(string_index) := the_character_from_data_line;
--               END IF;
	       b_found_new_val := TRUE;
            END IF;
	 END IF;

     IF b_convert THEN

       IF b_munging_address THEN
          converted_number := convert_string_to_number(found_string_array, string_index);    
          load_address := converted_number;
          mem_index := load_address;
--          mem_index := load_address / 1;
          b_munging_address := FALSE;
       ELSE
	  IF (mem_index < 1048576) THEN
	    Marc_Gaucherons_Memory_Variable(mem_index) := convert_string_to_std_logic(found_string_array, string_index, 8);
            mem_index := mem_index + 1;
          END IF;
       END IF; 
       b_convert := FALSE;
       b_found_new_val := FALSE;
       string_index := 0;
    END IF;
    line_length := line_length - 1; 
    END LOOP;

END LOOP;
-- get the first _real_ block of data, sized to our memory width
-- and keep on loading.
  mem_init := TRUE;
END IF;
-- END OF READMEM



      -- Write data
      if wrclock'event and wrclock = '1' then
        wr_address_internal := wraddress;
        if wren = '1' then 
          Marc_Gaucherons_Memory_Variable(CONV_INTEGER(UNSIGNED(wr_address_internal))) := data;
        end if;
      end if;

      -- read data
      q <= Marc_Gaucherons_Memory_Variable(CONV_INTEGER(UNSIGNED(rdaddress)));
      


    end process;
end europa;

--synthesis translate_on


--synthesis read_comments_as_HDL on
--library altera_vhdl_support;
--use altera_vhdl_support.altera_vhdl_support_lib.all;
--
--library ieee;
--use ieee.std_logic_1164.all;
--use ieee.std_logic_arith.all;
--use ieee.std_logic_unsigned.all;
--
--library std;
--use std.textio.all;
--
--entity epc_lane1_module is 
--        port (
--              
--                 signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
--                 signal rdaddress : IN STD_LOGIC_VECTOR (19 DOWNTO 0);
--                 signal rdclken : IN STD_LOGIC;
--                 signal wraddress : IN STD_LOGIC_VECTOR (19 DOWNTO 0);
--                 signal wrclock : IN STD_LOGIC;
--                 signal wren : IN STD_LOGIC;
--
--              
--                 signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
--              );
--end entity epc_lane1_module;
--
--
--architecture europa of epc_lane1_module is
--  component lpm_ram_dp is
--GENERIC (
--      lpm_file : STRING;
--        lpm_hint : STRING;
--        lpm_indata : STRING;
--        lpm_outdata : STRING;
--        lpm_rdaddress_control : STRING;
--        lpm_width : NATURAL;
--        lpm_widthad : NATURAL;
--        lpm_wraddress_control : STRING;
--        suppress_memory_conversion_warnings : STRING
--      );
--    PORT (
--    signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
--        signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
--        signal wraddress : IN STD_LOGIC_VECTOR (19 DOWNTO 0);
--        signal wrclock : IN STD_LOGIC;
--        signal rdaddress : IN STD_LOGIC_VECTOR (19 DOWNTO 0);
--        signal rdclken : IN STD_LOGIC;
--        signal wren : IN STD_LOGIC
--      );
--  end component lpm_ram_dp;
--                signal internal_q5 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
--                TYPE mem_array is ARRAY( 1048575 DOWNTO 0) of STD_LOGIC_VECTOR(7 DOWNTO 0);
--                signal memory_has_been_read :  STD_LOGIC;
--                signal read_address :  STD_LOGIC_VECTOR (19 DOWNTO 0);
--
--begin
--
--  process (rdaddress)
--  begin
--      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
--        read_address <= rdaddress;
--      end if;
--
--  end process;
--
--  lpm_ram_dp_component : lpm_ram_dp
--    generic map(
--      lpm_file => "epc_lane1.mif",
--      lpm_hint => "USE_EAB=ON",
--      lpm_indata => "REGISTERED",
--      lpm_outdata => "UNREGISTERED",
--      lpm_rdaddress_control => "UNREGISTERED",
--      lpm_width => 8,
--      lpm_widthad => 20,
--      lpm_wraddress_control => "REGISTERED",
--      suppress_memory_conversion_warnings => "ON"
--    )
--    port map(
--            data => data,
--            q => internal_q5,
--            rdaddress => read_address,
--            rdclken => rdclken,
--            wraddress => wraddress,
--            wrclock => wrclock,
--            wren => wren
--    );
--
--  
--  q <= internal_q5;
--end europa;
--
--synthesis read_comments_as_HDL off

library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity epc is 
        port (
              -- inputs:
                 signal address : IN STD_LOGIC_VECTOR (19 DOWNTO 0);
                 signal read_n : IN STD_LOGIC;
                 signal select_n : IN STD_LOGIC;
                 signal write_n : IN STD_LOGIC;

              -- outputs:
                 signal data : INOUT STD_LOGIC_VECTOR (15 DOWNTO 0)
              );
end entity epc;


architecture europa of epc is
--synthesis translate_off
component epc_lane0_module is 
           port (
                 -- inputs:
                    signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal rdaddress : IN STD_LOGIC_VECTOR (19 DOWNTO 0);
                    signal rdclken : IN STD_LOGIC;
                    signal wraddress : IN STD_LOGIC_VECTOR (19 DOWNTO 0);
                    signal wrclock : IN STD_LOGIC;
                    signal wren : IN STD_LOGIC;

                 -- outputs:
                    signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
                 );
end component epc_lane0_module;

component epc_lane1_module is 
           port (
                 -- inputs:
                    signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal rdaddress : IN STD_LOGIC_VECTOR (19 DOWNTO 0);
                    signal rdclken : IN STD_LOGIC;
                    signal wraddress : IN STD_LOGIC_VECTOR (19 DOWNTO 0);
                    signal wrclock : IN STD_LOGIC;
                    signal wren : IN STD_LOGIC;

                 -- outputs:
                    signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
                 );
end component epc_lane1_module;

--synthesis translate_on
                signal data_0 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal data_1 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal logic_vector_gasket :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal module_input10 :  STD_LOGIC;
                signal module_input11 :  STD_LOGIC;
                signal module_input12 :  STD_LOGIC;
                signal module_input13 :  STD_LOGIC;
                signal q_0 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal q_1 :  STD_LOGIC_VECTOR (7 DOWNTO 0);

begin

  --s1, which is an e_ptf_slave
--synthesis translate_off
    logic_vector_gasket <= data;
    data_0 <= logic_vector_gasket(7 DOWNTO 0);
    --epc_lane0, which is an e_ram
    epc_lane0 : epc_lane0_module
      port map(
        q => q_0,
        data => data_0,
        rdaddress => address,
        rdclken => module_input10,
        wraddress => address,
        wrclock => write_n,
        wren => module_input11
      );

    module_input10 <= std_logic'('1');
    module_input11 <= NOT select_n;

    data_1 <= logic_vector_gasket(15 DOWNTO 8);
    --epc_lane1, which is an e_ram
    epc_lane1 : epc_lane1_module
      port map(
        q => q_1,
        data => data_1,
        rdaddress => address,
        rdclken => module_input12,
        wraddress => address,
        wrclock => write_n,
        wren => module_input13
      );

    module_input12 <= std_logic'('1');
    module_input13 <= NOT select_n;

    data <= A_WE_StdLogicVector((std_logic'(((NOT select_n AND NOT read_n))) = '1'), (q_1 & q_0), A_REP(std_logic'('Z'), 16));
--synthesis translate_on

end europa;


--synthesis translate_off

library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;



-- <ALTERA_NOTE> CODE INSERTED BETWEEN HERE
--add your libraries here
-- AND HERE WILL BE PRESERVED </ALTERA_NOTE>

entity test_bench is 
end entity test_bench;


architecture europa of test_bench is
component nios is 
           port (
                 -- 1) global signals:
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- the_J23_SW
                    signal in_port_to_the_J23_SW : IN STD_LOGIC;

                 -- the_dev_uart
                    signal rxd_to_the_dev_uart : IN STD_LOGIC;
                    signal txd_from_the_dev_uart : OUT STD_LOGIC;

                 -- the_test_0_test
                    signal addr_to_the_test_0 : OUT STD_LOGIC_VECTOR (5 DOWNTO 0);
                    signal cs_to_the_test_0 : OUT STD_LOGIC;
                    signal readdata_from_the_test_0 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal wreq_from_the_test_0 : IN STD_LOGIC;
                    signal write_n_to_the_test_0 : OUT STD_LOGIC;
                    signal writedata_to_the_test_0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);

                 -- the_tri_state_bridge_avalon_slave
                    signal be_n_to_the_SRAM : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal read_n_to_the_SRAM : OUT STD_LOGIC;
                    signal select0_n_to_the_SRAM : OUT STD_LOGIC;
                    signal select1_n_to_the_SRAM : OUT STD_LOGIC;
                    signal select_n_to_the_epc : OUT STD_LOGIC;
                    signal tri_state_bridge_address : OUT STD_LOGIC_VECTOR (20 DOWNTO 0);
                    signal tri_state_bridge_data : INOUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal tri_state_bridge_readn : OUT STD_LOGIC;
                    signal write_n_to_the_SRAM : OUT STD_LOGIC;
                    signal write_n_to_the_epc : OUT STD_LOGIC
                 );
end component nios;

component SRAM is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                    signal be_n : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal read_n : IN STD_LOGIC;
                    signal select0_n : IN STD_LOGIC;
                    signal select1_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;

                 -- outputs:
                    signal data : INOUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component SRAM;

component epc is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (19 DOWNTO 0);
                    signal read_n : IN STD_LOGIC;
                    signal select_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;

                 -- outputs:
                    signal data : INOUT STD_LOGIC_VECTOR (15 DOWNTO 0)
                 );
end component epc;

                signal addr_to_the_test_0 :  STD_LOGIC_VECTOR (5 DOWNTO 0);
                signal be_n_to_the_SRAM :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal clk :  STD_LOGIC;
                signal cs_to_the_test_0 :  STD_LOGIC;
                signal dev_uart_s1_dataavailable_from_sa :  STD_LOGIC;
                signal dev_uart_s1_readyfordata_from_sa :  STD_LOGIC;
                signal in_port_to_the_J23_SW :  STD_LOGIC;
                signal module_input14 :  STD_LOGIC_VECTOR (19 DOWNTO 0);
                signal module_input9 :  STD_LOGIC_VECTOR (17 DOWNTO 0);
                signal read_n_to_the_SRAM :  STD_LOGIC;
                signal readdata_from_the_test_0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal reset_n :  STD_LOGIC;
                signal rxd_to_the_dev_uart :  STD_LOGIC;
                signal select0_n_to_the_SRAM :  STD_LOGIC;
                signal select1_n_to_the_SRAM :  STD_LOGIC;
                signal select_n_to_the_epc :  STD_LOGIC;
                signal tri_state_bridge_address :  STD_LOGIC_VECTOR (20 DOWNTO 0);
                signal tri_state_bridge_data :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal tri_state_bridge_readn :  STD_LOGIC;
                signal txd_from_the_dev_uart :  STD_LOGIC;
                signal wreq_from_the_test_0 :  STD_LOGIC;
                signal write_n_to_the_SRAM :  STD_LOGIC;
                signal write_n_to_the_epc :  STD_LOGIC;
                signal write_n_to_the_test_0 :  STD_LOGIC;
                signal writedata_to_the_test_0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);


-- <ALTERA_NOTE> CODE INSERTED BETWEEN HERE
--add your component and signal declaration here
-- AND HERE WILL BE PRESERVED </ALTERA_NOTE>


begin

  --Set us up the Dut
  DUT : nios
    port map(
      addr_to_the_test_0 => addr_to_the_test_0,
      be_n_to_the_SRAM => be_n_to_the_SRAM,
      cs_to_the_test_0 => cs_to_the_test_0,
      read_n_to_the_SRAM => read_n_to_the_SRAM,
      select0_n_to_the_SRAM => select0_n_to_the_SRAM,
      select1_n_to_the_SRAM => select1_n_to_the_SRAM,
      select_n_to_the_epc => select_n_to_the_epc,
      tri_state_bridge_address => tri_state_bridge_address,
      tri_state_bridge_data => tri_state_bridge_data,
      tri_state_bridge_readn => tri_state_bridge_readn,
      txd_from_the_dev_uart => txd_from_the_dev_uart,
      write_n_to_the_SRAM => write_n_to_the_SRAM,
      write_n_to_the_epc => write_n_to_the_epc,
      write_n_to_the_test_0 => write_n_to_the_test_0,
      writedata_to_the_test_0 => writedata_to_the_test_0,
      clk => clk,
      in_port_to_the_J23_SW => in_port_to_the_J23_SW,
      readdata_from_the_test_0 => readdata_from_the_test_0,
      reset_n => reset_n,
      rxd_to_the_dev_uart => rxd_to_the_dev_uart,
      wreq_from_the_test_0 => wreq_from_the_test_0
    );


  --the_SRAM, which is an e_ptf_instance
  the_SRAM : SRAM
    port map(
      data => tri_state_bridge_data,
      address => module_input9,
      be_n => be_n_to_the_SRAM,
      read_n => read_n_to_the_SRAM,
      select0_n => select0_n_to_the_SRAM,
      select1_n => select1_n_to_the_SRAM,
      write_n => write_n_to_the_SRAM
    );

  module_input9 <= tri_state_bridge_address(19 DOWNTO 2);

  --the_epc, which is an e_ptf_instance
  the_epc : epc
    port map(
      data => tri_state_bridge_data (15 DOWNTO 0),
      address => module_input14,
      read_n => tri_state_bridge_readn,
      select_n => select_n_to_the_epc,
      write_n => write_n_to_the_epc
    );

  module_input14 <= tri_state_bridge_address(20 DOWNTO 1);

  process
  begin
    clk <= '0';
    loop
       if (clk = '1') then
          wait for 7 ns;
          clk <= not clk;
       else
          wait for 8 ns;
          clk <= not clk;
       end if;
    end loop;
  end process;
  PROCESS
    BEGIN
       reset_n <= '0';
       wait for 155 ns;
       reset_n <= '1'; 
    WAIT;
  END PROCESS;


-- <ALTERA_NOTE> CODE INSERTED BETWEEN HERE
--add additional architecture here
-- AND HERE WILL BE PRESERVED </ALTERA_NOTE>


end europa;



--synthesis translate_on
