library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;




--this model is similar to the top level model in xilinx.
--by replace the avalon bus with xilinx port.
entity test is
port(
		fifo_read_REQ			: out  STD_LOGIC ;-- read request
		fifo_read_ready			: in  STD_LOGIC ;-- read request
		fifo_data			: INout	STD_LOGIC_VECTOR(19 downto 0) ;-- the data I.E. the address of cluster center
		fifo_addr			: INout	STD_LOGIC_VECTOR(5 downto 0) ;-- the data I.E. the address of cluster center

	trg_come 		: out std_logic;
	out_reset_n 		: out std_logic;
	out_clock 		: out std_logic;


	ava_clk : in std_logic ;
	ava_cs : in std_logic ;

	ava_wdata : in std_logic_vector(31 downto 0) ;
	ava_rdata : out std_logic_vector(31 downto 0) ;
	
	ava_write_n : in std_logic ;
	ava_addr : in std_logic_vector(5 downto 0) 
		
		


);

end test;

architecture arch_test of test is
--cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
component chinhvu 
	PORT
	(
		RESET_n			: IN STD_LOGIC ;	-- push button RESET, on PIN
				
		fifo_CLK				: IN  STD_LOGIC ;	-- local copy of the chinhvu clock, 25 MHz
		fifo_read_REQ			: out  STD_LOGIC ;-- read request
		fifo_read_ready			: in  STD_LOGIC ;-- read request
		fifo_data			: INout	STD_LOGIC_VECTOR(19 downto 0) ;-- the data I.E. the address of cluster center
		fifo_addr			: INout	STD_LOGIC_VECTOR(5 downto 0) ;-- the data I.E. the address of cluster center

		
		-- avalon/nios interface
		ava_cs			: in std_logic ;
		ava_clk			: in std_logic ;
		ava_write_n		: in std_logic ;
		ava_wreq		: out std_logic ;
		
		ava_addr		: in std_logic_vector(5 downto 0) ;
		ava_rdata		: out std_logic_vector(31 downto 0) ;
		ava_wdata		: in std_logic_vector(31 downto 0) 
				

	);
END component;

--cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
signal	system_clk 		:  std_logic:='0';
signal	reset_n 		:  std_logic:='1';
signal	ava_wreq 		:  std_logic;







-- for clusterfifos


begin

----new 

--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss		

--wwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwire
system_clk<=  ava_clk ;
out_clock<=ava_clk;
--start(0)<=	ava_addr(0)  and ava_cs;
--reset_n<=not (ava_addr(2)  and ava_cs);
--got_clustert<=ava_addr(3)  and ava_cs;
--rdreq<=		ava_addr(4)  and ava_cs;
--		ava_rdata<= "000000000000" & data_outt;
--			data_int<= ava_wdata(17 downto 0) ;

trg_come<='1' when	ava_addr="001000"  and ava_cs='1' else
          '0';
--start(1)<=	ava_addr(1)  and ava_cs;
--start(2)<=	ava_addr(5)  and ava_cs;
reset_n<='0' when	ava_addr="100000"  and ava_cs='1' else
         '1';
out_reset_n<=reset_n;
--not (ava_addr(5)  and ava_cs);
--write_addr<=ava_addr(3)  and ava_cs;
--rdreq<=		ava_addr(4)  and ava_cs;
		--fifo_addr<=ava_wdata(5 downto 0) when write_addr='1' ;
--	ava_rdata<= "000000000000" & data_out;

---------------------------------------------------------------------------
--process (system_clk,ava_addr)
--begin
--if ava_cs='1' then
--	if system_clk='1' and system_clk'event  then
--		if got_cluster='1' and read_req='0' then
--		data_in<= ava_wdata(19 downto 0);
--		end if;
--		if got_cluster='0' and read_req='1' then
--		ava_rdata<= "000000000000" & data_out;
--		end if;
--	end if;
--end if;
--end process;

---------------------------------------------------------------------------

--uuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuu

chinhvu_i: chinhvu 
	PORT map
	(
	reset_n=>reset_n,
		fifo_CLK=>system_clk,
		fifo_read_REQ=>fifo_read_REQ,
		fifo_read_ready=>fifo_read_ready,
		fifo_data=>fifo_data,
		fifo_addr=>fifo_addr,-- the data I.E. the address of cluster center

		
		-- avalon/nios interface
		ava_cs=>ava_cs,
		ava_clk=>ava_clk,
		ava_write_n	=>ava_write_n,
		ava_wreq=>ava_wreq,
		
		ava_addr=>ava_addr,
		ava_rdata=>ava_rdata,
		ava_wdata=>ava_wdata
				

	);
--uuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuu		
end arch_test;
